<?php
/*
	qmd-cms 0.8.7 - general settings

	last update: 05/06/2014
	
These are general settings for qmd-CMS
and constants regulating the behaviour.

You may overwrite these settings in your .scheme/myScheme/index.php
or any other file you are using in order to reflect different designs with one site.

there are restricions on making changes here - see notes for each entry!!
*/

//DO NOT change these values unless you have written consent by ***hy

define('__y_qmd_cms_version','0.8.7 alpha');
define('__y_qmd_cms_release','0337');	//hg REVISION
//-----------------------------------------------------------------------------


include_once('../GLOBALS/qmd_app_config.php');//make your changes here!!!
//if this file doesn't exist copy ../GLOBALS/qmd_app_config_template.php -> ../GLOBALS/qmd_app_config.php
//AND ENTER YOUR CREDENTIALS there
// ****************************************************************************
//
//	Note that all SYSTEMCONSTANTS are preceded by "__y_"
//	Do not change them unless you know what you are doing.
//	
//	
//-----------------------------------------------------------------------------

//	The DEFAULT LANGUAGE for the site is stored in the settings table of the DATABASE
//	If a user has chosen to use the SITE in Language 'jp' and the selected
//	article is not available in japanese she will be shown the article in 
//	the language defined in the settings table.
//

//this is the name of the logfile to be used. It resides in www/ if no other path is chosen
//if you are using logging, please check the rights to write to that file otherwise the program will crash
define ('debug_log_file_name','qmd.log');	//alter this one if you wish to ...

/* RIGHTS
for example with the name above

#echo foo > www/qmd.log
chown $user:www-data www/qmd.log
chmod g+w www/qmd.log
*/


//GLOBALS:
//debuglogfile: is by default only used in local test mode
$__y_debuglogfile=NULL;

$__y_debuglog_is_open=0;//this will be set to 1 after initializing debug

//The lzvPrefix is for internal usage of my own testing
global $lzvPrefix;


$qEOT_pattern='(\.|\!|\?|\:|\<br/\>|\<br \/\>)';
/*Automatically detect the scripts location. Don't make any changes here - will be used for creating (global) links
	$host = 'http://'.$_SERVER['HTTP_HOST'];
	$directory = dirname($_SERVER['SCRIPT_NAME']);
	$website = $directory == '/' ? $host.'/' : $host.$directory.'/';
*/
$website=$_SERVER['REQUEST_SCHEME'].'://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'];
$chkParseURL=parse_url($website);
if ($chkParseURL==FALSE):
	die('Error on server-configuration');//we don't have qmd_die loaded so we just crash here
else:												//and there is no reason why this shouldn't work... but we catch it anyway.
	$site=$chkParseURL['host'];
endif;
//this loooks stupid but I really had this on a live server - so it's req'd!!!
if (empty($site)):
	define('_SITE',$_SERVER['SERVER_NAME']);
else:
	define('_SITE',$site);	
endif;

define('__y_dtformat','Y/m/d H:i:s');//this is the system format for internal usage of Datetime
												//the dates that are diplayed on the website are formatted with:
												//s('date_format')

/*	NOW we check if we're in test mode. 
	The TLD 'test' is usually only available on your local machine.
	Edit your hosts-file according to the name chosen!!!
*/

$iPos=strpos(_SITE,".test");
/* if iPos is the last part, you are in test-mode note we don't check here if it is really the last part.
	But imagine the options for NOT being the last part... The only option that this works NOT is a live
	website that is named:
		www.test.TLD
	I guess s.o. owning the domains in questions is using another cms...
	[Well, test.com is  V E R Y  slow - they sure need a new cms (-:]
*/

if ($iPos !==FALSE):
	define("__y_local_test",1);	//testing with DEBUG
	//the next one is to be changed
	define('__y_DEBUG',3);	//set to 10 for full debug mode
									//2 for log into qmd.log
									//3 for default msgboxes in order 2 DEBUG
									//higher values will output more data/information
									//do not set this to anything but 0 in live mode
else:
	//Live-Mode Controls
	define("__y_local_test",0);

	//the next is not recommended to be changed in Live Mode see abv.
	define('__y_DEBUG',0);	
endif;

//define("__y_DEBUG",1);	//uncomment this line if you require to debug a live website anyway...
									//do it with caution and don't forget to comment it after testing is finished.
									//NOTE: you need write access to qmd.log in www/!


//these are constants for using the css - stuff.
//It is not fully implemented and I lack the time to do it ATM.
	$qmd_categoryHead='qmd_categoryHead';
	$qmd_categoryCurrent='qmd_categoryCurrent';
	$qmd_categoryItem='qmd_categoryItem';
	$qmd_categoryUL='qmd_categoryUL';
	
//Don't make changes here - also for controllerMode of qmdC
	$qmd_const_URL_Params=Array();
	$qmd_const_URL_Params[0]='menu';//we are coming from a menu
	$qmd_const_URL_Params[1]='cat';//we are coming from a (sub-)category
	$qmd_const_URL_Params[2]='administration';//we are in admin mode 
	$qmd_const_URL_Params[3]='login';//login
	$qmd_const_URL_Params[4]='logoff';	//logoout
	$qmd_const_URL_Params[5]='moderation';	//moderation is not implemented
	$qmd_const_URL_Params[6]='user';	//user is not implemented
	
	
//Language constants
	$qmd_Lang_ANY = '@ANY';//this is a marker that an article is not maintained for each language
									//but one article for all languages
									//we could put this into the list of available languages
									
	$qmd_Lang_ALL = '@ALL';//this is a parameter on deleting articles if set the artoicle will be 
									//deleted completely = all languages 
	
//	Don't make changes here

	$ra1 = array('applet', 'body', 'bgsound', 'base', 'basefont', 'embed', 'frame', 'frameset', 'head', 'html',
             'id', 'iframe', 'ilayer', 'layer', 'link', 'meta', 'name', 'object', 'script', 'style', 'title', 'xml');
	$ra2 = array('javascript', 'vbscript', 'expression', 'applet', 'meta', 'xml', 'blink', 'link', 'style', 'script',
            'embed', 'object', 'iframe', 'frame', 'frameset', 'ilayer', 'layer', 'bgsound', 'title', 'base',
            'onabort', 'onactivate', 'onafterprint', 'onafterupdate', 'onbeforeactivate', 'onbeforecopy',
            'onbeforecut', 'onbeforedeactivate', 'onbeforeeditfocus', 'onbeforepaste', 'onbeforeprint',
            'onbeforeunload', 'onbeforeupdate', 'onblur', 'onbounce', 'oncellchange', 'onchange', 'onclick',
            'oncontextmenu', 'oncontrolselect', 'oncopy', 'oncut', 'ondataavailable', 'ondatasetchanged',
            'ondatasetcomplete', 'ondblclick', 'ondeactivate', 'ondrag', 'ondragend', 'ondragenter', 'ondragleave',
            'ondragover', 'ondragstart', 'ondrop', 'onerror', 'onerrorupdate', 'onfilterchange', 'onfinish', 'onfocus',
            'onfocusin', 'onfocusout', 'onhelp', 'onkeydown', 'onkeypress', 'onkeyup', 'onlayoutcomplete', 'onload',
            'onlosecapture', 'onmousedown', 'onmouseenter', 'onmouseleave', 'onmousemove', 'onmouseout', 'onmouseover',
            'onmouseup', 'onmousewheel', 'onmove', 'onmoveend', 'onmovestart', 'onpaste', 'onpropertychange',
            'onreadystatechange', 'onreset', 'onresize', 'onresizeend', 'onresizestart', 'onrowenter', 'onrowexit',
            'onrowsdelete', 'onrowsinserted', 'onscroll', 'onselect', 'onselectionchange', 'onselectstart', 'onstart',
            'onstop', 'onsubmit', 'onunload');
	$tagBlacklist = array_merge($ra1, $ra2);
	
	//the following should be all lowercase
	$stickySessionVars=array(_SITE.'/poster/','dbsection','article_save',_SITE.'/mathcaptcha-digit-x',_SITE.'/mathcaptcha-digit-y',_SITE.'/time',_SITE.'/return2','$post');

//don't make changes here - these are modes for articles
define('__visible',1);
define('__showincats',2);
define('__pagemode',4);
define('__fullscreen',8);
define('__default4scheme',16);

//don't make changes here - these are modes for articles
define('__VAC',1);
//define('__',2);
//define('__pagemode',4);
//define('__fullscreen',8);

	define('__USER_isROOT',16);
	define('__USER_isAdmin',8);
	define('__USER_isMod',4);
	define('__USER_is2ndLevel',2);
	define('__USER_isUser',1);
	//-------------------------------------------------------
	//see also the documentation: chapter 3.3 comments
	$__commentModes=array(0,//	comments off
							1,//	comments frozen
							2,	//commentable
							5,	//users can see frozen comments
							6,	//commentable for users only
							7,//show frozen comment / users can comment
							9,//only 2nd Level Users see frozen comments
							10,//only 2nd Level Users can comment
							11//FROZEN but 2nd Level Users can comment
							);
	
//these are the built-in functions with a direct link
	$qmd_sefLink=array();
	$qmd_sefLink[0]='login';
	$qmd_sefLink[1]='logoff';
	$qmd_sefLink[2]='register';
	$qmd_sefLink[3]='sitemap';
	$qmd_sefLink[4]='search';
	$qmd_sefLink[5]='contact';
	$qmd_sefLink[6]='comment';
	$qmd_sefLink[7]='user';
	$qmd_sefLink[8]='activate';
	$qmd_sefLink[9]='choiceProcess';
	$qmd_sefLink[10]='204';//No content /en obras
	$qmd_sefLink[11]='400';//nonexistent link
	$qmd_sefLink[12]='401';//Unauthorized
	$qmd_sefLink[13]='404';//redirect from not existing link
	$qmd_sefLink[14]='userpanel';//
	$qmd_sefLink[15]='user-messages';
	$qmd_sefLink[16]='contactform';
	$qmd_sefLink[17]='qtest';
	$qmd_sefLink[18]='report-comment';
	//IMPORTANT: don't change the above. Don't change the order of the items!
	//If you need more items just append them
	
//these are known loaders
	$qmd_knownLoaders=array();
	$qmd_knownLoaders[0]='qmd_msg_list';
	$qmd_knownLoaders[1]='qmd_msg_list_item';

	//these are globals for messaging... 
	$qmdNOTIFYmsg='';
	$qmdNOTIFY_Albl=null;
	$qmdNOTIFY_Atrg=null;
	$qmdNOTIFY_title='';
	
	//META:
	//this is META-stuff for SEO
	$DCTypeArray=array
					(	'Text',
						'Software',
						'Service',
						'Image',
						'Event',
						'Dataset',
						'Collection',
						'InteractiveResource',
						'PhysicalObject',
						'Sound');
						
	$META_docType=array();
	$META_docType[0]='<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">';
	$META_docType[1]='<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">';
	$META_docType[2]='<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Frameset//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-frameset.dtd">';
	$META_docType[3]='<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">';
	$META_docType[4]='<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">';
	$META_docType[5]='<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Frameset//EN" "http://www.w3.org/TR/html4/frameset.dtd">';
	
	
	$META_docTypeDesc=array();
	$META_docTypeDesc[0]='XHTML 1.0 strict';
	$META_docTypeDesc[1]='XHTML 1.0 Transitional';
	$META_docTypeDesc[2]='XHTML 1.0 Frameset';
	$META_docTypeDesc[3]='HTML 4.01 strict';
	$META_docTypeDesc[4]='HTML 4.01 Transitional';
	$META_docTypeDesc[5]='HTML 4.01 Frameset';

	
/*======================================================================================END of constants---*/

/*	the function db() will return values from the credentials for accessing the DATABASE */
function db($variable)
{
	
	global $_db_localtest;	//defined in qmd_app_config
	global $_db_live_Mode;	//defined in qmd_app_config

	if (__y_local_test==1):
		return $_db_localtest[$variable];
	else:
		return $_db_live_Mode[$variable];
	endif;
}
//EoF	
?>