<?php

/*------------------------------
	Program: qmd-cms [qimanfaya-Menu-Driven-CMS]
	Module: qmd article class
	..............................................
	qmd-cms 0.8.7
	last update: 05/06/2014

	--------------------------------

	qmd_article_class.php
	=====================

	This file is part of the qmd-php-library
	
	Author: ***hy
	For further reference regarding this code see qmdcms.php and the readme-files.
	
	This code was developed by ****hy
	Copyright: qimanfaya/hy-soft 2012,2014
	
	Licence:		GPL V.3

	A copy of the GNU General Public License is available:
	in the root of this folder
	and on the World Wide Web
	at <http://www.gnu.org/licenses/gpl-3.0.txt>. You can also obtain it by writing
	to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
	MA 02111-1307, USA.
	
*/
//there is another class below which is the actual base class for all articles in use:
//qmd_base_article


/*Every article should be run like 
		$A = new $articleType($qmdC,$BaseRec);
		$A->initialization();
		$A->displayArticle();
	
	please don't forget to call 
		parent::displayArticle();
		if you override displayArticle (YOU SHOULD!!!)
		
		you might want to modify/override
		
		+showArticleHead
		+showArticleTeaser
		+showArticleBody
		
		+showArticleComments
		
		NOTE: comments are retrieved from the standard database of qmd-CMS
		so you might disconnect from the DB b4 showing comments, if your 
		article-object has it's data somewhere else.
		
		depending on the class you should also modify the 
		ancestors' properties after calling parent::__construct()
		such as tablefieldnames...
		see 'exc_list.php' in the content-section
		
		for any new class extending the base classes you need an entry in
		qmd_classes.php 
			(F) load_Article_Data
		
*/		
		
	class qmd_custom_article{

		var $_CONTROLLER;
		
		var $_ArticleType;		//this holds the type of an article
										// 0 - undefined - VAC
										// 1 - regular article
										// 2 - list
										//... we could further think of:
										// 3 - blog
										// 4 - forum
										// 5 - image-Gallery
										// 6 - google-earth-module (with tracks)
										// 7 - something yellow
	/*										in order to register a new type of article
											put the appropriate code into (F) register_ArticleType
											
	*/
										
		var $INIT;
		var $ArticleRow;
		var $_jsFile;
		var $_cssFile;
		var $teaserTag;
		var $TeaserMode;		//-2 uninitialized
									//-1 no teaser body empty
									//0  body length < s('default_teaser_length');
									//+1 teaser defined by settings body is cut
									//+2 a real teaser is inserted in the article body
									//+3 body is included!
									//+4 body handles stuff itself (starting with "<p" or "<div")
		var $iCommentsThisLang;
		var $iCommentsOtherLang;
		var $ArticleCommentMode;
		
		function __construct($controller,$BaseRec){
			$this->INIT=0;
			
			$this->_jsFile='';
			$this->_cssFile='';
			
			$this->_CONTROLLER=$controller;
			$this->ArticleRow=$BaseRec;
			$this->TeaserMode=-2;
			$this->teaserTag=-1;
			$this->iCommentsThisLang=-1;//not initialized yet
			$this->iCommentsOtherLang=-1;
			$this->ArticleCommentMode=-2;
		}
		
		function __destruct(){
			if ($this->ArticleRow!=null):
				unset($this->ArticleRow);
			endif;
		}
		/*
		function setArticleRow($DATA)
		{
			$this->ArticleRow=$DATA;
		}
		*/
		function getArticleID($ML=FALSE){	//ML = TRUE delivers the ID of ML table otherwise arcticle/parent
			$result=-1;
			if (!is_null($this->ArticleRow)):
				if (is_array($this->ArticleRow)):
					if ($ML==TRUE):
						if (isset($this->ArticleRow['id'])):
							$result=$this->ArticleRow['id'];
						endif;
					else:
						if (isset($this->ArticleRow['artid'])):
							$result=$this->ArticleRow['artid'];
						endif;
					endif;
				endif;
			endif;
			return $result;	
		}
		function initialization(){
			$this->register_ArticleType();
			//get_ArticleData();
		}
		
		function register_ArticleType()
		{	/*	as a good programming style, please enter your own object types 
				and initialization-code here - even when no code is required
				This one should be called from every derivated object.
				It should be called after the object is filled with sensible data
				in order to implement post-initialization.
				One of the most common post-initialization would be to call it's own 
				css & js-scripts
				So, if you are using some special JavaScript stuff only for one type of
				article - put it here! Same applies to css
				The seftitle should be
				+ unique - so you can distinguish between
				this is already handled by database.
				
				Several articles with different seftitle may share the same initialization.
				
				The default section handles all default objects that are not specified in a
				special manner - i.e. direct descendandt of $this object.
				
				
				
			*/
					/*###################################################################################
					/*###################################################################################
					/*###################################################################################
					/*###################  This is where you put the object-initialization  #############
					/*###################            of your own article-objects            #############
					/*###################################################################################
					/*###################################################################################
					/*###################################################################################
					/*#################################################################################*/
			//$x=;
			if ($this->INIT==0)//prevent double initialization
			{
			
			$this->articleInit();//override this (f) if you need to do some init
			
			switch (get_class($this)):
				case ('message_list'):
					//msgbox('this is ok');
					break;
				case ('message_list_item'):
					break;
				case ('excursions_list_item'):
					//msgbox('INIT excursions_list_item');
					break;
				case ('excursions_list'):
					//msgbox('INIT excursions_list');
					break;
				case ('qmd_custom_article'):
					//msgbox('qmd_custom_article');
					break;
				case ('qmd_base_article'):
					//msgbox('qmd_base_article');
					break;
				case ('qmd_LIST'):
					//msgbox('qmd_LIST');
					break;
					
			endswitch;
			
			/*###################################################################################
			  ###################################################################################
			  ###################################################################################
			  #################################################################################*/
					
			//default initialization:
			$this->Aload_css();
			$this->Aload_js();
			$this->INIT++;
			}//endif 
		}

		function getField($fieldname)
		{
			$result=$this->ArticleRow[$fieldname];
			return $result;
		}
		function displayArticle()
		{
			$result=TRUE;
			
			//OVERRIDE this one in order to recieve sensible results
			return $result;
		}
		function xLoad_css_js($Mode)//0 = css 1 = js
		{
			$result=0;
			if ($Mode==0)
			{
				if (!empty($this->_cssFile))
				{
					$this->_CONTROLLER->load_css($this->_cssFile,FALSE,0,FALSE,FALSE);
					$result++;
				}
			}
			else
			{
				if (!empty($this->_jsFile))
				{
					$this->_CONTROLLER->load_js($this->_jsFile,FALSE,0,TRUE,FALSE,FALSE);
					$result++;
				}
			}
			$result=$result+$this->_CONTROLLER->doLoad_css_js($Mode,$this->ArticleRow['scheme']);
			return $result;
		}
		function Aload_js()
		{
			
			$result=$this->xLoad_css_js(1);
			return $result;
		}
		
		function Aload_css()
		{
			$result=$this->xLoad_css_js(0);
			return $result;
		}
		/*the next functions do nothing. You need to override them in order to do something regarding YOUR objects!
		*/
		function objectEdit(){
			echo l('no_object_specific_data');
		}
		
		function objectSave($parentID){//this needs to have a result set
			
			return TRUE;
		}
		/*********************************************************************************/
		
	}
	
	
	class qmd_base_article extends qmd_custom_article
	{
	
		var $_tablename;
		var $_tablename_ML;
		var $_db_Name;
		var $DBconnected;
		var $_loader;
	
		function __construct($controller,$BaseRec,$tablename='',$dbName=''){
			
			parent::__construct($controller,$BaseRec);
			
			$this->DBConnected=false;
			$this->_loader='';
	
	
			if (empty($tablename)):
				$this->_tablename=_PRE.'qmd_articles';
			else:
				$this->_tablename=$tablename;
			endif;
			$this->_tablename_ML=$this->_tablename.'_ML';//we use this as a default
																		//you probably need to override this one in YOUR article objects
			if (empty($dbName)):
				$this->_db_Name='';
			else:
				$this->_db_Name=$dbName;
			endif;
			
		
		}
		function __destruct(){
			parent::__destruct();
			
			if ($this->DBConnected==TRUE):	//this should not be the case if properly implemented
				$this->disconnect();
			endif;
		
		}		
		
		
		function connect()
		{	
			
			if (!empty($this->_db_Name)):
				if ($this->DBConnected==FALSE):
					if (!empty($this->_db_Name)):
						connect_to_db($this->_db_Name) or qmd_die(l('dberror'));
					endif;
				endif;
			endif;
			$this->DBConnected=TRUE;
		}
		function disconnect()
		{	
			if ($this->DBConnected==TRUE):
				if (!empty($this->_db_Name)):
					connect_to_db('');
				endif;
				$this->DBConnected=FALSE;
			endif;
		}
		function articleInit()
		{
			$result=TRUE;
			//msgbox('Init');	//NOTE: DEBUG if loading works properly
			
			return $result;
		}
		
		function articleFinalize()
		{
			$result=TRUE;
			//echo 'Ende Artikel';
			$this->disconnect();
			return $result;
		}
		//You have to override the next functions for all lists and other self-developed article-objects that have a parent.
		function getArticleParent(){return null;}
		function getExternalID(){return -1;}
		
		function getArticleCommentMode()
		{
			if ($this->ArticleCommentMode==-2)
			{
				$result=0;
				$SiteMode=s('site_comments_mode');
				if ($SiteMode>0)://check systemsettings first
					$ACM=$this->ArticleRow['commentable'];

					if ($SiteMode==1)
						$ACM=$ACM | 1;
					else
						if ($SiteMode==0)
							$ACM=0;
							
					
					switch ($ACM):
						case 3:$ACM=1;//frozen
								break;
						case 4:$ACM=0;//no
								break;
						case 3:
						case 8:
						case 12:
								$ACM=0;
								break;
						case 13:$ACM=5;
								break;
						case 14:
						case 15:
							$ACM=6;
								break;
					endswitch;
					$result=$ACM;
				endif;
				$x = ($result & 4);
				if ($x>0)
				{
					if ($this->_CONTROLLER->get_userPermission(__USER_isUser)==0)
						$result=0;
					else
						if (($result>4) &&($result<8))
							$result=$result-4;
				}
				
				$x = ($result & 8);
				if ($x>0)
				{
					if ($this->_CONTROLLER->get_userPermission(__USER_is2ndLevel)==0)
						$result=0;
					else
						if (($result>8) &&($result<12))
							$result=$result-8;
				}
				//$result is now respective to current user only 0=>no comments 1=>frozen 2=>commentable
				$this->ArticleCommentMode=$result;
			}
			else
				$result=$this->ArticleCommentMode;
			return $result;
		}
		
		function has_comments($approved=TRUE,$Mode=0)//$Mode=0 -> only current lang otherwise all
		{//NOTE this function delivers a value < 0 if commenting is not available for the article in question
		global $qSQL;
		global $qmd_Lang_ANY;
			$result=-1;
			
			if ($this->ArticleCommentMode<0)//not initialized yet
			{
				$ACM=$this->getArticleCommentMode();
				
				if ($ACM==0)
				{
					//$result=-1; is already set
					$this->iCommentsThisLang=0;
					$this->iCommentsOtherLang=0;
				}
				else
				{
					$a=array();
					$a[]=$this->ArticleRow['artid'];
					$a[]=$this->_CONTROLLER->language;
					$a[]=$qmd_Lang_ANY;
					$sql='SELECT count(id) as commentcount from '._PRE.'qmd_comments WHERE articleid=? AND lang_used in (?,?) 
								AND answer2comment is NULL';
					
					if ($approved==TRUE):
						$sql.=' AND approved>?';
						$a[]=0;
					endif;

					$r = $qSQL->qSQLquick($sql,$a);
					
					if (is_array($r))
					{
						$this->iCommentsThisLang=$r[0]['commentcount'];
					}
					unset($a);
					//-----------------------------------------------------
					$a[]=$this->ArticleRow['artid'];

					$sql='SELECT count(id) as commentcount from '._PRE.'qmd_comments WHERE articleid=? 
							AND answer2comment is NULL';
					if ($approved==TRUE):
						$sql.=' AND approved>?';
						$a[]=0;
					endif;

					$r = $qSQL->qSQLquick($sql,$a);
					if (is_array($r))
					{
						$this->iCommentsOtherLang=$r[0]['commentcount'] - $this->iCommentsThisLang;
					}
					if ($Mode==0)
						$result=$this->iCommentsThisLang;
					else
						$result=$this->iCommentsOtherLang+$this->iCommentsThisLang;
				}
			}
			else
				$result=$this->ArticleCommentMode;
			
			return $result;
		}
		//Display article
		function showArticleHead($Mode=1){

			global $qmd_Lang_ANY;
			
		//CAUTION: this works only for the basedata
		// If you are using other tables than qmd_articles you need to override this
		// Probably just copy and paste the code and enter different properties instead of ArticleRow and the like
			

			if (isset($this->ArticleRow['title']))
				$title=$this->ArticleRow['title'];
			else
				$title='';
			
			if (($this->ArticleRow['displaytitle']==1)||($Mode==0)):
				if ($Mode==1):
					echo('<div class="qmd_article_title">'.$title.'</div>');
				else:
					echo('<div class="qmd_article_title">'.qmd_createLink($this->ArticleRow['seftitle'],
																							$title)
																							.'</div>');
				endif;
			endif;

			if ($this->ArticleRow['showdate']>0)
				echo '<div class="qmd_article_date">'.qmd_datedb2HTML($this->ArticleRow['date']).'</div>';
			
			if (isset($this->ArticleRow['lang']))
			{
				$lang=$this->ArticleRow['lang'];
			
				if (($lang!=$this->_CONTROLLER->language)&&($lang!=$qmd_Lang_ANY))
					echo '<div class="qmd_notLang">'.l('no_article_in_selected_lang')."\r\n".'</div>';
				
			}
			
			
		}
		function getArticleBody()
		{
			$body='';

			if ($this->TeaserMode>0)
			{
				$body=$this->ArticleRow['body'];
				$body=preg_replace('/<a href="\//','<a href="/'.$this->_CONTROLLER->language.'/',$body,-1,$count);
				
				$body=preg_replace("/<a href='\//","<a href='/".$this->_CONTROLLER->language.'/',$body,-1,$count);
				
				if ($this->TeaserMode<3)
				{	
					if ($this->TeaserMode==2)
						$body=substr($body,$this->teaserTag+7+3,strlen($body));
					else
						$body=substr($body,$this->teaserTag,strlen($body));
					
				}
			}
			
			return $body;
		}
		//$TeaserMode
									//-2 uninitialized
									//-1 no teaser body empty
									//0  body length < s('default_teaser_length');
									//+1 teaser defined by settings body is cut
									//+2 a real teaser is inserted in the article body
									//+3 include
									//+4 body handles stuff itself (starting with "<p" or "<div")
		function getArticleTeaserLength()
		{
		global $qEOT_pattern;
			$this->TeaserMode=-1;	//-1 no teaser body empty
									//0  body length < s('default_teaser_length');
									//+1 teaser defined by settings body is cut
									//+2 a real teaser is inserted in the article body
									//+3 include
									//+4 body handles stuff itself (starting with "<p" or "<div")
			$result=0;
			
			if (isset($this->ArticleRow['body']))
			{
				$sBody=$this->ArticleRow['body'];
				$bodyLen=strlen($sBody);
				//+3 body is included!
				$include=strpos($sBody,'[include]');
				$include2=strpos($sBody,'[/include]');
				if (($include===0)&&($include2 !==FALSE))
					$this->TeaserMode=3;
				else
				{
					$result=strpos($sBody,'[break]');
					//msgbox($result);
					if ($result===false)
					{
						if ((substr($sBody,0,2)=='<p')||(substr($sBody,0,4)=='<div'))
						{
							$this->TeaserMode=4;
						}
						else
						{
							$result=s('default_teaser_length',300);
							$matches=array();
							$newresult=preg_match($qEOT_pattern, $sBody,$matches,PREG_OFFSET_CAPTURE,$result); // 


							if ($newresult===false)
							{	

								$this->TeaserMode=0;
								$result=$bodyLen;
							}
							else
							{

								$result=$matches[0][1];//was +1
								
								if (strlen($sBody)<=$result)
									$this->TeaserMode=0;
								else
								{
									//if (($sBody[$result]=='.')||($sBody[$result]=='!')||($sBody[$result]=='?')||($sBody[$result]==':'))
									if ($sBody[$result]<>'<')
										$result++;
									$this->TeaserMode=1;
								}
							}
						}
					}
					else
						$this->TeaserMode=2;
				}
			}
			$this->teaserTag=$result;
			return $result;
		}
		function getArticleTeaser($Mode)
		{//OVERRIDE this (F) in your articleobject if you need to display something different
			//Mode 0=> Teaser Mode with several articles
			//Mode 1=> Article Mode show page more or less unchanged or highlight the teaser if no <html> found
			//Mode 2=> Teaser Mode for SEO-Description
			$teaser='';
			
			if ($this->TeaserMode==-2)
				$this->getArticleTeaserLength();
			if ($this->TeaserMode>0)
			{
				
				if ($this->TeaserMode<3)
				{
					$teaser=substr($this->ArticleRow['body'],0,$this->teaserTag);
					
					if ($Mode==0)
						$teaser=$teaser.'...<br/>';
					else
					{	if ($this->Mode==1)
						{
							if ($this->TeaserMode==2)
								if ((substr($teaser,0,3)!=='<b>')&&(substr($teaser,0,2)!=='<h'))
								{
									$teaser='<b>'.$teaser.'</b><br/>';
								}
						}
					}
				}
				
			}
			else
			{
				if ($this->TeaserMode==0)
				{
					$teaser=$this->ArticleRow['body'];
				}
			}

			return $teaser;
		}
		function showArticleTeaser($Mode){
			if ($this->TeaserMode==-2)
				$this->initArticleShow();

			$teaser=$this->getArticleTeaser($Mode);
			if (!empty($teaser))
				echo $teaser;
		}
		
		function showArticleBody(){

			
			if ($this->TeaserMode==-2)
				$this->initArticleShow();
			$body=$this->getArticleBody();
			if ($this->TeaserMode==3)
			{
				file_include($body,9999000);
				connect_to_db();	//reset
			}
			else
				echo $body;
			$this->_CONTROLLER->showarticleEditLink($this);
		}
		
		function showArticleComments(){
			$this->disconnect();//comments are always in the main database
			comment($this->ArticleRow['artid'],$this->ArticleRow['seftitle']);	//TODO we should fetch all the required data from within the articleobject
																			//and then display the lot.
		}
		function initArticleShow()
		{
			$teaserTag=$this->getArticleTeaserLength();
		}
		function ArticleShow($Mode=1)//Mode=0 show teaser Mode=1 show all
		{
			//msgbox($Mode);
			$this->initArticleShow();
			$result=TRUE;
			//Override This Function
			$sCSS='qmd_article_box';
			$x=($this->ArticleRow['display_mode']&__pagemode);
			
			if (($x>0) && ($Mode==1))
				$sCSS.='_page';
			else
			{
				$x=($this->ArticleRow['display_mode']&__fullscreen);
				
				if (($x>0)&&($Mode==1))//such an article never makes it to here...
					$sCSS.='_full';
			}
			echo '<div class="'.$sCSS.'">';
			
			$this->showArticleHead($Mode);//////////////  HEAD  ///////////////////////////////////////////////////////////
			$this->showArticleTeaser($Mode);//////////////  TEASER //////////////////////////////////////////////////////////
			
			if ($Mode>0):
				
				$this->showArticleBody();//////////////  BODY  ////////////////////////////////////////////////////////////////
				
				echo '</div>';// class="qmd_article_box">';
				$this->showArticleComments();//////////////  COMMENTS  ////////////////////////////////////////////////////////
			else:

				$sMore=l('read_more');

				echo '<div class="qmd_article_readmore">'.qmd_createLink($this->ArticleRow['seftitle'],
																							$sMore)
																							.'</div>';
				$this->disconnect();
				
				if ($this->has_comments(TRUE,0)>0)//only approved and in current language for TEASER
					echo '<div class="qmd_article_seecomments">'.qmd_createLink($this->ArticleRow['seftitle'],
																									l('see_comments')
																									.'&nbsp;('.$sx.')').'</div>';
				echo '</div>';//I don't know if this is a good place to close the DIV
								//there is probably a better solution
				echo '<p class="qmd_article_spacer"></p>';
			endif;
			
			return $result;
		}
		
		function displayArticle($Mode=1)
		{
			
			$result=parent::displayArticle();
			if ($result==TRUE):
				
				$this->connect();
				
				$result=$this->ArticleShow($Mode);
				
			endif;
			
			$result=$this->articleFinalize();
			//$this->doPostForm(1);	this was just a test!
				
			return $result;
		}
		function HasChildArticles()
		{
			$result=-1;
			return $result;
		}
		
		public function getBackLink2Article()
		{
			$result='/'.$this->ArticleRow['seftitle'];
			return $result;
		}
		/**************************************************************************************************
		**************************************************************************************************
		**************************************************************************************************
		**************************************************************************************************
		**************************************************************************************************
		**************************************************************************************************
		**************************************************************************************************
		**************************************************************************************************
		**************************************************************************************************
		**************************************************************************************************
		**************************************************************************************************/
		/* YOU HAVE TO override these functions when providing an article object!!! */
		
		public function DoEditArticle(){
		global $qSQL;
		global $lAcomments;
		global $qmd_const_URL_Params;
		global $LANG;
		global $qmd_Lang_ANY;
		global $DCTypeArray;
		global $META_docTypeDesc;
		global $__commentModes;
		
		$curLang=$this->ArticleRow['lang'];
		if (empty($curLang))
			$curLang=$this->_CONTROLLER->language;
		
		$xP=$this->getArticleParent();
		
		if ($xP==null):
			$parentID=null;
		else:
			$parentID=$xP->getArticleID();
		endif;
		
		$r=$this->ArticleRow;
		
		
		if ($r<>null):
			$artid=$r['artid'];
			$frm_action = '/'.$this->_CONTROLLER->language.'/'.$qmd_const_URL_Params[2].'/?action=process%26task=admin_article%26id='.$artid.'%26editLang='.$curLang;
			
			$childid=isset($r['id'])?$r['id']:-1;
			$langID=$r['MLID'];//ID of the language table!
			
			$frm_scheme=isset($r['scheme'])?$r['scheme']:s('scheme');
			$frm_display_mode=$r['display_mode'];
			$frm_showonhome = $r['show_on_home'];
			
			$frm_showdate=$r['showdate'];
			
			$article_category = $r['category'];
		
			$header_edit_article = l('header_edit_article');
			
			
			$frm_title = $r['title']; //
			
			$frm_sef_title = $r['seftitle']; //
			
			
			$frm_text = $r['body'];
			
			if (substr($frm_text,0,9)=='[include]'):
				
				//$body_text=file_include($frm_text,9999000,1);
				$body_text=l('preview_not_available');
				$previewTag=0;
			else:
				$body_text=$frm_text;
				$previewTag=1;
			endif;
			
			$frm_meta_key = $r['keywords_meta'];
			
			$frm_commentable = $r['commentable'];
			
			$x=array_search($frm_commentable,$__commentModes);
			
			if ($x===FALSE)
				$frm_commentable=s('art_default_comments');
			else
				$frm_commentable =$x;
			
			$frm_task = 'edit_article';
			$frm_submit = l('edit_button'); 
			$frm_display_title = $r['displaytitle'];
			$frm_article_date=strtotime($r['date']);
			$frm_VAC=$r['VAC'];
			$frm_articleobject=$r['objectloader'];
			$aLang=get_ArticleLangsAvail($artid);
			$frm_desc_meta=$r['description_meta'];
			$frm_subject=$r['subject_meta'];
			$frm_DCType=$r['DCType'];
			$frm_METADocType=$r['DOCtypeHTML'];
			
			$frm_ObjXtra=$r['optXtra'];
		else://no ID given i.e. we have a new article

			$frm_action = '/'.$this->_CONTROLLER->language.'/'.$qmd_const_URL_Params[2].'/?action=process%26task=admin_article';
			$body_text='';
			$previewTag=1;
			$frm_DCType='Text';
			$frm_METADocType=0;
			$frm_desc_meta='';
			$childid=-1;
			$artid=-1;
			//ID of the language table!
			$langID=-1;
			
			if (isset($this->ArticleRow['lang'])):
				//ID of the language table!
				$curLang=$this->ArticleRow['lang'];//current language
			else:
				$curLang=$this->_CONTROLLER->get_UParamByName('editLang',$this->_CONTROLLER->language);//current language
				
			endif;
			
			if (isset($xP)):
				$frm_scheme=$xP->ArticleRow['scheme'];
			else:
				$frm_scheme=s('scheme');
			endif;
			$frm_display_mode = (__visible | __showincats);//defaults
			
			$article_category=1;//TODO ATM hard coded )-;
			$frm_article_date=time();
			$header_edit_article = l('article_new');
			
			//$pos = 1;
			$frm_articleobject=$this->_loader;
			
			$frm_title = $_SESSION && isset($_SESSION['article_save']['title']) ? $_SESSION['article_save']['title'] : ''; //
			
			$frm_sef_title = $_SESSION && isset($_SESSION['article_save']['seftitle']) ? cleanSEF($_SESSION['article_save']['seftitle']) : ''; 
			$frm_text = $_SESSION && isset($_SESSION['article_save']['text']) ? $_SESSION['article_save']['text'] : ''; //
			
			$frm_meta_key = $_SESSION && isset($_SESSION['article_save']['keywords_meta']) ? cleanSEF($_SESSION['article_save']['keywords_meta']) : ''; //
			$frm_display_title = 1;
			$frm_showdate= 1;
			
		
			
			$frm_showonhome = s('display_new_on_home');
			$frm_commentable = s('art_default_comments');
			$frm_task = 'add_article';
			$frm_submit = l('submit');
			if ($this->_CONTROLLER->get_UParamByName('ArtVacMode')<1)
				$frm_VAC=0;
			else
				$frm_VAC=1;
			$aLang=$LANG;
			$frm_subject='';
			$frm_ObjXtra='';
		endif;//else new article
		
		$frm_vacshowforce=($frm_VAC & 2);
		$frm_vacshowleft=($frm_VAC & 4);
		$frm_vacshowright=($frm_VAC & 8);
		$frm_vacshowbot=($frm_VAC & 16);
		$frm_vacshowtop=($frm_VAC & 32);
		if ($frm_VAC>0):
			$frm_VAC=1;
		endif;
		$default_4_scheme=($frm_display_mode & __default4scheme);
		$frm_publish = ($frm_display_mode & __visible);
		
		$show_in_cats = ($frm_display_mode & __showincats);
		$frm_page=($frm_display_mode & __pagemode);
		$frm_fullscreen=($frm_display_mode & __fullscreen);
		
		
			
		echo html_input('form', '', 'post', '', '', '', '', '', '', '', 'post', $frm_action);
		
		echo '<div class="qmd_adminpanel">';
		$aVac=array();
		$aVac[0]=l('article');
		$aVac[1]=l('VAC');
		echo '<p class="qmd_adminSectionHeader">
					<a onclick="toggle(\'qmd_admin_edit_article\')" style="cursor: pointer;" title="'.$header_edit_article.'">'
							.$header_edit_article
					.'</a>&nbsp;['.$curLang.']&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'.
					html_input('combobox', 'cmbVAC', 'cmbVAC', $frm_VAC, l('Mode'), '', 'onclick="toggle3(\'qmd_edit_vac\',\'article_props\',\'qmd_edit_art_props\')"',
							'',    '',    '',      '',      '',     '',        '',$aVac);
		//echo '000';
		if ($parentID==null):
			$pparent='';
		else:
			
			$pparent=l('art_parent').': '.$parentID;
		endif;
		
		
		if ($r==null):
			echo '['.l('article_new').']';
		else:
			echo 'ID: ' .$artid.' '.$pparent. ' lang-ID: '.$r['MLID'];
		endif;
		
		
		echo	'</p>';
		echo '<table border="1"	><tr><td>';
		
		echo '<div id ="qmd_admin_edit_article" style="display: inline;">';
				if ($r==null):
					echo html_input('text', 'title', 'at', $frm_title, l('title'), '', 'onchange="genSEF(this,document.forms[\'post\'].seftitle)" onkeyup="genSEF(this,document.forms[\'post\'].seftitle)"');
				else:
					echo html_input('text', 'title', 'at', $frm_title, l('title'));
				endif;
				echo '<br/>';
		
				echo html_input('text', 'seftitle', 'as', $frm_sef_title, l('sef_title'));
				
				echo html_input('textarea', 'text', 'txt', $frm_text, l('text'), 'qmd_admineditArticle', 'onkeyup="updatePreview(\'txt\',\'preview\')"', '', '2', '100');
				
				buttons();
				echo '<hr/>';
				$sql=query_get_menu();
				$sql.=' order by m.sort ';
				$ma=$qSQL->qSQLsimple($sql);
				
				$SelMenu=get_Menu2Article ($artid);	
				$x=$this->_CONTROLLER->get_UParamByName('option');
				if ($x=='add_menu')
				{
					$SelMenu[]=-1;
				}
				echo html_input('checkbox', 'publish_article', 'pu', 1, l('publish_article'),  '', '', $frm_publish);
				//$frm_showdate=$r['showdate'];
				echo '<br/>';
				create_category_combo(0,$article_category,l('category'),'');//all levels
				echo '<br/>';
				if ($frm_VAC==0)
					echo '<div id="article_props">';
				else
					echo '<div id="article_props" style="display:none">';
					if (count($SelMenu)>0)
					{
						for ($iCount=0;$iCount<count($SelMenu);$iCount++)
						{
							echo html_input('combobox','cmbMenu'.$iCount,'cmbMenu'.$iCount,$SelMenu[$iCount], l('menulink'),'','','','','','','','','',$ma);
							if ($iCount>0)
								echo html_input('submit', 'remove_menu_'.$SelMenu[$iCount], 'remove_menu', l('remove_menu'), $frm_action.'%26remove_men='.$SelMenu[$iCount], '');
						
							echo '<br/>';
						}
					}else
					{
						echo html_input('combobox','cmbMenu0','cmbMenu0',$SelMenu[0], l('menulink'),'','','','','','','','','',$ma);
					}
					echo html_input('submit','btnAddMenu','btnAddMenu',l('add_new'),$frm_action.'%26option=add_menu');
					echo '<br/>';
					
					
					
					$aschemes=get_scheme_array();
					$x=array_search($frm_scheme,$aschemes);
					if ($x===false)
						echo '<div class="qmd_warning">Error: scheme setting is outdated or not existent ('.$frm_scheme.')</div>';
					echo html_input('combobox','cmbscheme','cmbScheme',$frm_scheme, l('art_scheme'),'qmd_admin_edit_article_cmb_big','','','','','','','','',$aschemes);
					echo '<br/>';
					echo html_input('checkbox', 'default_4_scheme', 'default_4_scheme', 1, l('default_4_scheme'),  '', '', $default_4_scheme);
					
					echo '<br/>';
					//---------------------------TYP ----------------------------------------------
					/*please refer to dublincore.org if in doubt
					Collection 
					Dataset 
					Event 
					Image 
					InteractiveResource 
					PhysicalObject 
					Service 
					Software
					Sound 
					Text 						*/
					
					
					$frm_DCTypeord=array_search($frm_DCType,$DCTypeArray);
					
					echo html_input('combobox','cmbDCType','cmbDCType',$frm_DCTypeord, 'DC-Type','qmd_admin_edit_article_cmb_big','','','','','','','','',$DCTypeArray,'',15);
					echo '<br/>';
					
					
					echo html_input('combobox','cmbMETADoCType','cmbMETADoCType',$frm_METADocType, 'Meta-DoC-Type','qmd_admin_edit_article_cmb_big','','','','','','','','',$META_docTypeDesc);
					echo '<br/>';
					
					echo html_input('text', 'articleobject', 'ao', $frm_articleobject, l('articleobject'));
					echo '<br/>';
					
					echo html_input('text', 'artobjXtra', 'artobjXtra', $frm_ObjXtra, l('articleobjectXtra'),'','','',0,32);
					echo '<br/>';
					
			
					echo html_input('checkbox', 'show_in_cats', 'show_in_cats', 1, l('show_in_cats'),  '', '', $show_in_cats);
					echo '<br/>';
					echo html_input('checkbox', 'show_on_home', 'sho', 1, l('show_on_home'),  '', '', $frm_showonhome);
					echo '<br/>';
					
					echo html_input('checkbox', 'show_as_page', 'show_as_page', 1, l('page_mode'),  '', '', $frm_page);
					
					echo '<br/>';
					echo html_input('checkbox', 'fullscreen', 'fullscreen', 1, l('fullscreen'),  '', '', $frm_fullscreen);
					
					echo '<br/>';
				echo '</div>';//article_props
				
				
				if ($frm_VAC==1)
					echo '<div id="qmd_edit_vac" style="display: inline;">';
				else
					echo '<div id="qmd_edit_vac" style="display: none;">';

						echo '<h3>VAC</h3>';
						
						echo html_input('checkbox', 'vacshowforce', 'vacshowforce', 1, l('vacshowforce'),  '', '', $frm_vacshowforce);
						echo '<br/>';
						echo html_input('checkbox', 'vacshowleft', 'vacshowleft', 1, l('vacshowleft'),  '', '', $frm_vacshowleft);
						echo '<br/>';
						echo html_input('checkbox', 'vacshowright', 'vacshowright', 1, l('vacshowright'),  '', '', $frm_vacshowright);
						echo '<br/>';
						echo html_input('checkbox', 'vacshowtop', 'vacshowtop', 1, l('vacshowtop'),  '', '', $frm_vacshowtop);
						echo '<br/>';
						echo html_input('checkbox', 'vacshowbot', 'vacshowbot', 1, l('vacshowbot'),  '', '', $frm_vacshowbot);
						echo '<br/>';
					echo '</div>';
				
			echo '</div><!-- qmd_admin_edit_article -->';
			echo '</td>';
			
			echo '<td valign="top">';
			
			if ($artid>0):
				echo '<p class="qmd_admin_langhead">'.l('lang_select').'</p>';
			
			
				for ($jCount=0;$jCount<count($LANG);$jCount++):
					$sLang=$LANG[$jCount];
					if ((array_search($sLang,$aLang)===FALSE)&&($sLang!=$curLang))://no
						echo '<p class="qmd_admin_langnew">'
							.qmd_createLink('/'.$qmd_const_URL_Params[2].'/?action=admin_article
																					%26id='.$artid
																					.'%26editLang='.$sLang
																					.'%26task=create
																					%26master='.$curLang
																					.'%26parent='.$parentID,
														l('create_art_in').$sLang)
							.'</p>';
					else://yes
						if ($sLang!=$curLang):
							echo '<p class="qmd_admin_langedit">'
									.qmd_createLink('/'.$qmd_const_URL_Params[2]
																.'/?action=admin_article
																%26id='.$artid
																.'%26editLang='.$sLang,
														l('edit_art_in').$sLang).'</p>';
						endif;
					endif;
				endfor;
				//echo 'xxx<br>';
				if ($curLang<>$qmd_Lang_ANY ):
					if (array_search($qmd_Lang_ANY ,$aLang)===FALSE)://no
						echo '<p class="qmd_admin_langnew">'
							.qmd_createLink('/'.$qmd_const_URL_Params[2].'/?action=admin_article
																					%26id='.$artid
																					.'%26editLang='.$qmd_Lang_ANY
																					.'%26task=create
																					%26master='.$curLang
																					.'%26parent='.$parentID,
														l('create_art_in').$qmd_Lang_ANY)
							.'</p>';
					else:
						echo '<p class="qmd_admin_langedit">'
								.qmd_createLink('/'.$qmd_const_URL_Params[2].'/?action=admin_article
															%26id='.$artid
															.'%26editLang='.$qmd_Lang_ANY,
													l('edit_art_in').' #ANY')
							.'</p>';
					endif;
				endif;
				
			else:
				echo l('lang_select_not_avail');
			endif;
			echo '</td>';
			echo '</tr>';
			echo '</table>';
			echo '</div><!-- qmd_adminpanel -->'; 
			//echo '</fieldset></div>'; 
			//$toggle='<a onclick="toggle(\'preview\')" style="cursor: pointer; display: none;"';
			$toggle='<a onclick="toggle(\'preview\')" style="cursor: pointer;"';
			echo '<div class="qmd_adminpanel">';
				
				if ($previewTag>0):
					$sPreview=$frm_text;
				else:
					$sPreview=l('preview_not_available');
				endif;
				//echo '<p class="qmd_adminSectionHeader">'.l('preview').'</p>';
				echo '<p class="qmd_adminSectionHeader">'.$toggle.' title="'.l('preview').'">'.l('preview').'</a></p>';
				echo '<div id="preview" style="display: none;">';
					echo '<div class="qmd_article_box">';
						echo $sPreview;
					echo '</div>';
				echo '</div>';
			echo '</div>'; 
			
			/****************************************************************************************
			****************************************************************************************/
			//msgbox($frm_VAC);
			if ($frm_VAC==1)
				echo '<div id="qmd_edit_art_props" style="display: none;">';
			else
				echo '<div id="qmd_edit_art_props">';

				
				$objectID=$this->getExternalID();
				if ($objectID>0)
					$objectID='&nbsp;[external ID: '.$objectID.']';
				else
					$objectID='';
				
				echo '<div class="qmd_adminpanel">';
					echo '<p class="qmd_adminSectionHeader"><a onclick="toggle(\'object\')" style="cursor: pointer;" title="'.l('editobjectdata').'">'.l('editobjectdata').$objectID.'</a></p>';
					echo '<div id="object" style="display: none;">';
						$this->objectEdit();
						
					echo '</div>';
				echo '</div>';

			/****************************************************************************************
			****************************************************************************************/
				echo '<div class="qmd_adminpanel">';
				
					echo '<p class="qmd_adminSectionHeader"><a onclick="toggle(\'customize\')" style="cursor: pointer;" title="'.l('customize').'">'.l('customize').'</a></p>';
					echo '<div id="customize" style="display: none;">';
				
						//echo 'foo<br/>';
						echo html_input('textarea', 'keywords_meta', 'km', $frm_meta_key, l('keywords_meta'),'','onkeyup="countChars(\'km\',\'key_showchars\')"','',2,100);
						echo '<span id="key_showchars"></span>';
						echo '<br/>';
						
						echo html_input('textarea', 'description_meta', 'dm', $frm_desc_meta, l('description_meta'),'','onkeyup="countChars(\'dm\',\'desc_showchars\')"','',2,100);
						echo '<span id="desc_showchars"></span>';
						echo '<br/>';
						echo html_input('text', 'subject', 'subject', $frm_subject, l('meta_subject'),'','','');
						echo '<br/>';
						echo html_input('checkbox', 'display_title', 'dti', 1, l('display_title'),  '', '', $frm_display_title); 
						echo '<br/>';
						echo html_input('checkbox', 'show_date', 'sd', 1, l('show_date'),  '', '', $frm_showdate);
			
						if ($frm_article_date<time()):
							echo '&nbsp;&nbsp;&nbsp;'.date(s('date_format'),$frm_article_date);
						else:
							echo '&nbsp;&nbsp;&nbsp;<span class="articlefuturedate">'.date(s('date_format'),$frm_article_date).'</span>';
						endif;
				
						echo '<br/>';
				
						echo html_input('combobox', 'cmbCommentMode', 'cmbCommentMode', $frm_commentable, l('comments'), '', '', '', '', '', '', '', '','',$lAcomments);
				
						echo '<br/>';
					
					echo '</div></div>'; //echo '</div></fieldset></div>'; 
				echo '</div>';
				
				echo '<div class="qmd_adminpanel">';

				echo '<p class="qmd_adminSectionHeader"><a onclick="toggle(\'admin_publish_date\')" style="cursor: pointer;" title="'.l('publish_date').'">'.l('publish_date').'</a></p>';
				echo '<div id="admin_publish_date" style="display: none;">';

				echo '<p>'.l('server_time').': '.date(s('date_format')).'</p>';
				echo '<p>'.l('article_date').'</p>';

				posting_time($frm_article_date);
				echo '</div></div>'; //echo '</div></fieldset></div>'; 
			
			echo '<p>';
			
			echo html_input('hidden', 'langID', 'langID', $langID,'');
			echo html_input('hidden', 'task', 'task', 'admin_article','');
			
			echo html_input('submit', $frm_task, $frm_task, $frm_submit, '', 'buttonbig');
			if ($parentID==null):
				echo html_input('hidden', 'articleParent', 'articleParent', -1,'');
			else:
				echo html_input('hidden', 'articleParent', 'articleParent', $parentID,'');
			endif;
			if ($artid>0):
				echo html_input('hidden', 'articleClass', 'articleClass', 'qmd_base_article','');
				/*------------------------------------------------this is REQUIRED!!!---------------------*/
				echo html_input('hidden', 'article_category', 'article_category', $article_category,'');
				echo html_input('hidden', 'articleLang', 'articleLang', $curLang,'');
				
				/*------------------------------------------------this is REQUIRED!!!---------------------*/
				
				echo '&nbsp;';
				echo html_input('hidden', 'artid', 'artid', $artid,'');
				echo '&nbsp;';				
				$showDelete=1;
				
				if ($this->HasChildArticles()>0)
					$showDelete=-1;
				
				if ($showDelete>0)
				echo html_input('submit', 'delete_article', 'delete_article', '['.$curLang.'] '.l('delete'), '',
										'buttonbig', 'onclick="javascript: return pop(\''.l('js_delete2').'\')"');
				echo html_input('submit', 'delete_article_complete', 'delete_article_complete', l('delete_ALL_Lang'), '',
										'buttonbig', 'onclick="javascript: return pop(\''.l('js_delete2').'\')"');
				echo html_input('submit', 'copyArticle', 'copyArticle', l('copyArticle'), '',
										'buttonbig', '');
				
			endif;
			echo '</p></form>';
			execJS('updatePreview(\'txt\',\'preview\')');//security for strange divs in the body textarea	
																		//update preview appends a clearer div and everything looks better now

		}//DoEditArticle
	public function DoDeleteArticle($artid,$langSel='')
	{
		global $qSQL;
		global $qmd_Lang_ALL;
		
		$STATUS=0;
		if (empty($langSel))$langSel=$qmd_Lang_ALL;
		//$this->connect();
		$langs=count_table_entries('qmd_articles_ML', 'id', " WHERE parent=".$artid);
		
		if ($langs<2)$langSel=$qmd_Lang_ALL;
		
		if ($langSel!=$qmd_Lang_ALL ):
			
			if ($qSQL->preparedelete(array('parent=','lang='),array($artid,$langSel),array(' AND '))>0):
				$res=$qSQL->deleteSQL(_PRE.'qmd_articles_ML',$iRows); 	//iRows will return the number of rows affected
				if ($res>0):
					$langs=$langs-$iRows;
					
					$STATUS=1;
				else:
					msgbox('error deleting article_ml [1]');
				endif;
			else:
				msgbox('error deleting article_ml [0]');
				
			endif;
			
		else:
			if ($qSQL->preparedelete(array('parent='),array($artid),null)>0):
				$res=$qSQL->deleteSQL(_PRE.'qmd_articles_ML',$iRows); 	//iRows will return the number of rows affected
				if ($res>0):
					$langs=$langs-$iRows;
					
					$STATUS=1;
				else:
					msgbox('error deleting article_ml [2]');
				endif;
			else:
				msgbox('error deleting article_ml [2a]');
			endif;
			
		endif;
		
		if (($langs==0)&&($STATUS==1)):// now we actually delete the rest
			$STATUS=0;
			//1. delete comments
			if ($qSQL->preparedelete(array('articleid='),array($artid),null)>0):
				$res=$qSQL->deleteSQL(_PRE.'qmd_comments',$iRows); 	//iRows will return the number of rows affected
				if ($res>0):
					
					
					$STATUS=1;
				else:
					msgbox('error deleting comments for article [3]');
				endif;
			else:
				msgbox('error deleting article_ml [3a]');
			endif;
			//2. delete from menu2article
			if ($STATUS==1):
				$STATUS=0;
				if ($qSQL->preparedelete(array('article_id='),array($artid),null)>0):
					$res=$qSQL->deleteSQL(_PRE.'qmd_article2menu',$iRows); 	//iRows will return the number of rows affected
					if ($res>0):
						
						
						$STATUS=1;
					else:
						msgbox('error deleting menuassignment for article [3]');
					endif;
				else:
					msgbox('error deleting menuassignment for article [3a]');
				endif;
				//3. delete the article itself
				if ($STATUS==1):
					$STATUS=0;
					if ($qSQL->preparedelete(array('id='),array($artid),null)>0):
						$res=$qSQL->deleteSQL(_PRE.'qmd_articles',$iRows); 	//iRows will return the number of rows affected
						if ($res>0):
							$STATUS=1;
							
						else:
							msgbox('error deleting article [4]');
						endif;
					else:
						msgbox('error deleting article [4a]');
					endif;
					if ($STATUS==1):
						
						if ($id == s('display_page')): //TODO
							$STATUS=0;
							$xID=0;
							$sql='UPDATE '._PRE.'qmd_settings SET VALUE = ? WHERE name = ?';
							if ($qSQL->qSQLdirect($sql,array(0,'display_page'),$xID)<1):
								msgbox('error updating settings on delete article');
							else:
								$STATUS++;
								
							endif;
						endif;
					endif;
				endif;
			endif;
		endif;
			
		return $STATUS;
	}//DoDeleteArticle
	public function DoCreateArticle($seftitle, 
												$parent=0,
												$article_date=0, 
												$category=0,
												$display_title='',
												$ArtCommentMode=-1,
												$display_mode=3,
												$show_on_home=0,
												$showdate=1,
												$artorder=0,
												$VAC=0,
												$scheme='',
												$articleObject='',
												$frm_DCType='Text',
												$frm_METADocType=0,
												$articleobjectXtra='',
									//ML
												$text='',
												$title='',
												$keywords_meta='',
												$description_meta='',
												$frm_subject='')		//returns the new  ID if a new article is created
	{
	global $qSQL;
	global $default_MetaDataKW;
	global $default_MetaDataDesc;
	global $meta_DCSubject;
	
		if (empty($seftitle))
			qmd_die('can not create article with empty seftitle!');
		if ($article_date<=0)
			$article_date=qmd_PHP2db(time());
		
		if ($ArtCommentMode<0)
			$ArtCommentMode=s('site_comments_mode');
		
		if (empty($scheme))
			$scheme=s('scheme');
		
//ML
		if (empty($keywords_meta))
			$keywords_meta=$default_MetaDataKW[$this->_CONTROLLER->language];
		if (empty($description_meta))
			$description_meta=$default_MetaDataDesc[$this->_CONTROLLER->language];
		if (empty($frm_subject))
			$frm_subject=$meta_DCSubject[$this->_CONTROLLER->language];
			
		
		$newID=-1;
		if ($qSQL->prepareinsert(array('seftitle',
															'art_parent',
															'date', 
															'category',
															'displaytitle',
															'commentable', 
															'display_mode',
															'show_on_home', 
															'showdate',
															'artorder',
															'VAC',
															'scheme',
															'objectloader',
															'DCtype',
															'DOCtypeHTML',
															'optXtra')
													,array($seftitle, 
																$parent,
																$article_date, 
																$category,
																$display_title,
																$ArtCommentMode,
																$display_mode,
																$show_on_home,
																$showdate,
																$artorder,
																$VAC,
																$scheme,
																$articleObject,
																$frm_DCType,
																$frm_METADocType,
																$articleobjectXtra)
															)>0):
			$res=$qSQL->insertSQL(_PRE.'qmd_articles',$NewID);
					
			if ($res!==1)
			{
				msgbox('error on insert article');
				$processStatus=-1;//-1 Error +1ok
			}
			else
			{
				if ($qSQL->prepareinsert(array('parent', 'lang','body','title','keywords_meta', 'description_meta','subject_meta'),
															array($NewID, $this->_CONTROLLER->language, $text,$title,$keywords_meta,$description_meta,$frm_subject))>0):
							
					$res=$qSQL->insertSQL(_PRE.'qmd_articles_ML',$xdummy);
					if ($res>0):
						$result=$NewID;
						
					else:
						msgbox('Error Insert article ML 2');
						
					endif;
				else:
					msgbox('Error Insert article ML 1');
					
				endif;
			}
		else:
			msgbox('error on prepare insert article');
			$processStatus=-1;//-1 Error +1ok
		endif;
		return $result;
	}
	public function DoSaveArticle(){//returns the new  ID if a new article is created
	global $qSQL;
	global $DCTypeArray;
	global $__commentModes;
		$newArticleID=-1;
		$display_mode=0;
		
		$iDBStatus=0;
		$iRowCount=0;

		$processStatus=0;//-1 Error +1ok
		
		$parent=$_POST['articleParent'];
		
		$VAC=$_POST['cmbVAC'];
		
		if ($parent<1)$parent=null;
		
		//check basics
		$title = isset($_POST['title']) ? clean(entity($_POST['title'])) : ''; //
		$$title=sanitize($title);
		
		$seftitle = isset($_POST['seftitle']) ? $_POST['seftitle'] : ''; //
		$artid= isset($_POST['artid']) ? $_POST['artid'] : -1; //
		
		$articleLanguage = isset($_POST['articleLang']) ? $_POST['articleLang'] : $this->_CONTROLLER->language; //
		
		$langID=isset($_POST['langID']) ? $_POST['langID'] : -1; //
		$return2form=1;
		$sMSG='';
		$aLinkLabel=array(l('back'));
		$aLinkList=array($_SERVER['HTTP_REFERER']);
		$articleobjectXtra=$_POST['artobjXtra'];
		if (empty($title)):
			qmd_notify(1,l('err_TitleEmpty').l('errNote'),$aLinkLabel,$aLinkList);
		else:
			if (empty($seftitle)):
				qmd_notify(1,l('err_SEFEmpty').l('errNote'),$aLinkLabel,$aLinkList);
			else:
				if (cleancheckSEF($seftitle) == 'notok'):
					qmd_notify(1,l('err_SEFIllegal').l('errNote'),$aLinkLabel,$aLinkList);
				else:
					
					if (!check_if_unique('article_seftitle', $seftitle, $artid, $sMSG)):
						qmd_notify(1,l('err_SEFExists').l('errNote').' '.$sMSG,$aLinkLabel,$aLinkList);
					else:
						if (!check_if_unique('article_title', $title, $artid, $sMSG)):
							qmd_notify(1,l('err_TitleExists').l('errNote').' '.$sMSG,$aLinkLabel,$aLinkList);
						else:
							if ($VAC==0)
							{
								
								if (isset($_POST['cmbMenu0'])):
									$menFound=1;
								else:
									msgbox('Warning no menu selected',$aLinkLabel,$aLinkList);
								endif;
							}
							else
								$menFound=0;
							$return2form=0;
						endif;
					endif;
				endif;
			endif;
		endif;
		
		if ($return2form==1):
			form_articles('');//shouldn't we hand parameters
		else:
			//$frm_DCType=!empty($_POST['cmbDCType']) ? $_POST['cmbDCType'] : 'Text'; //set from categories!!!
			$showdate=0;
			if ($VAC==0)
			{
				$frm_DCTypeord= $_POST['cmbDCType']; //
				$frm_DCType=$DCTypeArray[$frm_DCTypeord];
				
				$frm_METADocType=$_POST['cmbMETADoCType'];
				
				$show_in_cats = isset($_POST['show_in_cats']) && $_POST['show_in_cats'] == 'on' ? 1 : 0; //
				$description = isset($_POST['description']) ? clean(entity($_POST['description'])): ''; //
				if (isset($_POST['show_date'])):
					if ($_POST['show_date']=='on'):
						$showdate++;
					endif;
				endif;
				$keywords_meta = isset($_POST['keywords_meta']) ? entity($_POST['keywords_meta']): ''; //
				$description_meta = isset($_POST['description_meta']) ? entity($_POST['description_meta']): ''; //
				$frm_subject= isset($_POST['subject']) ? entity($_POST['subject']): ''; //
				$display_title = isset($_POST['display_title']) && $_POST['display_title'] == 'on' ? 1 : 0; //
				$page_mode = isset($_POST['show_as_page']) && $_POST['show_as_page'] == 'on' ? 1 : 0; //
				$fullscreen = isset($_POST['fullscreen']) && $_POST['fullscreen'] == 'on' ? 1 : 0; //
				$articleObject=$_POST['articleobject'];//actually this is the loader
				
				$default_4_scheme=isset($_POST['default_4_scheme'])&&$_POST[default_4_scheme]=='on'?1:0;
				
				$ArtCommentMode=$_POST['cmbCommentMode'];
				$ArtCommentMode=$__commentModes[$ArtCommentMode];
				$schemeord= $_POST['cmbscheme']; //
				$aschemes=get_scheme_array();
				$scheme=$aschemes[$schemeord];
				
				$publish_article = isset($_POST['publish_article']) && $_POST['publish_article'] == 'on' ? 1 : 0; //
			
				if ($publish_article==1)
					$display_mode=($display_mode | __visible);
				if ($show_in_cats==1)
					$display_mode=($display_mode | __showincats);
				
				if ($page_mode==1)
					$display_mode=($display_mode | __pagemode);
				if ($fullscreen==1)
					$display_mode=($display_mode | __fullscreen);
				if ($default_4_scheme==1)
					$display_mode=($display_mode | __default4scheme);

				$keywords_meta=sanitize($keywords_meta);
				$description_meta=sanitize($description_meta);
			
			
				$meta_subject=cleanText($meta_subject);
				$keywords_meta=cleanText($keywords_meta);
				$description_meta=cleanText($description_meta);
			}
			else
			{
				$frm_DCType='Text';
				$frm_METADocType='0';
				
				$show_in_cats = 0;
				$description = ''; //
				$keywords_meta = ''; //
				$description_meta = ''; //
				$frm_subject= ''; //
				$display_title = 0; //
				$page_mode =  0; //
				$fullscreen = 0; //
				$articleObject='';//actually this is the loader
				
				$default_4_scheme=0;
							
				$ArtCommentMode=0;
				$scheme=0;
				$display_mode = isset($_POST['publish_article']) && $_POST['publish_article'] == 'on' ? 1 : 0; //
			}
			$category = !empty($_POST['define_category']) ? $_POST['define_category'] : 0; //set from categories!!!
																														//is actually the subcat
			
			
			$text = isset($_POST['text']) ? $_POST['text'] : ''; //

			
			//--------------------------------------------------------------- article2Menu--------
			$AMenus=get_Menu2Article($artid);
			
			$AMenusAdd=array();

			$iCount=0;
			
			while ($menFound>0)
			{
				$sTmp='cmbMenu'.$iCount;

				if (isset($_POST[$sTmp]))
				{
			
					$menid=$_POST[$sTmp];
					//msgbox($menid)
					$xTest=array_search($menid,$AMenus);
					if (($xTest===FALSE)&&($menid>=0))
					{
						$AMenusAdd[]=$menid;//add this to the menu2article
					}
					else
					{
						//we don't have to do something on this one because it is already saved
						dropFromArray($AMenus,$xTest);
					}
				}
				else
				{
					$menFound--;
				}
				$iCount++;
			}
			//--------------------------------------------------------------- article2Menu--------
			
			
			if ($VAC>0):
				
				if (isset($_POST['vacshowforce']) && $_POST['vacshowforce']=='on' ):
					$VAC=($VAC | 2);
				endif;
				if (isset($_POST['vacshowleft']) && $_POST['vacshowleft']=='on' ):
					$VAC=($VAC | 4);
				endif;
				if (isset($_POST['vacshowright']) && $_POST['vacshowright']=='on' ):
					$VAC=($VAC | 8);
				endif;
				if (isset($_POST['vacshowbot']) && $_POST['vacshowbot']=='on' ):
					$VAC=($VAC | 16);
				endif;
				if (isset($_POST['vacshowtop']) && $_POST['vacshowtop']=='on' ):
					$VAC=($VAC | 32);
				endif;
			
			endif;
			
			$show_on_home = isset($_POST['show_on_home']) && ($_POST['show_on_home'] == 'on' /*|| $p_osition > 1*/) ? 1 : 0; //

			$article_date = $_POST['fposting_year'].'-'.$_POST['fposting_month'].'-'.$_POST['fposting_day'].' '.
								$_POST['fposting_hour'].':'.$_POST['fposting_minute'].':00';
			//$article_date=qmd_PHP2db($article_date);
			
			$_SESSION['article_save']['title'] = $_POST['title']; // 
			$_SESSION['article_save']['seftitle'] = $_POST['seftitle']; //
			$_SESSION['article_save']['text'] = $_POST['text']; //
						
			$curr_artorder = retrieve('artorder','qmd_articles','id',$artid);
						
			if (!$curr_artorder):
				$artorder = 1;
			else:
				$artorder = $curr_artorder;
			endif;
						
			//$link = $qmd_const_URL_Params[2].'/qmd_articles';
						
			$title=cleanText($title);
			$text=cleanText($text);
			
			if ($artid<0):
				
				$newID=$this->DoCreateArticle($seftitle, 
																$parent,
																$article_date, 
																$category,
																$display_title,
																$ArtCommentMode,
																$display_mode,
																$show_on_home,
																$showdate,
																$artorder,
																$VAC,
																$scheme,
																$articleObject,
																$frm_DCType,
																$frm_METADocType,
																$articleobjectXtra,
																//ML
																$text,
																$title,
																$keywords_meta,
																$description_meta,
																$frm_subject
																);
								
				if ($newID>0):
					$nextRes=NULL;
					$xdummy=0;
					$processStatus=1;
				else:
					$processStatus=-1;
				endif;
				
				for ($iCount=0;$iCount<count($AMenusAdd);$iCount++)
				{
				
					if ($qSQL->prepareinsert(array('menu_id','article_id'),array($AMenusAdd[$iCount],$newID))>0):
						$res=$qSQL->insertSQL(_PRE.'qmd_article2menu',$xdummy);
						if ($res>0):
							
							$processStatus=1;//-1 Error +1ok
						else:
							msgbox('Error Insert article2Menu 2');
							$processStatus=-1;//-1 Error +1ok
						endif;
					else:
						msgbox('Error Insert article2Menu 1');
						$processStatus=-1;//-1 Error +1ok
					endif;
				}
				
				//end of edit article
				if ($processStatus>0):
					if ($this->objectSave($NewID)==TRUE)://this is for derived objects that need to do more on saving!
						$processStatus=$newID;
					else:
						msgbox('Can not save this object!');
					endif;
					
				else:
					msgbox('can not save');
				endif;
			else:
				
				if ($this->DBConnected==TRUE):
					$this->disconnect();//make sure it is connected to the right database
				endif;

				if ($qSQL->prepareupdate(array('seftitle',
																	'date', 
																	'category',
																	'displaytitle',
																	'commentable', 
																	'display_mode',
																	'show_on_home', 
																	'showdate',
																	'artorder',
																	'VAC',
																	'scheme',
																	'objectloader',
																	'DCType',
																	'DOCtypeHTML',
																	'optXtra')
													,array($seftitle, 
																$article_date, 
																$category,
																$display_title,
																$ArtCommentMode,
																$display_mode,
																$show_on_home,
																$showdate,
																$artorder,
																$VAC,
																$scheme,
																$articleObject,
																$frm_DCType,
																$frm_METADocType,
																$articleobjectXtra),
													array('id='),array($artid)
															)>0):
					
					$iRows=0;
					$res=$qSQL->updateSQL(_PRE.'qmd_articles',$iRows);
					if ($res==1):
						
						
						$processStatus=1;//-1 Error +1ok
					else:
						msgbox('error on update article');
						$processStatus=-1;//-1 Error +1ok
					endif;
				else:
					msgbox('error on prepare update article');
					$processStatus=-1;//-1 Error +1ok
				endif;
				
				if ($processStatus>=0):
					
					if ($langID>0):
						if ($qSQL->prepareupdate(array('title',
																	'parent',
																	'lang',
																	'keywords_meta',
																	'description_meta',
																	'subject_meta',
																	'body'),
												array($title,
														$artid,
														$articleLanguage,
														$keywords_meta,
														$description_meta,
														$frm_subject,
														$text),
											array('id='),array($langID))>0):
							$iRows=0;
							$res=$qSQL->updateSQL(_PRE.'qmd_articles_ML',$iRows);
							if ($res==1):
								//$iRows affected
								$processStatus=1;//-1 Error +1ok
							else:
								msgbox('error on update article ml');
								$processStatus=-1;//-1 Error +1ok
							endif;
						else:
							msgbox('error on prepare update article ml');
							$processStatus=-1;//-1 Error +1ok
						endif;
					else:
						//we create a new language
						$xdummy=0;
						if ($qSQL->prepareinsert(array('parent', 'lang','body','title','keywords_meta', 'description_meta '),
																array($artid, $this->_CONTROLLER->language, $text,$title,$keywords_meta,$description_meta))>0):
								
							$res=$qSQL->insertSQL(_PRE.'qmd_articles_ML',$xdummy);
							if ($res>0):
								$processStatus=1;//-1 Error +1ok
							else:
								msgbox('Error Insert article ML 2');
								$processStatus=-1;//-1 Error +1ok
							endif;
						else:
							msgbox('Error Insert article ML 1');
							$processStatus=-1;//-1 Error +1ok
						endif;
												
					endif;
					
					for ($iCount=0;$iCount<count($AMenusAdd);$iCount++)
					{
						insert_article2menu($artid,$AMenusAdd[$iCount]);
					}
					for ($iCount=0;$iCount<count($AMenus);$iCount++)
					{
						delete_article2menu($artid,$AMenus[$iCount]);
					}
					if ($processStatus>0):
						if ($this->objectSave($artid)!==TRUE):
							msgbox('Can not save this object!');
						endif;
					
					else:
						msgbox('can not save');
					endif;
				endif;//end update article
			endif;
			
		endif;
		
		return $processStatus;
				
	}
	function createLangCopy($targetLanguage,$newArtID=-1)
	{
	global $qSQL;
		
		$result=FALSE;
		$this->disconnect();
		
		$aF=array('parent','lang','body','title','keywords_meta','description_meta','subject_meta');
		if (!isset($this->ArticleRow['body']))$this->ArticleRow['body']='';
		if (!isset($this->ArticleRow['title']))$this->ArticleRow['title']='';
		if (!isset($this->ArticleRow['keywords_meta']))$this->ArticleRow['keywords_meta']='';
		if (!isset($this->ArticleRow['description_meta']))$this->ArticleRow['description_meta']='';
		if (!isset($this->ArticleRow['subject_meta']))$this->ArticleRow['subject_meta']='';
		if ($newArtID<0)

			$newArtID=$this->ArticleRow['artid'];
		else
			$this->ArticleRow['title']=$this->ArticleRow['title'].'~copy';

		
		$aV=array(	$newArtID,
						$targetLanguage,
						$this->ArticleRow['body'],
						$this->ArticleRow['title'],
						$this->ArticleRow['keywords_meta'],
						$this->ArticleRow['description_meta'],
						$this->ArticleRow['subject_meta']);
		$iNewID=0;
		if ($qSQL->prepareinsert($aF,$aV)>0):
			$res=$qSQL->insertSQL(_PRE.'qmd_articles_ML',$iNewID);
			if ($res==1):
				//iNewID is the new ID
				$result=$iNewID;
				
			else:
				//error on isert
				msgbox('could not create copy of article ML');
			endif;
		else:
			//error
			msgbox('could not create copy of article ML [0]');
		endif;
		
		return $result;
	}
	function createArticleCopy($targetLanguage)
	{
		global $qSQL;
		
		$result=FALSE;
		$this->disconnect();
		
		/*
		art_parent 	
		seftitle 	
		date 	
		category 	
		display_mode 
		displaytitle 
		commentable 
		show_on_home
		artorder 	
		default_page
		showdate 	
		VAC 	
		scheme 
		objectloader 	
		DCType 	
		DOCtypeHTML
		*/
		$aF=array('art_parent','seftitle','date','category','display_mode','displaytitle','commentable','show_on_home',
					'artorder','default_page','showdate','VAC','scheme','objectloader','DCType','DOCtypeHTML');
		$aV=array($this->ArticleRow['art_parent'],$this->ArticleRow['seftitle'].'~copy',$this->ArticleRow['date'],
					$this->ArticleRow['category'],$this->ArticleRow['display_mode'],$this->ArticleRow['displaytitle'],
					$this->ArticleRow['commentable'],$this->ArticleRow['show_on_home'],$this->ArticleRow['artorder'],
					$this->ArticleRow['default_page'],$this->ArticleRow['showdate'],$this->ArticleRow['VAC'],
					$this->ArticleRow['scheme'],$this->ArticleRow['objectloader'],$this->ArticleRow['DCType'],$this->ArticleRow['DOCtypeHTML']);
		$iNewID=0;
		if ($qSQL->prepareinsert($aF,$aV)>0):
			$res=$qSQL->insertSQL(_PRE.'qmd_articles',$iNewID);
			if ($res==1):
				//iNewID is the new ID
				$result=$iNewID;
				
				$this->createLangCopy($this->ArticleRow['lang'],$result);
			else:
				//error on isert
				msgbox('could not create copy of article');
			endif;
		else:
			//error
			msgbox('could not create copy of article [0]');
		endif;
		
		return $result;
	}

	}//Article Object qmd_base_article 
	//**************************************************************************************
	//**************************************************************************************
	class qmd_form_article extends qmd_base_article
	{
		var $POSTID;
		var $postmode;
		var $frm_action;
		
		function __construct($controller,$BaseRec,$tablename='',$dbName=''){
			parent::__construct($controller,$BaseRec,$tablename='',$dbName='');
			$this->POSTID='A87DF012DD';
			$this->postmode=1;
			$this->frm_action='/'.$this->ArticleRow['seftitle'].'?mode=pc';//preservecaptcha
			
		}
		function displayArticle($mode=1)//this is always 1 here there is no preview
		{
			
			if (isset($_POST[$this->POSTID]))
				$this->doPostForm();
			else
			{
				$this->initArticleShow();
				$this->connect();
			
				//$result=$this->ArticleShow($Mode);
				$this->doShowForm();
			}
			
			
			$result=$this->articleFinalize();
				
			return $result;
		}
		function doShowForm()//You need to override this in order to do something regarding YOUR objects!
		{
			$result=-1;
			
			$sCSS='qmd_article_box';
			echo '<div class="'.$sCSS.'">';
			$this->showArticleHead($Mode);//////////////  HEAD  ///////////////////////////////////////////////////////////
			echo html_input('form', '', 'post', '', '', '', '', '', '', '', 'post', $this->frm_action);
			echo '<fieldset>';
			//--------------------------------------------------------------------------------------
			//we do not distinguish here between teaser and article
			//you can do it nicely on your own.
			
			$this->showArticleTeaser($Mode);//////////////  TEASER //////////////////////////////////////////////////////////
			
			$this->showArticleBody();//////////////  BODY  ////////////////////////////////////////////////////////////////
				


			$this->disconnect();
				
			//--------------------------------------------------------------------------------------
			echo html_input('hidden', $this->POSTID, $this->POSTID, $this->POSTID, '');
			echo html_input('submit','submit_form','submit_form',l('submit'),$frm_action);
			echo '</fieldset>';
			echo '</form>';
			echo '</div>';
			echo '<p class="qmd_article_spacer"></p>';
			return $result;
		}
		
		
		function doPostForm()//You need to override this in order to do something regarding YOUR objects!
		{//$mode =1 -> send mail to default adress
		// other modes (0,2 and 3) are reserved you can use other values and handle for yourself
			unset($_POST[$this->POSTID]);
			switch ($this->postmode):
				case 1:
					$sTxt='This is the information from auto article message'."\r\n";
					$sTxt.='[foo1] ==> baz'."\r\n";
					foreach ($_POST as $key => $value)://
						$sTxt.='['.$key.'] ==> '.$value."\r\n";
						
					endforeach;
					$sTxt.='[foo8] ==> bar'."\r\n";
					qmd_eMail(s('website_email'),s('contact_subject'),$sTxt,'');
					
					break;
				default:
			
					$result=-1;
			endswitch;
			return $result;
		}
	}
?>