<?php
/*
	Program: qmd-cms [qimanfaya-Menu-Driven-CMS]
	
	------------------------------
   qmd-cms - center and article
	qmd-cms 0.8.7
	last update: 05/01/2014

	--------------------------------

	qmd_article.php
	=============

	This file is part of the qmd-php-library
	
	Author: ***hy
	For further reference regarding this code see qmdcms.php and the readme-files.
	
	This code was developed by ****hy
	Copyright: qimanfaya/hy-soft 2012,2014
	
	Licence:		GPL V.3

	A copy of the GNU General Public License is available:
	in the root of this folder
	and on the World Wide Web
	at <http://www.gnu.org/licenses/gpl-3.0.txt>. You can also obtain it by writing
	to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
	MA 02111-1307, USA.
			

*/

function center()
{
	global $qmdC;
	global $qmd_const_URL_Params;
	
	$lDone=FALSE;
	
	$action = ''; //
	
	$sact=$qmdC->get_Func();
	
	if (!isset($_SESSION[_SITE.'/return2']))
		$_SESSION[_SITE.'/return2']=$qmdC->get_ValidURI(1);
	
	/*
	Any internal function must set a BOOLEAN result!
	If processed the result should be set to TRUE
	If there should be more processing 
		- set result to FALSE
		- set $qmdC->SEF to something reasonable in order to continue processing or use 401, 404 etc.
	*/
	
	if (!empty($sact)):
	
		if (is_callable ( $sact )==true):
			if ($sact=='qmd_notify')://this is probably set by runtime
				qmd_notify(5,'');
				$lDone=TRUE;
			else:
				
				$lDone=$sact();
			endif;
		else:
			
			$lDone=TRUE;
			
			echo '<p class="qmd_under_construction">'.l('error_404').'</p>'; // Patch #404 
		endif;
	endif;
	if (!$lDone):
		
		$action=$qmdC->get_SEF();
		
		if(empty($action)):
			$sact=$qmdC->get_UParamByName('action');
		endif;
		
		switch($qmdC->get_Mode()):
			
			case 2:
				if ($qmdC->get_userPermission(__USER_isAdmin)>0):
					
					admin_center();
					$lDone=TRUE;
					break;
				endif;
				$lDone=TRUE;
				break;
			case 3:
				login();
				$lDone=TRUE;
				break;
			case 4:
				logoff();
				$lDone=TRUE;
				break;
			case 5:
				//moderation();
				if ($qmdC->get_userPermission(__USER_isMod)>0):
					
					admin_center();	//the difference is handled in administration
					$lDone=TRUE;
				else:
					$action='404';
				endif;
				break;
			case 6:
				$lDone=TRUE;
				if ($qmdC->get_user()>=__USER_isUser):
					
					if ($action=='showuser'):
						$idu=$qmdC->get_UParamByName('uid');
						if ($idu>0)
							{userpanel($idu);}
						else
							{$lDone=FALSE;
							$action='404';
						}
					else:
						userpanel();
					endif;
					
				else:
					$lDone=FALSE;
					$action='404';
				endif;
				break;

		endswitch;
		if (!$lDone):
			
			switch ($action):
				case 'search_query':
					search(); 
					break;
				case 'savecomment':
					
					_save_comment();
					break;
				case 'checklogin'://this is where the login takes place
					
					if ($qmdC->uid>0):
						$aLBL=array(l('userpanel'),l('backhome'),l('backlastpage'));
						$aTRG=array('/userpanel','/',$_SESSION[_SITE.'/return2']);
						
						if ($qmdC->get_userPermission(__USER_isAdmin)>0):
						
							$aLBL[]=l('administration');
							$aTRG[]='/'.$qmd_const_URL_Params[2];
						else:
							if ($qmdC->get_userPermission(__USER_isMod)>0):
								$aLBL[]=l('moderation');
								$aTRG[]='/'.$qmd_const_URL_Params[5];
							endif;
						endif;

						qmd_notify(0,l('logged_in'),$aLBL,$aTRG);
						unset($_SESSION[_SITE.'/return2']);

					else:
						echo '<p class="qmd_under_construction">'.l('error_404').'</p>'; // Patch #404 
					endif;
					break;
				case 'comment':
					
					comment($qmdC->get_ID);//,'comment_posted'); 
					break;
				case 'contactform'://never makes it to here cause it's a (F)
				case 'contact':
					
					contact(); 
					break;
					
				case 'submit_text':
					processing(); 
					break;
			
				//case 'archive':	//this is disabled ATM
				//	archive(); break;
				case 'sitemap':
					sitemap(); 
					break;
				
				case 'login':

					login(); break;
				case '400':
					$qmdC->menushowNext();
					echo '<p class="qmd_under_construction">'.l('error_400').'</p>'; // Patch #400
					//sitemap(); 
					break; // 
				case '401':
					$qmdC->menushowNext();
					echo '<p class="qmd_under_construction">'.l('error_401').'</p>'; // Patch #401
					//sitemap(); 
					break; // Patch #404 show sitemap with message.
				case '404':
					$qmdC->menushowNext();
					echo '<p class="qmd_under_construction">'.l('error_404').'</p>'; // Patch #404 
					//sitemap(); 
					break; // Patch #404 show sitemap with message.
				default:
					articles(); 
					break;
			endswitch;
		endif;
	endif;
	
}

// ARTICLES

// *******************************************************************************************
function default_display_article()
{
global $qmdC;
	
	$AO=$qmdC->qmdA();
	if (!is_null($AO))	
	{
		if ($AO->displayArticle()==FALSE)//try showing the article
			qmd_die('ERROR showing this Article!');
	}
	else
	{
		qmd_die('no Article-Object in Controller | default_display_article');
	}
}
function show_articles($aArticles)
{
global $qmdC;
	$result=0;

	$result=count($aArticles);

	switch ($result):
		case 0:
			
			if ($qmdC->get_SEFActive()>0):

				$F=$qmdC->get_SEF();
				$F();
			else:
				echo l('error_204');
			endif;
			break;
		case 1:
			
			default_display_article();
			
			break;
		default:	
			
			$qmdC->showArticlesFromList();
			
			
	endswitch;
	
	
	return $result;
}
// *******************************************************************************************
// *******************************************************************************************
function articles()
{
	global $qmdC;

	$ARTICLES=$qmdC->get_aArticles();

	if (count($ARTICLES)==0):
		if ($qmdC->get_ID()>0):
			$ART[0]=$qmdC->get_ID();
		endif;
	endif;
	$qmdC->menushowNext();
	
	show_articles($ARTICLES);
	
	return;
}


?>