<?php
/*
	Program: qmd-cms [qimanfaya-Menu-Driven-CMS]
	
	------------------------------
   qmd-cms - categories Library File 
   qmd-cms 0.8.7
	last update: 05/06/2014

	--------------------------------

	qmd_categories.php
	=============

	This file is part of the qmd-php-library
	
	Author: ***hy
	For further reference regarding this code see qmdcms.php and the readme-files.
	
	This code was developed by ****hy
	Copyright: qimanfaya/hy-soft 2012,2014
	
	Licence:		GPL V.3

	A copy of the GNU General Public License is available:
	in the root of this folder
	and on the World Wide Web
	at <http://www.gnu.org/licenses/gpl-3.0.txt>. You can also obtain it by writing
	to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
	MA 02111-1307, USA.
			

*/

// LISTS CATEGORIES
// DISPLAY CATEGORIES

//categories() doesn't work
function categories($useLI=FALSE,$startFromParent=0,$level=0) 
{//used to display an overview for all categories similar to sitemap
	global $qmd_categoryLIcurrent, $qmd_categoryLI;
	global $qmdC;
	global $qmd_Lang_ANY;
	
	$result=TRUE;
	
	if ($useLI===TRUE):
		$sLI='<li>';
		$sLIend='</li>';
	else:
		$sLI=htmlspacer(3);
		$sLIend='';
	endif;

	$iDBStatus=0;
	$iRowCount=0;
	$iDBStatus2=0;
	$iRowCount2=0;
	$sql=query_get_cat().' WHERE parent = '.$startFromParent;
	if ($qmdC->get_userPermission(__USER_isMod)==0)://if not mod show only published
		$sql.=' AND c.published = 1 ';
	endif;
	$sql.=' GROUP BY c.id
			ORDER BY c.catorder,c.id';

	$rows = getSQL($sql,$iDBStatus,$iRowCount);

	if ($level==0):
		echo '<h2>'.l('cat_overview').'</h2>';
	endif;
	if ($iDBStatus>=0):


		for ($iCount=0;$iCount<$iRowCount;$iCount++):
			
			$rec=$rows[$iCount];
			
			$category_title = $rec['catlink'];

			$rec['name']=$rec[$qmdC->language];
			$sqlart=query_get_art(7).' AND category = '.$rec['catid'].' AND ((lang="'.$qmdC->language.'") OR (lang="'.$qmd_Lang_ANY.'"))
									AND ((display_mode & '.__showincats.')>0)
									AND (date<=NOW())';
			$rowsart = getSQL($sqlart,$iDBStatus2,$iRowCount2);
			
			
			echo '<div class="qmd_catpanel">';
				$isubCats=count_table_entries('qmd_categories', 'id', 'where parent='.$rec['catid'].' AND published=1');
				
				$sMargin=($level*20).'px;';
				if ($level==0):
					$sSub='';
				else:
					$sSub='<b>'.l('subcat1').': </b>';
				endif;
				if ($level>0)
					echo '<div class="qmd_catcontainer">';
				echo '<div class="qmd_catEntry" style="margin-left:'.$sMargin.'">';
				if ($isubCats>0):
					$linkTo='<a onclick="toggle(\'qmd_cat'.$rec['catlink'].'\')" style="cursor: pointer;">';
					$closeLink='</a>';
				else:
					$linkTo='';
					$closeLink='';
				endif;
				
				echo $linkTo.gethtmlspacer($level*4).'<b>'.$sSub.$rec['name'].'</b>';
				//if ($isubCats>0)
				if ($isubCats==1)
					echo '('.$isubCats.' '.l('subcat1').' )';
				else
					echo '('.$isubCats.' '.l('subcats').' )';
				echo $closeLink;
				
				if (count($rowsart)>0):
					$linkTo='<a onclick="toggle(\'qmd_cat'.$rec['catlink'].'\')" style="cursor: pointer;">';
					$closeLink='</a>';
				else:
					$linkTo='';
					$closeLink='';
				endif;
				
				echo $linkTo.'['.$iRowCount2.' '.l('articles').']';
				
				echo $closeLink;
				
				echo '</div>';
				if ((count($rowsart)>0) ||($isubCats>0)):
					echo '<div id ="qmd_cat'.$rec['catlink'].'" style="display:none;">';
					echo '<div class="qmd_catcontainer">';
				
					for ($jCount=0;$jCount<$iRowCount2;$jCount++):
						$ra=$rowsart[$jCount];
						echo '<p>'.qmd_createLink('/'.$ra['seftitle'],
															$ra['title'],$ra['title'],1,0,1)
															.'</p>';
					endfor;
					if ($isubCats>0):
						categories($useLI,$rec['catid'],$level+1); 
					endif;
					echo '</div></div>';
				endif;
				if ($level>0)
					echo '</div>';
			echo '</div>';//qmd_catpanel
			//subcategories($parent,$sLI,$sLIend);
		endfor;
		if ($level==0):
			echo '<br/>';
			echo qmd_createLink('/sitemap',
										l('try_sitemap'));
		endif;
	else:
		echo $sLI.l('no_categories').$sLIend;
	endif;
	return $result;

}



// DISPLAY dropdown menu; CATEGORIES with dropdown Articles
function categories_dropdown($useLI,$maxcats=5,$maxpercat=4,$showmore=1,$startFrom='') 
{

global $qmd_categoryCurrent, $qmd_categoryHead,$qmd_categoryItem,$qmd_categoryUL;
global $qmd_const_URL_Params;
global $qmdC;
global $qmd_const_URL_Params;
global $qSQL;
	$result=0;
	
	//$useLI=TRUE;
	if ($useLI===TRUE):
		$sLIlvl2='<li>';
		$sLIlvl2end='</li>';
		$sLI='<li>';
		$sLIend='</li>';
		$sUL='<ul>';
		$sULend='</ul>';
	else:
		
		$sLIlvl2='<div class="'.$qmd_categoryItem.'">';
		$sLIlvl2end='</div>';
		$sLI='<div class="'.$qmd_categoryHead.'">';
		$sLIend='</div>';
		$sUL='<div class="'.$qmd_categoryUL.'">';
		$sULend='</div>';
		
	endif;
	
	$parentID=-1;
	
	if (!empty($startFrom)):
		
		$xID=0;
		$sql='SELECT id from '._PRE.'qmd_categories WHERE catlink=?';
		$rows=$qSQL->qSQLdirect($sql,array($startFrom),$xID);
		
		if ((is_array($rows))&&(count($rows)>0)):
			$parentID=$rows[0]['id'];
		else:
			$parentID=-2;
		endif;
	endif;
	
	if ($parentID==-2):
		
		echo '<h3>'.qmd_createLink('/cat',l('cat_overview')).'</h3>';
		echo $sUL;//'	<div class="qmd_categoryUL">';
		echo '		<div class="qmd_categoryHead">';
		echo 				qmd_createLink('/cat/uncategorized',l('uncategorized'));
		echo '		</div>';
		echo '</div>';
					
	else:
		echo '<h3>'.qmd_createLink('cat/',
											l('categories'))
											.'</h3>';
		$query=query_get_cat().' WHERE published = 1';
		if ($parentID>0):
			$query.=' AND parent='.$parentID .' OR c.id='.$parentID;
		endif;
		$query.=' ORDER BY catorder ASC';
		
		$iDBStatus=0;
		$iRowCount=0;

		$rows = getSQL($query,$iDBStatus,$iRowCount);
		
		if (is_array($rows)&&count($rows)>0):
			$result=count($rows);
			$iCount=0;
			echo $sUL;
			if ($maxcats<0):
				$maxcats=count($rows);
			else:
				if ($maxcats>count($rows)):
					$maxcats=count($rows);
				endif;
			endif;

			while (($iCount<$maxcats)&&($iCount<count($rows))):
				$r=$rows[$iCount];
				
				$calc_num_query = query_get_art(7).' AND category = '.$r['catid']
										.' AND lang="'.$qmdC->language.'"  ORDER BY date DESC';
				if ($maxpercat>0):
					$calc_num_query.=' LIMIT 0, '.$maxpercat; 
				endif;	
				$cm_result = getSQL($calc_num_query,$iDBStatus,$iRowCount);
				
				if ($iDBStatus>=0):
					if ($iRowCount > 0):
						$target=$qmd_const_URL_Params[1].'/'.$r['catlink'];
						$title=$r['description'];
						$text=$r[$qmdC->language];
						if (s('num_categories')==1):
							$text.=' ('.$iRowCount.')';
						endif;
						
						$sOut=qmd_createLink($target,$text,$title);
						
						echo $sLI.$sOut.$sLIend."\r\n";
						echo $sUL."\r\n";
						
						$sOut='';
						$jCount=0;
						
						while ($jCount < $iRowCount):

							$art=$cm_result[$jCount];
							
							$sOut.= $sLIlvl2.qmd_createLink($target.'/'.$art['seftitle'],
																		$art['title'],
																		$art['title'])
																		.$sLIend."\r\n";
							$jCount++;
						endwhile;//while
						echo $sOut.$sULend."\r\n";

					else:
						$maxcats++;
					endif;
				else:
					msgbox('Error on retrieving articles for Category '.$r['id'].' Status: '.$iDBStatus);
				endif;
				$iCount++;
			endwhile;//while
			if ($qmdC->get_URI(0)!=$qmd_const_URL_Params[1]):
				echo $sLI.qmd_createLink('cat/',
												'more...')
												.$sLIend;
			endif;
			echo $sULend;
			
			echo "\r\n \r\n <!-- end category listing -->";
		endif;
	endif;
	return $result;
}//caegories_dropdown

function _fill_category_combo($maxlevel,$parent,$default_cat,$curlevel)
{	//TODO this needs some optimization. But is used in admin mode only.
	//So the performance is not prioritized...
	
	global $qmdC;
	
	$category_query = query_get_cat().' WHERE published = 1';// AND lang='.$qmdC->language;
	$category_query = $category_query.' AND c.parent = '.$parent.'  ORDER BY catorder,id ASC';
	
	$iDBStatus=0;
	$iRowCount=0;
			
	$category_result = getSQL($category_query,$iDBStatus,$iRowCount);
	for ($iCount=0;$iCount<$iRowCount;$iCount++):
		$cat = $category_result[$iCount];
			
		echo '<option value="'.$cat['catid'].'"';
		if ($default_cat == $cat['catid']):
			echo ' selected="selected"';
		endif;
		if ($curlevel==0):
			echo '>'.$cat[$qmdC->language].'</option>';
		else:
			echo '>'.str_repeat('--- ',$curlevel).$cat[$qmdC->language].'</option>';
		endif;
		if (($curlevel<$maxlevel)||($maxlevel==0)):
			
			_fill_category_combo($maxlevel,$cat['catid'],$default_cat,$curlevel+1);
		endif;
		
	endfor;
}
function create_category_combo($maxlevel,$default_cat,$label='',$OnChange='onchange="dependancy(\'qmd_articles\')"',$showNoSubCat=0,$showLabelabv=false)
{
	
	if ($label==''):
		$label=l('category');
	endif;
	$selected =' selected="selected"';
	
	echo '<p><label for="cat">';
	echo $label;
	echo ':</label>';
	if ($showLabelabv==true):
		echo '<br />';
	else:
		echo '&nbsp;&nbsp;&nbsp;&nbsp;';
	endif;
	
	echo '<select name="define_category" id="cat" '.$OnChange.'>';
	
	if ($default_cat<0):
		$parent_selection = $selected;
	else:
		$parent_selection ='';
	endif;
	
	if ($showNoSubCat<>0):
		echo '<option value="0"'.$parent_selection.'>'.l('not_sub').'</option>';
	endif;
	
	_fill_category_combo($maxlevel,0,$default_cat,0);
	
	echo '</select></p>';
}
?>