<?php
/*
	Program: qmd-cms [qimanfaya-Menu-Driven-CMS]
	
	------------------------------
   qmd-cms - comments Library File 
   qmd-cms 0.8.7
	last update: 05/01/2014

	--------------------------------

	qmd_comments.php
	=============

	This file is part of the qmd-php-library
	
	Author: ***hy
	For further reference regarding this code see qmdcms.php and the readme-files.
	
	This code was developed by ****hy
	Copyright: qimanfaya/hy-soft 2012,2014
	
	Licence:		GPL V.3

	A copy of the GNU General Public License is available:
	in the root of this folder
	and on the World Wide Web
	at <http://www.gnu.org/licenses/gpl-3.0.txt>. You can also obtain it by writing
	to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
	MA 02111-1307, USA.
			

*/

function _save_comment(){
	
	global $qmdC;
	global $qSQL;
	global $qmd_const_URL_Params;
	
	$aErrors=array();
	//$status=0;	//-1 error	0=some error 1= ok post comment
	//clean up the comment
	$comment = trim($_POST['text']);
	
	$comment = clean(cleanXSS($comment,0));
	
	$comment = cleanText($comment);
	
	if (strlen($comment) < 4 )
	{
		$aErrors[]=l('comment2short');
		$commentReason=l('comment2short');
	}
	else
	{
		
		$post_article_id = (is_numeric($_POST['id']) && $_POST['id'] > 0) ? $_POST['id'] : null;
		
		
		if ($post_article_id==NULL):
			$post_article_id=$qmdC->get_ID();
		endif;

		$ip = (strlen($_POST['ip']) < 16) ? clean(cleanXSS($_POST['ip'])) : null;
		
		if (
				(isset($_POST['uid']))
			&&
				($_POST['uid']==$qmdC->get_uid())
				):
			
			$uid=$_POST['uid'];
		
		
			$name = retrieve('uname','qmd_users','id',$uid);
		
			if (empty($name)):
				$doublecheck=1;//do doublecheck
				$uid=-1;			//reset
			else:
				$doublecheck=0;//no doublecheck
				
			endif;
		else:
			//these are only set for unregistered users
			$uid=-1;
			
			$url = substr($url, 0, 3) == 'www' ? 'http://'.$url : $url;
			
			$name = trim($_POST['name']);
			$name = preg_replace('/[^a-zA-Z0-9_\s-]/', '', $name); // 
			if (empty($name)) { $name = 'Anonymous'; }
			else{$name = strlen($name) > 1 ? clean(cleanXSS($name)) : null;}
			
			if (!isset($_POST['eMail'])):
				$aErrors[]=l('ce_reasons_unfilledReqField').' (eMail)';
			else:
				$eMail= $_POST['eMail'];
			
				if (!check_eMail($eMail)):
					$eMail='';
					$aErrors[]=l('Invalid_eMail_submitted');
				endif;
			
				if (is_null($name)):
					$aErrors[]=l('ce_reasons_unfilledReqField').' (Name)';
					
				else:
					
					$checkname = retrieve('uname','qmd_users','uname',$name);
					if (!empty($checkname)):
						
						$aErrors[]=l('UserIsRegistered');
					endif;
				endif;
				
			endif;
			
			if (!checkMathCaptcha()):
				$aErrors[]=l('ce_reasons_captcha');
			endif;
			
		endif;
		if (isset($_POST['parentcomment']))
		{
			$parentcomment=$_POST['parentcomment'];
			if ($parentcomment<1)
				$parentcomment=NULL;
		}
		else
			$parentcomment=NULL;
		
		/*
		$l['ce_reasons_unfilledReqField']='A required field is blank.';
		$l['ce_reasons_comment2short']='The comment is too short.';
		$l['ce_reasons_captcha']='You haven\'t entered the right math captcha code.';
		$l['ce_reasons_dublette']='You have tried to post identical messages too quickly on this article.';
		*/
		
		
		if ($uid<0):
			$contentCheck = retrieve('id', 'qmd_comments', 'comment', $comment);
			
			$ident = !$contentCheck || (time() - $_SESSION[_SITE.'/poster']['time']) > s('comment_repost_timer') ||
										$_SESSION[_SITE.'/poster']['ip'] !== $ip ? 1 : 0;
										
			$doublecheck = $_SESSION[_SITE.'/poster']['article'] === "$comment:|:$post_article_id" &&
						(time()-$_SESSION[_SITE.'/poster']['time']) < s('comment_repost_timer') ? 0 : 1;
			if ($ip == $_SERVER['REMOTE_ADDR'] && $comment && $name && $post_article_id  &&
								$doublecheck == 1 && $ident == 1):
			else:
				$aErrors[]='some Error - or you are not allowed to post comments...';
			endif;
								
		endif;
		/*
		echo $ip."\r\n";
		echo $_SERVER['REMOTE_ADDR']."\r\n";
		echo $comment."\r\n";
		echo $name."\r\n";
		echo "PA: ".$post_article_id."\r\n"."---";
		echo $doublecheck."\r\n";
		echo $ident."\r\n";
		*/
		if (count($aErrors)==0):


			$url = trim($_POST['url']);
			
			$url = preg_replace('/[^a-zA-Z0-9_:\/\.-]/', '', $url); 
			
			unset($_SESSION[_SITE.'/poster']);
			$approved = s('approve_comments') == 0 ? 1 : 0;
			if ($qmdC->get_user()>=__USER_isUser):
				$name='';
				$url='';
				if ($qmdC->get_user()>=__USER_is2ndLevel)
					$approved=1;
			endif;
			
			if ($qSQL->prepareinsert(array('articleid', 'name', 'url', 'comment', 'approved','userid','eMail','lang_used','ip','answer2comment'),
												array($post_article_id, $name, $url, $comment, $approved,$qmdC->get_uid(),$eMail,$qmdC->language,$_SERVER['REMOTE_ADDR'],$parentcomment))>0):
				$res=$qSQL->insertSQL(_PRE.'qmd_comments',$iNewID);
				if ($res==1):
					//iNewID is the new ID
					
					$link=qmd_createLink('/'.$qmd_const_URL_Params[2].'/?action=comment%26task=editcomment%26commentid='.$iNewID,
												l('edit'));
				else:
					//TODO qmd_notify
					msgbox('oops - failed saving the comment!');
				endif;
			else:
				//TODO qmd_notify
				msgbox('ERROR on saving the comment!');
			endif;
			$_SESSION[_SITE.'/poster']['article']="$comment:|:$post_article_id";
			$_SESSION[_SITE.'/poster']['time'] = time();
			// this is to set session for checking multiple postings.
			$_SESSION[_SITE.'/poster']['ip'] = $ip;
			$commentStatus = $approved== 0 ? l('comment_sent_approve') : l('comment_sent');
			// eMAIL COMMENTS
			if ((s('mail_on_comments') == 1) && ($approved<1)):
			
				if (s('approve_comments') == 'on')
				{
					$status = l('approved_text');
					$subject =l('subject_a');
				}
				else
				{
					$status = l('not_waiting_approved');
					$subject =l('subject_b');
				}
				$to = s('website_email');
				$send_array = array(
					'to'=>$to,
					'name'=>$name,
					'comment'=>$comment,
					'ip'=>$ip,
					'url'=>$url,
					'subject'=>$subject,
					'status'=>$status,
					'link'=>$link);
				//****************SEND eMail
				$x=send_email_c($send_array);
				if ($x==false):
					msgbox('Error sending mail!');
					
					send_sys_message('Error sending Mail (comment)','Can not send eMail from comment');
				endif;
			endif;
			// End of Mail
		
		else:
			//output errors
			$commentStatus = l('comment_error');
			echo '<ul>';
			foreach($aErrors as $item):
				echo '<li>'.$item.'</li>';
			endforeach;
			echo '</ul>';
			//$commentReason = l('ce_reasons');
			
			$_SESSION[_SITE.'/comment']['name'] = $name;
			$_SESSION[_SITE.'/comment']['comment'] = br2nl($comment);
			$_SESSION[_SITE.'/comment']['url'] = $url;
			$_SESSION[_SITE.'/comment']['fail'] = true;
		endif;
	}
	echo '<h2>'.$commentStatus.'</h2>';
	if (count($aErrors)>0):
		
		echo '<p>'.$commentReason.'</p>';
	
	endif;
	
	
	//$back_link=$_SERVER['HTTP_REFERER'];
	$articleTITLE = retrieve('title', 'qmd_articles', 'a.id', $post_article_id);
	$articleSEF = retrieve('seftitle', 'qmd_articles', 'a.id', $post_article_id);
	//$parentcomment;
	$back_linkA='/'.$articleSEF;
	$back_linkC='/'.$articleSEF.'?commentid='.$parentcomment;
	if (count($aErrors)>0):
	
		qmd_notify(2, $aErrors[0] ,array(l('back2answeredComment'),l('back2answeredArticle')),array($back_linkC,$back_linkA));
	
	else:
		qmd_notify(0, l('Comment_saved') ,array(l('back')),array($back_link));
		
 	endif;

}

function countComments($aid,$curLang=1)//this (F) is not used anymore - now the article itself will be counting comments
{ 
global $qmdC;
global $qSQL;
global $qmd_Lang_ANY;	

	$result=0;
	$totalrows = 'SELECT count(id) AS num FROM '._PRE.'qmd_comments
						WHERE articleid = ? AND approved = ?';
	if ($curLang>0)
		$totalrows.=' AND lang_used=? OR lang_used=?';
	
	$aSQL=array($aid,1,$qmd_Lang_ANY,$qmdC->language);
	
	$rowsresult=$qSQL->qSQLquick($totalrows,$aSQL);
	
	if (is_array($rowsresult)):
		$result = $rowsresult[0]['num'];
	
	endif;
	
	return $result;
}
function formatcomment($title,$comment,$Mode,$uname='',$stringlen=30)
{//$Mode = 0 teaser for new_comments
	//$Mode =1 transX for display comment
	//$Mode =2 transX for quote comment
	
	$result=$comment;
	switch ($Mode):
		case 0:
			//debuglog($result,'original');
			
			$result = preg_replace('/\[QUOTE(.+)\[\/QUOTE\]/', '', $result);
			$result=$title .' ' .$result;
			//debuglog($result,'1');
			$result = strlen($result) > $stringlen ? substr($result, 0, $stringlen - 3).'...' : $result;
			//debuglog($result,'2');
			$result = str_replace(' ...', '...', $result);
			//debuglog($result,'3');
			
			break;
		case 1:
			//debuglog($result,'original');
			$result = preg_replace('/<br \/>rn/U','<br/>', $result); // 
			$sPattern='\\';
			$result = preg_replace('/'.$sPattern.'r'.$sPattern.'n/U','<br/>', $result); // 
			//debuglog($result,'phase 1');
			$result = preg_replace('/\[QUOTE=\"(.+)\"\]/U', '[QUOTE="<strong>$1</strong>"] ', $result); // 
			//debuglog($result,'phase 1');
			$result = preg_replace('/\[QUOTE=\"(.+)\"\]/U', '<span class="qmd_comment_quote">$1: ', $result); // 
			//debuglog($result,'phase 2');
			$result = preg_replace('/\[\/QUOTE]/U', '</span>', $result); // 
			//debuglog($result,'phase 2');
			break;
		case 2:
			$result='[QUOTE="'.$uname.'"]'.$result.'[/QUOTE]';
			break;
	endswitch;
	return $result;
}
function __doshowThisComment($reccom,$asef,$level,$Mode,$targetcomment=-1,$answerMode,$iCount=0,$DEBUG=FALSE)
{//$Mode =1 frozen
//$Mode = commentable
global $qmd_const_URL_Params;
global $back_to_page;//TODO this is crap!!!
	
global $qmdC;
global $qSQL;
	
	$result=0;//turns to 1 if a commentbox was displayed
	
	if (is_null($reccom['answer2comment']))//we may not increase this if below 0
		$displayAnswerMode=-1;//this is default for root comments
	else
		$displayAnswerMode=1;//this is default for answers to comments
	$title=$reccom['title'];
	$df=s('date_format');
	$date = date($df, strtotime($reccom['time']));
	
	$day=date('N', strtotime($reccom['time']))-1;
	
	$Days=explode(', ',l('day_names_short'));
	$date=$Days[$day].' '.$date;
	
	if (empty($reccom['uname']))
		$name = $reccom['name'];
	else
		$name=qmd_createLink('/user?action=showuser%26uid='.$reccom['userid'],$reccom['uname']);
	
	if (empty($reccom['url'])):
		$sURL='';
	else:
		$_ss=$reccom['url'];
		$Pos=strpos($_ss,'www.');
		
		if ($Pos==false)
			{$_ss=substr($_ss,0,15).'...';}
		else
			{$_ss=substr($_ss,$Pos+1,15).'...';}
		
		$sURL=qmd_createLink('/'.$reccom['url'],$_ss,l('usersHP')); 
	endif;
	$user= '<a id="comment'.$reccom['coid'].'">&nbsp;'.$name.'<br/>';
	$user.=$sURL;
	if ($reccom['coid']==$targetcomment)
	{
		$user='<div class="qmd_highlightcomment">'.$user.'</div>';
	}
	//------------------------------------------------------------
	if ($iCount % 2)
		$sClass='qmd_commentblockOdd';
	else
		$sClass='qmd_commentblockEven';
	$DaComment=$reccom['comment'];
	if ($level>0)
	{
	
		$sClass='qmd_commentblockLevel2';
		$x=ypos('[QUOTE=',$DaComment);
		if (($x>=0) && ($displayAnswerMode>0))
		{	
			$displayAnswerMode=2;//this is just the logo showing quote or answer at the left side!
			$DaComment=formatcomment($reccom['title'],$DaComment,1);
		}
	}
	echo '<tr class="'.$sClass.'">';
		if ($level==0)
			echo '<td class="qmd_comment_left" colspan="2">';
		else
		{	echo '<td class="qmd_comment_leftQuote">';
				if ($displayAnswerMode==2):
					echo '<img src="/dev.img/quote.png">';
				else:
					echo '<img src="/dev.img/answer.png">';
				endif;
			echo '</td>';
			echo '<td class="qmd_comment_left">';
		}
			echo $user;
		echo '</td>';
		echo '<td class="qmd_comment_main">';
			echo '<table border="0" width="100%">';
			echo '<colgroup>
				<col width="75%" />
				<col width="25%" />
				</colgroup>';

			echo '<tr class="qmd_commentHead"><td>'.$title.'</td><td class="qmd_commentDate">'.$date.'</td>';
			echo '</tr>';
			echo '<tr><td class="qmd_commentBody" colspan="2">';
				echo $DaComment;
			echo '</td></tr>';
			
				echo '<tr><td>&nbsp;</td><td>';
				if ($qmdC->get_userPermission(__USER_isMod)>0):
					$sEdit='<a href="/'.$qmdC->language.'/'.$qmd_const_URL_Params[2].'/?action=comment';
					$sEdit.='%26task=editcomment%26commentid='.$reccom['coid'].'"
							title="'.l('edit').' '.l('comment').'"><img src="/dev.img/edit.gif" alt="'.l('edit').'" /></a>';
				
					echo $sEdit;
					$sDrop='<a href="/'.$qmdC->language.'/'.$qmd_const_URL_Params[2].'/?action=comment';
					$sDrop.='%26task=deletecomment%26commentid='.$reccom['coid'].'"
								title="'.l('delete').' '.l('comment').'" onclick="return pop(\''.l('js_delete2').'\')"><img src="/dev.img/drop.gif" alt="'.l('delete').'" /></a>';
					echo $sDrop;
				//echo '</div>';
				
				endif;
				$baseURL=$qmdC->get_ValidURI();
				
				echo '&nbsp;&nbsp;';
				$sReply='<a href="'.$baseURL.'?action=comment';
				$sReply.='%26task=reply%26commentid='.$reccom['coid'].'#comment'.$reccom['coid'].'"
							title="'.l('reply').' '.l('comment').'"><img src="/dev.img/answer.gif" alt="'.l('reply').'" /></a>';
				if ($Mode==2)
					echo $sReply;
				
				echo '&nbsp;&nbsp;';
				$sReply='<a href="'.$baseURL.'?action=comment';
				$sReply.='%26task=cite%26commentid='.$reccom['coid'].'#comment'.$reccom['coid'].'"
							title="'.l('cite').' '.l('comment').'"><img src="/dev.img/cite.gif" alt="'.l('cite').'" /></a>';
				if ($Mode==2)
					echo $sReply;
				
				echo '&nbsp;&nbsp;';
				$sRec='<a href="'.$baseURL.'?action=comment';
				$sRec.='%26task=recommend%26commentid='.$reccom['coid'].'"';
				$sRec='<a title="'.l('recommend').' '.l('comment').'" onclick="return pop(\''.l('not_implemented').'\')"><img src="/dev.img/recommend.gif" alt="'.l('recommend').'" /></a>';
				//echo $sRec; //not implemented yet
				
				echo '&nbsp;&nbsp;';
				$sReply='<a href="/report-comment?';
				$sReply.='commentid='.$reccom['coid'].'"
							title="'.l('report').'"><img src="/dev.img/report.gif" alt="'.l('report').'" /></a>';
				echo $sReply;
				
				echo '</td></tr>';
			//endif;
			echo '</table>';
		//echo '<div class="qmd_commentHead">Title</div>';
		//echo '<div class="qmd_commentBody">
		//				main
		//			</div>
		echo '</td>';//main
		
		
	echo '</tr>';//qmd_commentblock*
	
	if (($reccom['coid']==$targetcomment)&&($answerMode>0))
	{
		echo '<tr><td colspan="3">';
		$title='Re: '.$reccom['title'];
		
		$uname=$reccom['uname'];
		if (empty($uname))
			$uname=$reccom['name'];
		if ($answerMode==2)
		{
			
			$squote=formatcomment($reccom['title'],$reccom['comment'],2,$uname);
		}
		else
		
			$squote='';
		
		
		showcommentinputMask($reccom['articleid'],$squote,$title,$reccom['coid']);
		$result++;
		
		echo '</td></tr>';
	}
	
	$aSQL=array();
	
	$query =query_get_comment($reccom['articleid'],$aSQL,$reccom['coid'],-1);
	
	$subcomments = $qSQL->qSQLquick($query,$aSQL);
	if (!is_array($subcomments))
		qmd_die('Houston we have a problem - on subcomments');
	else
	{
		
		$xCount=count($subcomments);
		if ($xCount>0)
			for ($i=0;$i<$xCount;$i++)
			{
				$r=$subcomments[$i];
				$result=$result+__doshowThisComment($r,$asef,$level+1,$Mode,$targetcomment,$answerMode);
			}
	}
	
	return $result;
}

function getcommentMasterParent($targetcomment)
{
global $qSQL;
	$result=-1;
	$sql='Select id,answer2comment from '._PRE.'qmd_comments WHERE id=?';
	
	$res=$qSQL->qSQLquick($sql,array($targetcomment));
	if (is_array($res))
	{	
		
		if (count($res)>0)
		{
			
			if (!is_null($res[0]['answer2comment']))
			{
				
				$iNext=$res[0]['answer2comment'];
				$result=getcommentMasterParent($iNext);
			}
			else
			{
				
				$result=$res[0]['id'];
				
			}
			
		}
		else
		{
			$result=$targetcomment;
		}
		
	}
	else	
		qmd_die('getcommentParents is broken');
	
	return $result;
}
function getcommentPaging()
{
global $qmdC;
	$i=$qmdC->get_UParamByName('commentpaging',s('comment_limit',99999));
	if (is_numeric($i))
		$commentCountpP = $i;
	else
	{
		if ($i = 'off')
			$commentCountpP = 999999;
		else
			$commentCountpP = s('comment_limit',99999);
	}
	return $commentCountpP;
}
function getMastercomment($targetcomment,$comments,&$page,&$pageStart,&$ord)
									// results to $targetcomment if $targetcomment has no parent
{									// otherwise returns the id of the Mastercomment
									//if targetcomment is not Found in $comments it is 'looked up'
									//$targetcomment is the comment- id in question
									//$comments is the arry with comments
									//$page will be set to the page we need to see
									//$pageStart is the offset in $comments where the page starts
									//$ord is the index of comments where we find the MasterComment
	$result=-1;
	$commentCountpP=getcommentPaging();
	
	$max=count($comments);
	
	$page=0;
	$pageStart=0;

	$iMasterComment=-1;
	
	$lFound=0;
	$i=0;
	while ($i<$max):
		
		if ($i % $commentCountpP == 0)
		{
			$page++;
			$pageStart=$i;
		}
		$r=$comments[$i];
		
		if ($r['coid']==$targetcomment)
		{
			$result=$targetcomment;
			$ord=$i;
			$lFound=1;
			$i=$max;
		}
		$i++;
		
	endwhile;
	
	
	if ($lFound==0)
	{
		
		
		$iMasterComment=getcommentMasterParent($targetcomment);
		
		$result=getMastercomment($iMasterComment,$comments,$page,$pageStart,$ord);
	}
	return $result;

}
/*
	The "MasterComment" is the parent-comment (with no other parent) to the target-comment
	the targetcomment is the one that we want to look up directly or that we want to quote
	
*/
function _show_comment($aid,$asef,$numcomments,$Mode)//Mode = 1 ->frozen Mode =2 -> edit
{
global $qmd_const_URL_Params;
global $back_to_page;//TODO this is crap!!!
	
global $qmdC;
global $qSQL;
	$showinput=0;
	$iSkip=-1;
	
	$targetcomment=$qmdC->get_UParamByName('commentid');
	
	$action=$qmdC->get_UParamByName('action');
	$task=$qmdC->get_UParamByName('task');
	
	if ($action=='comment')
	{
	
		switch ($task):
			case 'cite':
				$answerMode=2;
				//$targetcomment=$qmdC->get_UParamByName('commentid');
				break;
			case 'reply':
				$answerMode=1;
				//$targetcomment=$qmdC->get_UParamByName('commentid');
				break;
			default://do nothing
				$answerMode=0;
		endswitch;
		
	}
	
	$thisCommentPage=$qmdC->get_UParamByName('commentPage')-1;
	
	$commentCountpP=getcommentPaging();
	
	//TODO we should be using a function from articles
	//now we find out which is the parent comment (root) of the targetcomment
	
	$aSQL = array();
	$query =query_get_comment($aid,$aSQL,NULL);
	$commentpagesCount = ceil($numcomments / $commentCountpP);
	if ($thisCommentPage>=$commentpagesCount)
		$thisCommentPage=$commentpagesCount-1;
	if ($thisCommentPage<0)
		$thisCommentPage=0;
	
	if ($targetcomment<1)//we use regular paging
	{
		$offset = ($thisCommentPage) * $commentCountpP;
		$query.=' LIMIT '.$offset.','. $commentCountpP;
	}
	
	
	$comments = $qSQL->qSQLquick($query,$aSQL);
	
	if (!is_array($comments)):
		qmd_die('Houston we have a problem!');
	else:
		
		//b4 we do some output we adjust what we've got to paging
		$max=count($comments);
		$pageStart=0;
		$page=0;
		
		if ($targetcomment>0)
		{	
			$ord=0;
			$iMasterComment=getMastercomment($targetcomment,$comments,$page,$pageStart,$ord);
		}
		else
			$iMasterComment=-1;
		
		echo '<table class="qmd_commentTableMain" border="0">';
		echo '<colgroup>
				<col width="35" />
				<col width="55" />
				<col width="350" />
			</colgroup>';
		echo '<tr class="tr_invisibleheader"><td>&nbsp;</td><td>&nbsp;</td><td>&nbsp;</td></tr>';
		
		
		if (($iMasterComment>0)&&($answerMode>0)):
			
			$i=0;
				
			$r=$comments[$ord];
			$iSkip=$r['coid'];
			$showinput= __doshowThisComment($r,$asef,0,$Mode,$targetcomment,$answerMode,0,TRUE);

			$max=$pageStart+$commentCountpP;
			if ($max>count($comments))
				$max=count($comments);
			$iCount=$pageStart;
		else:
			
				
			$iCount=$pageStart;
			$max=$iCount+$commentCountpP;
			
			if ($max>count($comments))
			{
				$max=count($comments);
			}
			$targetcomment=-1;//reset
			
		endif;
		
		
		
		$xCount=0;//we need this to alternate rows
		while ($iCount<$max):	
			$reccom=$comments[$iCount];
			if ($reccom['coid']!= $iSkip)
			{
				__doshowThisComment($reccom,$asef,0,$Mode,-1,0,$xCount+$showinput);
				$xCount++;//we need this to alternate rows
			}
			$iCount++;//this is for the actual records
		endwhile;//
		echo '</table>';
		//===========================================================
		//now the footer for the comments with next and previous_page
		//...........................................................
		echo '<p class="qmd_article_spacer"></p>';
		$Page=$thisCommentPage+1;
		echo $Page.'/'.$commentpagesCount .' '.l('comment_Pages');
		if ($thisCommentPage>0)
			echo '&nbsp;'.qmd_createLink('/'.$asef.'/?commentPage='.$thisCommentPage,l('previous_page'));
		

		for ($jCount=1;$jCount<=$commentpagesCount;$jCount++ ):
			if ($jCount==$Page):
				echo '&nbsp;'.$jCount.'&nbsp;';
			else:
				
				echo '&nbsp;'.qmd_createLink('/'.$asef.'/?commentPage='.$jCount,$jCount).'&nbsp;';
			endif;
		endfor;
		$Page++;
			
		if ($Page<=$commentpagesCount):
			
			echo '&nbsp;'.qmd_createLink('/'.$asef.'/?commentPage='.$Page,l('next_page'));
				
		endif;
	endif;//comments avialable
	
	return $showinput;
}
function showcommentinputMask($aid,$quote='',$title='',$parentcomment=NULL)
{
global $qmdC;
	// recall and set vars for reuse when botched post
	//***hy do not access this if not set
	
	$comment=$quote;
	$ctitle=$title;
	$url ='';
	if (isset($_SESSION[_SITE.'/comment'])):
			
		if($_SESSION[_SITE.'/comment']['fail'] == true):
				
			$name = $_SESSION[_SITE.'/comment']['name'];
			$comment = $_SESSION[_SITE.'/comment']['comment'];
			$ctitle = $_SESSION[_SITE.'/comment']['title'];
			$url = $_SESSION[_SITE.'/comment']['url'];
			unset($_SESSION[_SITE.'/comment']);
		endif;
	endif;
			
	echo '<div class="qmd_commentsbox"><h2>'.l('addcomment').'</h2>';
	echo l('required');//./.'</p>';//."\r\n";
	echo html_input('form', '', 'post', '',  '', '', '', '', '', '', 'post', '/'.$qmdC->language.'?action=savecomment')."\r\n";
	echo "<fieldset>";
	if ($qmdC->get_user()>0):
		$uid=$qmdC->uid;
		$uname=$qmdC->username;
		
		$nameMode=' disabled="disabled" ';
		echo html_input('hidden', 'uid', 'uid', $uid, '', '', '', '', '', '', '',  '', '')."\r\n";
	else:
		$sMail='* '.l('email');
		$uname='';
		$nameMode='';
	endif;
	//...............1.......2........3.....4.........5.....      ..6......7......8....9...10..11..12..13..14.15. 16..17 18 19.....
	echo html_input('text', 'name', 'name', $uname, '* '.l('name'), '',$nameMode).'<br/>';
	if ($qmdC->get_user()==0):
		echo html_input('text', 'url', 'url', $url, l('url'), 'text')."\r\n";
	
		echo html_input('text', 'eMail', 'eMail', $eMail, $sMail, '')."\r\n";
	endif;
	echo html_input('text', 'title', 'title', $title, l('title'), 'qmd_large_inputline').'<br/>';
	echo html_input('textarea', 'text', 'text', $comment, '* '.l('comment'),  'qmd_comment_textarea', '', '', '5', '5')."\r\n";
	if ($qmdC->get_user()==0):
		echo mathCaptcha()."\r\n";
	endif;
	echo '<p>';
	
	echo html_input('hidden', 'id', 'id', $aid,'')."\r\n";
	
	echo html_input('hidden', 'commentspage', 'commentspage', $back_to_page,'')."\r\n"; //TODO: $back_to_page has never been set
	echo html_input('hidden', 'ip', 'ip', $_SERVER['REMOTE_ADDR'],'')."\r\n";
	echo html_input('hidden', 'time', 'time', time(),'');
	if (!is_null($parentcomment))
		echo html_input('hidden', 'parentcomment', 'parentcomment', $parentcomment,'');
	echo html_input('submit', 'submit', 'submit', l('submit'), '', 'button')."\r\n";
	echo '</p>';
	echo '</fieldset>';
	echo '</form></div>';
		
}

function reportcomment()
{
global $qmdC;
global $qSQL;

	$action=$qmdC->get_UParamByName('action');
	$task=$qmdC->get_UParamByName('task');
	$comID=$qmdC->get_UParamByName('commentid');

	if (isset($_POST['reportsend']))
	{
		if ($qmdC->get_uid()<=0)
			$check =checkMathCaptcha();
		else
			$check=TRUE;
		if ($check==FALSE):
			qmd_notify(1,l('ce_reasons_captcha'),
						array
							(
								l('back'),
								l('backlastpage')
							)
							,array('/report-comment',$_SESSION[_SITE.'/return2']));
		else:
			$query='select co.id, a.seftitle from '._PRE.'qmd_comments co left join qmd_articles a on (a.id=co.articleid) where co.id= '.$comID;
			$res=$qSQL->qSQLsimple($query);
			if ((is_array($res))&&(count($res)>0))
				$sef=$res[0]['seftitle'];
			$sTxt='There is probably an incident with a comment[br/]';
			$sTxt.='Reported by: '.$qmdC->username.' / '.$qmdC->get_uid().'[br/]';
			$sTxt.='check it out at: [br/]';
			$sTxt.='[br/]';
			$sLink='http://'.$_SERVER['SERVER_NAME'].'/'.$sef.'?commentid='.$comID.'#'.$comID;
			
			send_sys_message('Comment Reported',$sTxt.$sLink.'[br/]');
			
			qmd_notify(0,l('thanks4actingoncomments'),array(l('backlastpage')),array($_SESSION[_SITE.'/return2']));
		endif;
	}
	else
	{
		$ref=$_SERVER['HTTP_REFERER'];
		$_SESSION[_SITE.'/return2']=$ref;
		
		echo html_input('form', '', 'post', '',  '', '', '', '', '', '', 'post', '/report-comment?action=savereport%26mode=pppc%26commentid='.$comID)."\r\n";
		echo "<fieldset>";
		echo 'IP: '.$_SERVER['REMOTE_ADDR'].'<br/>';
		echo html_input('hidden', 'ip', 'ip', $_SERVER['REMOTE_ADDR'],'')."\r\n";
		echo html_input('hidden', 'reportsend', 'reportsend', 1,'');
		echo html_input('text', 'reportreason', 'reportreason', '', l('reportreason'), '')."\r\n";
		if ($qmdC->get_uid()<=0)
			echo mathCaptcha()."\r\n";
		echo html_input('submit', 'submit', 'submit', l('submit'), '', 'button')."\r\n";
		echo "</fieldset>";
		echo "</form>";
	}
	return TRUE;
}
function comment($aid,$asef) 
{
global $qmdC;
	
	$result=TRUE;
	$AO=$qmdC->qmdA($aid);
	
	$xAll=$qmdC->get_UParamByName('commentLang');
	if ($xAll==-1)
		$Acountcomments= $AO->has_comments(TRUE,0);
	else
		$Acountcomments= $AO->has_comments(TRUE,1);
	
	
	if (($Acountcomments>0)||($AO->ArticleCommentMode>1)):
		
		if ($xAll==-1)
		{
			$siteAll=$qmdC->get_URLRequest();
			$xURL=parse_url($siteAll);
			if (empty($xURL['query']))
				$siteAll.='?';
			$siteAll.='%26commentLang=ALL';
		}
		echo '<p class="qmd_article_spacer"></p>';
		
		echo '<div class="qmd_commentsheader">';
		
		//echo '<div class="qmd_commentHead">';
		echo l('comments');//.'</div>';
		if (($xAll==-1)&&($AO->iCommentsOtherLang>0))
		{
			echo '<div class="qmd_comment_langOptHelp" onclick="javascript: return olh_simple(\''.l('otherlang_info').'\',
																	[\'Ok\'],[],0)">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</div>';
			echo '<div class="qmd_button"><a href="'.$siteAll.'">'.l('all_languages').'</a></div>';
		}
		//else
			//echo '</div>';
		echo '</div>';
		
		echo '<div class="qmd_clearer">&nbsp;</div>';
		$doShowComments=$AO->ArticleCommentMode;//0 don't show 1 show frozen if any 2 show and allow
		$action=$qmdC->get_UParamByName('action');
		$task=$qmdC->get_UParamByName('task');
		$comID=$qmdC->get_UParamByName('commentid');
		
		if ($doShowComments>0)
		{
			
			if ($doShowComments==1)
			{	if ($Acountcomments>0)
				{
					_show_comment($aid,$asef,$Acountcomments,$doShowComments);
					echo '<p>'.l('frozen_comments').'</p>';
				}
			}
			else
			{
				if ($Acountcomments>0)
				{
					$x=_show_comment($aid,$asef,$Acountcomments,$doShowComments);
					
					if ($x==0)
					{
						showcommentinputMask($aid);
					}
				}	
				else
				{
					echo '<p>'.l('no_comment').'</p>';
					showcommentinputMask($aid);
				}
			}	
		}
		
	endif;
		
	return $result;	
}//comment()

function save_edit_comment($coid)
{
	global $qSQL;
	global $qmd_const_URL_Params;
	
	$result=-1;

	
	$sql='SELECT a.seftitle, c.id FROM '._PRE.'qmd_comments c LEFT JOIN ('._PRE.'qmd_articles AS a) 
			ON ( a.id = c.articleid ) WHERE c.id ='.$coid;
	$AA=$qSQL->qSQLquick($sql);
	
	if ((is_array($AA))&&count($AA)>0):
		
		$articleSEF=$AA[0]['seftitle'];
		$aLinkLabel=array(l('backhome'),l('ViewThisArticle'),l('administration'),l('viewthiscomment'));
		$aLinkList=array('/',
								'/'.$articleSEF,
								'/'.$qmd_const_URL_Params[2],
								'/'.$articleSEF.'?commentid='.$coid.'#comment'.$coid);
		
		if (isset($_POST)):
			$name=$_POST['name'];
			$approved=$_POST['approved'];
			if ($approved=='on'):
				$approved=1;
			else:
				$approved=0;
			endif;
			$url=$_POST['url'];	
			$comment = $_POST['editedcomment'];
			$eMail = $_POST['eMail'];

			
				
			if (!isset($url))$url='';//***hy this is required if URL field was left blank!
			//***hy clean($comment) is required to process a comment like: Simon says:'you'd better watch out!'
			$iRows=0;
			
			if ($qSQL->prepareupdate(array('name','url','eMail','comment','approved'),
											array($name,$url,$eMail,$comment,$approved),
											array('id='),array($coid),null)>0):
				$res=$qSQL->updateSQL(_PRE.'qmd_comments',$iRows);//			iRows will return the number of rows affected
				
				if ($res==1):
					qmd_notify(0,l('operation_completed'),$aLinkLabel,$aLinkList);
					
				else:
					//Errorsavingcomment
					qmd_notify(2,l('Errorsavingcomment'). ' x-1',$aLinkLabel,$aLinkList);
					
				endif;
			else:
				qmd_notify(2,l('Errorsavingcomment'). ' x-pu',$aLinkLabel,$aLinkList);
				
			endif;
		else:
			msgbox('Error processing comment');
		endif;
	else:
		$result=-1;
		qmd_die('Error retrieving corresponding article');
	endif;
	return $result;
}
function deletecomment($coid)
{
	global $qmd_const_URL_Params;
	global $qmdC;
	global $qSQL;
	
	$result=0;
	$sql='SELECT a.seftitle, c.id FROM '._PRE.'qmd_comments c LEFT JOIN ('._PRE.'qmd_articles AS a) ON ( a.id = c.articleid ) WHERE c.id ='.$coid;
	$AA=$qSQL->qSQLquick($sql);
	
	if ((is_array($AA))&&(count($AA)>0))
	{
		$articleSEF=$AA[0]['seftitle'];
		$aLinkLabel=array(l('backhome'),l('ViewThisArticle'),l('administration'));
		$aLinkList=array('/','/'.$articleSEF,'/'.$qmd_const_URL_Params[2]);
	
		$i=execSQL('DELETE FROM '._PRE.'qmd_comments WHERE id = '.$coid);
		
		if ($i>0)
			qmd_notify(0,l('operation_completed'),$aLinkLabel,$aLinkList);
		else
			qmd_notify(2,l('Errordeletingcomment'),$aLinkLabel,$aLinkList);
	}
	else
	{
		$result=-1;
		qmd_die('ERROR retrieving corresponding article - or comment is already deleted');
	
	}
return $result;
}

/* this function is not used neither tested ATM V.0.7.7 */
function create_comment_Link($coid,$sef,$mode,$page=-1,$artid=-1,$approved=1)
/*
	$coid=comment ID
	$sef= articleSEF
	
	$mode = 0 skip menu or cat 
	$mode=1 use menu 
	$mode=2 use category
	
	$page = -2 no paging
	$page = -1 retrieve page
	$page = 0 ... n use $page
	
	$artid should be provided if available
	$subItem must be provided if applicable
	$approved is by default ON - for links sending to the admin as a notification of new comments
											awaiting moderation this MUST be set to zero!
	
*/
{	
	global $qSQL;
	$error=0;
	switch ($mode):
		case 0:
			$preItem='';
			break;
		case 1:
			$preItem=$qmd_const_URL_Params[0].'/';
			break;
		case 2:
			$preItem=$qmd_const_URL_Params[1].'/';
			break;
	endswitch;
	$link=$sef;
	
	switch ($page):
		case -2:
			$page=0;
			break;
		case -1:
			if ($artid<0):
				$sql='SELECT id FROM '._PRE.'qmd_comments'.
									'WHERE articleid = (Select id from "._PRE."qmd_articles WHERE seftitle=?)';
				$A=array($sef,$subItem);
			else:
				$sql='SELECT id FROM '._PRE.'qmd_comments'.
									'WHERE articleid = ?';
				$A=array($artid,$subItem);
			endif;
			
			if ($approved==1):					
				$sql.=' AND approved = 1';
			endif;
				
			$sql.=' ORDER BY time DESC';
			$crows = $qSQL->qSQLquick($sql,$A);

			if (is_array($crows)):
				$noOfComments=count ($crows);;
				
				$comlim = s('comment_limit');
				$comment_limit = $comlim < 1 ? 1 : $comlim;
				$ord=0;
				while (($ord<$noOfComments)&&($crows[$ord]['id'] != $coid)):
					$ord++;
				endwhile;
				if ($ord>=$noOfComments):
					$error--;
					qmd_die('error: can not retrieve comment '.$coid. ' for article: '. $sef);
				else:
				
					$page = ceil($ord / $comment_limit);
				endif;
			else:
				$error--;
				qmd_die('problem receiving amount of comments for article "'.$sef.'"');
			endif;
			
			break;
		default:
			
			$preItem=$qmd_const_URL_Params[1].'/';
			break;
	endswitch;
	if ($error==0):
		$paging = $page > 1 ? '/?commentPage='.$page : ''; 
	
		$result=qmd_createLink($preItem.$link.$paging.'/#comment'.$ord,
										l('comment_info').' '.$r['title']);
	endif;
	return $result;
}//create_comment_Link UNUSED (f)

// NEW COMMENTS // 
function new_comments($number = 5) 
{
	
	global $qmd_const_URL_Params;
	global $qmd_Lang_ANY;
	global $qmdC;
	global $qSQL;
	$result=0;
	$stringlen=s('comment_teaser',30);
	
	$ordinal=0;
	//TODO this should be made with respect to the currently selected menu or cat
	//furthermore this does not reflect a possible sub article within a list.
	//The actual should just retrieve the latest $number of articles
	//and then fetch the required data of the article.
	
	/*qmd-CMS 0.7.2
		the main article will handle the comments shown here
		... or rather the  CONTROL-Object $qmdC
		The idea:
		the CONTROL-Object will have either a category 
		or a menu 
		So we display here the comments to the category or menu in question.
		Or we display only comments on a list... resp. the list items...
		
	*/
	
	
	//title TODO
	$userMode=$qmdC->get_user();
	$query='SELECT distinct co.id,co.articleid,co.name AS coname,co.comment,co.title,
					a.id AS aid,a.seftitle AS asef,u.uname,
					a.category
					
					FROM '._PRE.'qmd_comments AS co
					LEFT OUTER JOIN '._PRE.'qmd_articles AS a
						ON articleid = a.id
						
					LEFT JOIN '._PRE.'qmd_users AS u ON u.id = co.userid
					
					WHERE ((lang_used="'.$qmdC->language.'") OR(lang_used="'.$qmd_Lang_ANY.'")) 
						AND ((a.display_mode & 1)>0)';
	$AallowedModes=array(1,2);
	if ($userMode>0):
		$AallowedModes[]=5;
		$AallowedModes[]=6;
		$AallowedModes[]=7;
		if ($userMode>=2):
			$AallowedModes[]=9;
			$AallowedModes[]=10;
			$AallowedModes[]=11;
		endif;
	endif;
	
	$query.=' AND (a.commentable in (';
	for ($i=0;$i<count($AallowedModes);$i++):
		if ($i>0)
			$query.=',';
		$query.=$AallowedModes[$i];
	endfor;
	$query.='))';
	$query.='AND (approved = 1)
					ORDER BY co.id DESC LIMIT '.$number;
	
	$rows = $qSQL->qSQLquick( $query, null);
	
	if ((!is_array( $rows))||(count($rows)>0)):
		
		//echo the header
		echo '<h3>'.l('new_Comments').'</h3><ul>';
		//now we skip through the result of SQL
		
		for ($iCount=0;$iCount<count($rows);$iCount++):
			
			
			$r =$rows[$iCount];	//this is the row
			$iNum=$r['articleid'];	//this is the article
			
			
			$name = $r['coname'];
			if (empty($name))$name=$r['uname'];
			
			$comment = strip_tags($r['comment']);
			$comment=formatcomment($r['title'],$comment,0,$name,$stringlen);
			
			//$page = ceil($ord / $comment_limit);
			
			$ncom = $name.': '.$comment;
			
			$link = $r['asef']; 
			echo '<li>';
			$paging='?commentid='.$r['id'];
			echo qmd_createLink($qmd_const_URL_Params[1].'/'.$link.$paging.'#comment'.$r['id'],
										$ncom,
										l('comment_info').' '.$r['title']);
			echo '</li>';
			
		endfor;//
		echo '</ul>';
	endif;
	
	return $result;
}//new_comments

?>