<?php
/*
	
	
	Program: qmd-cms [Qimanfaya-Menu-Driven-CMS]
	------------------------------
   qmd-cms - Control-Object for qmdCMS (controling the whole thing)
   qmd-cms 0.8.7
	last update: 04/28/2014

	--------------------------------

	qmd_classes.php
	=============

	This file is part of the qmd-php-library
	
	Author: ***hy
	For further reference regarding this code see qmdcms.php and the readme-files.
	
	This code was developed by ****hy
	Copyright: qimanfaya/hy-soft 2012,2014
	
	Licence:		GPL V.3

	A copy of the GNU General Public License is available:
	in the root of this folder
	and on the World Wide Web
	at <http://www.gnu.org/licenses/gpl-3.0.txt>. You can also obtain it by writing
	to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
	MA 02111-1307, USA.
			
	If you want to do something here search for the keyword:
	object-initialization
	
	That's where you put something in to initialize YOUR article-object

*/			

	class qmd_CONTROL
	{
		var $loading;
						//-1            0   1         2      3      4      5
		var $ControllerMode; 	//undefined, Menu, Category, Admin, Login, Logoff  showFUNC
		//this ^^^^^^^^^^^^^^^^^^^^^^^^is not used up to now!
		
		var $language;

		var $ID;   	//articleID
		var $CAT;	//Category ID
		var $SEF;	//SEF of ITEM selected (Menu,Category)
		var $Func;
		
		var $AloadJS;//array with javascript files to load
		var $AloadCSS;//array with css - styles to load
		
		var $yTrace;/*
							ARRAY of Menues or Categories - e.g.
						[0] - ARRAY()
								link - name id
						e.g. 	yTrace[0][link]= excursions
								yTrace[0][name]= Excursionen
								yTrace[0][id]=22
								yTrace[0][traceMode]='0'; //0=Menu 1 = cat
						
						*/
		
		var $yNext;/*
							the next menuitems to show - only if in mode 0
							same as above
							link-name pairs...
						*/
						
		
		var $URL;			// the URI w/o params as an array
		var $URLparams;	// the params from URI
					/*
						[0] - action=process
						[1] - task=editcomment
						[2] - id=9
						[3] - #target
						[n]   commentsPage=2
					*/
		
		var $aArticleObjs;
		var $status; //unused
		
		var $uid;	//must be set b4 user
		
		var $username;
		var $urole;// root admin mod 2nd-level user 0
						/*= 0, 1, 2
							0=not logged in
							1=logged in - uid should be set
							2=2nd level user
							4=Moderator
							8=admin
							16=superuser
						*/
		
		var $MetaDataKeywords;//MetaData & Keywords for selected article(s)
		var $MetaDataDesc;//MetaData & Keywords for selected article(s)
		//var $rArticle;//record of the Article to display
		var $callSEFFunc;
		var $selectedScheme;
		var $trailingSlash;
		
		var $SeekModeLang; //0: seek for $lang or deliver $this->language
								//	1 seek for $lang exactly $lang will handed by param
								//-1 deliver any that can be found 
		var $usrMSGs;		//number of unread messages
		var $aVACShown;
		var $displayMode;
		
		
		
		function __construct(){	//Do not call this without $URI being initialized properly
			global $qmd_const_URL_Params;
			global $qmd_sefLink;
			global $LANG;
			$this->displayMode=-1;//unitialized;
			$this->AloadJS=array();//array with javascript files to load
			$this->AloadCSS=array();//array with css - styles to load
			
			$this->language=s('language'); //use default language from system settings
			$this->SeekModeLang=0;

			$this->loading=0;
			
			$this->MetaDataKeywords='';
			$this->MetaDataDesc='';
			$this->CAT=-1;
			$this->ControllerMode=-1;
			$this->ID=-1;
			$this->SEF='';
			$this->Func='';
			$this->yTrace=array();
			$this->aArticleObjs=array();
			
			$this->status=0;
			
			$this->username='';
			$this->uid=-1;
			$this->urole=0;
			
			
			$this->URL=array();
			$this->URLparams=array();
			$this->yNext=array();
			$this->callSEFFunc=0;
			$this->traceMode=0;//default Menu
			$this->set_selectedScheme(s('scheme','default'));
			
			$this->ajaxVals='';
			$this->usrMSGs=0;
			$this->aVACShown=array();
			//########################################################################################
			//############## PREPARING URL-HANDLING  #################################################
			
			$fullURI=$this->get_URLRequest();
			
			$ch=getLastChar($fullURI);
			if ($ch=='/')$this->trailingSlash=TRUE;else $this->trailingSlash=FALSE;
			
			$query='';
			$URI='';
			
			$xURL=parse_url($fullURI);
			if (is_array($xURL)):
				if (isset($xURL['path'])):
					$URI=$xURL['path'];
				endif;
				if (isset($xURL['query'])):
					$query=$xURL['query'];
				
				endif;
			endif;
			
			if (empty($URI)):
				$ch=' ';
			endif;
			
			//echo "URI: ".$URI.'<br/>';
			//echo "SITE:"._SITE.'<br/>';
			//echo "S   :".$_SERVER['SERVER_NAME'].'<br/>';
				
			$this->URL=explode('/',$URI);
			$goon=TRUE;
			//cleaning up the stuff in the URL
			
			while($goon==TRUE):
				if (count($this->URL)>0):
					$Xs=$this->URL[0];
					if ($Xs==':'):	//I really had that on my live server for whatever reason!
						array_shift($this->URL);
					else:
						if (empty($Xs)):
							array_shift($this->URL);
						else:
							if ($Xs==_SITE):
								array_shift($this->URL);
							else:
								$goon=FALSE;
							endif;
						endif;
					endif;
				else:
					$goon=FALSE;
				endif;
			endwhile;
			
			if (empty($this->URL[count($this->URL)-1]))array_pop($this->URL);
			//NOW the URL is clean

			$this->language=s('language');
			if (count($this->URL)>0)
			$x=array_search($this->URL[0],$LANG);
			
			if (($x===0)||(($x>0)&&($x<count($LANG))))
			{
				$this->language=$this->URL[0];
				
				array_shift($this->URL);
			}
			$this->URL=map_URIs($this->URL,$URI);//also send the complete URI without query
			include_once('lang/'.$this->language.'.php');
			//########################################################################################
			//############## PREPARING QUERY-HANDLING  (additional params   ##########################
			if (!empty($query)):
				$iMax=count($query);
				$x=explode('&amp;',$query);

				$y=array();
				//test with
				//www.qmd.test/excursions/tag/tiagua/museum?action=foo%26mode=bar;test=2&start=9%26month=august&amp;day=1;year=1961
				
				for ($i=0;$i<count($x);$i++):
					$tmp=explode('%26',$x[$i]);
					for ($j=0;$j<count($tmp);$j++)array_push($y,$tmp[$j]);
				endfor;

				unset($x);
				$x=array();
				for ($i=0;$i<count($y);$i++):
					$tmp=explode('&',$y[$i]);
					for ($j=0;$j<count($tmp);$j++)array_push($x,$tmp[$j]);
				endfor;

				unset($y);
				$y=array();
				for ($i=0;$i<count($x);$i++):
					$tmp=explode(';',$x[$i]);
					for ($j=0;$j<count($tmp);$j++)array_push($y,$tmp[$j]);

				endfor;
			
				$this->URLparams=$y;
			
			endif;
			
			//############## PREPARING URL-HANDLING  DONE! ###########################################
			//########################################################################################
			
			//Now interpreting the stuff
			//1. check the MODE we're in
			$iMax=count($qmd_const_URL_Params);

			$iCount=0;
			$s=$this->URL[0];
			$x=in_array($s,$qmd_const_URL_Params);
			if ($x==TRUE):
				$x=array_search($s,$qmd_const_URL_Params);

				
				$this->ControllerMode=$x;

				$this->SEF=$s;

			endif;
			if ($this->SEF=='logoff'):
				$_ReloadPending=1;
				//logoff(); don't call that here
			else:
				$s=$this->get_URIlast();
				
				$x=in_array($s,$qmd_sefLink);
				if ($x==true):
					
					if (strpos($s,'-')>0)
						$s=str_replace('-','',$s);
					
					$this->Func=$s;	//actually we don't need to evaluate further if there is a function set
											//but: have a look at the next if-statement
					
				endif;
				
				if (empty($this->Func)):
					
					if ($this->ControllerMode<0):
						$this->ControllerMode++;//default is Menu	-> in this case we look for a sef 
														//either in Menues or in articles
					else:
						//the next code is superfluous
						if ($this->SEF==$qmd_const_URL_Params[2]):
							if (count($this->URL)>1):
								$this->SEF=$this->URL[count($this->URL)-1];//should be administration anyway 
							endif;
						endif;
					endif;
					
					if ($this->ID==-1):
						
						$sTask=$this->get_UParamByName('task');
						switch ($sTask):
							case 'editcomment':
							break;
						default:

							$_id=$this->get_UParamByName('id');
							
							if($_id>0):
								
								$this->ID=$_id;
							endif;
						endswitch;
					endif;
				
				endif;
			endif;
			return;
		}
		function __destruct(){
			
			unset($this->aArticleObjs);
			unset($this->yTrace);
			unset($this->yNext);
			
		}
		//we never call this from outside, so we don't really need it anymore
		/*
		function set_ID($newVal){
			$this->ID=$newVal;
			return;
		}
		*/
		function qmdCMSID($Mode=1)//$Mode = 0 show only qmdCMS 1=>show with Link
		{
			$result='<span class="qmd_qmdCMSID">This site is powered(!) by ';
			if ($Mode==0)
				$result.='qMD-CMS V. '.__y_qmd_cms_version;
			else
			{
				$result.='<a href="http://qimanfaya.net/digital/qMD-CMS" title="qmd-CMS: V. '.__y_qmd_cms_version.' ['.__y_qmd_cms_release.']';
				if (__y_local_test>0)
					$result.='- {S: '.$this->selectedScheme.'}">q-MD-CMS</a></span>';
				else
					$result.='">q-MD-CMS</a></span>';
			}
			return $result;
		}
		function set_selectedScheme($newScheme)
		{
			$aschemes=get_scheme_array();
			
			$x=array_search($newScheme,$aschemes);
			
			if ($x===FALSE)
			{
				$this->selectedScheme=s('scheme').'/';
				if (__y_local_test==1)
					msgbox('Invalid Scheme selected: ' .$newScheme.' Using: '.s('scheme'));
			}
			else
				$this->selectedScheme=$newScheme.'/';
			
			unset($aschemes);
		}
		function get_URLRequest($secure=1)
		{//this delivers the actual URL without interpretation
			if ($secure==1)
				$result='http://'.$_SERVER['SERVER_NAME'];
			else
				$result=$_SERVER['REQUEST_SCHEME'].'://'.$_SERVER['SERVER_NAME'];
			$result.=$_SERVER['REQUEST_URI'];
			return $result;
		}
		function set_language($newLang){
			global $LANG;
			if ((!in_array($newLang,$LANG))||((empty($newLang)))):
				$newLang=s('language');
			endif;
			
			$this->language=$newLang;
		}
		function get_ValidURI($secure=1)
		{//$secure=0 works for php V.5.5.8-3 but not with 5.3.10-lubuntu3.7
			if ($secure==1)
				$result='http://'.$_SERVER['SERVER_NAME'];
			else
				$result=$_SERVER['REQUEST_SCHEME'].'://'.$_SERVER['SERVER_NAME'];
			$imax=count($this->URL);
			if ($this->URL[0]!=s('home_sef'))
			{
				for ($iCount=0;$iCount<count($this->URL);$iCount++)
				{
					$result.='/'.$this->URL[$iCount];
				}
			}
			
			return $result;
		}
		function set_defaultCAT($newVal){$this->CAT=$newVal;return;}
		function set_SEF($newVal){$this->SEF=$newVal;return;}
		
		
		function set_status($newVal){$this->status=$newVal;return;}
		function setUROLE($role)
		{
		global $qmd_const_URL_Params;
		global $qmd_sefLink;
			
			switch ($role):
				case __USER_isROOT:
				case __USER_isAdmin:
					break;
				case __USER_isMod:
				
					if ($this->ControllerMode==$qmd_const_URL_Params[2]):
						$this->ControllerMode=$qmd_const_URL_Params[5];
					endif;
					break;
				default:
					
					
					if (
							($this->ControllerMode==2) //$qmd_const_URL_Params[2])
						||
							($this->ControllerMode==5) //$qmd_const_URL_Params[5])
						):
						
						$this->ControllerMode=0;
						$this->SEF=$qmd_sefLink[12];//authorization req'd
						$this->URL[0]='';
						
					else:
						if (
								($this->ControllerMode==6)	//$qmd_const_URL_Params[6])
							&&
								($role<__USER_isUser)
							):
							
							$this->ControllerMode=0;
							$this->SEF=$qmd_sefLink[12];//authorization req'd
							$this->URL[0]='';
						endif;
					endif;
			
			endswitch;
			
			$this->urole=$role;
			return;
		}
		function set_uid($uid,$name,$role)
		{//$role:
		//define('__USER_isROOT',16);
		//define('__USER_isAdmin',8);
		//define('__USER_isMod',4);
		//define('__USER_is2ndLevel',2);
		//define('__USER_isUser',1);
			
			$this->username=$name;
			$this->uid=$uid;
			$this->setUROLE($role);

			return;
		}
		
		//this will not be changed from the outside
		//function set_Mode($newVal){$this->ControllerMode=$newVal;return;}
		
		
		
		function get_Mode(){return $this->ControllerMode;}
		
		function qmdA($artID=-1)//$artID < 0 ==> use first/only item otherwise seek article with id
		{
			$result=NULL;
			if (count($this->aArticleObjs)>0)
			{
				if ($artID<0)
					$result=$this->aArticleObjs[0];
				else
				{	
					$i=0;
					while ($i<count($this->aArticleObjs) &&($result==null))
					{
						if ($this->aArticleObjs[$i]->ArticleRow['artid']==$artID)
							$result=$this->aArticleObjs[$i];
						$i++;
					}
				}
			}
			return $result;
		}
		
		function get_ID(){
			$result=$this->ID;
			
			
			if (($result<1)&&(count($this->aArticleObjs)>0)):
				
				$this->ID=$this->aArticleObjs[0]->ArticleRow['artid'];
				$result=$this->ID;
			endif;
			
			return $result;
		}
		function get_SEF(){return $this->SEF;}
		function get_CAT()
		{
			if ($this->CAT==-1)
			{
				if (count($this->aArticleObjs[0])>0)
					$this->CAT=$this->aArticleObjs[0]->ArticleRow['category'];
				else
					$this->CAT=s('defaultVACCategory');
			}
			//INSERT INTO `qmd_settings`(`name`, `value`) VALUES ('defaultVACCategory',1)
			return $this->CAT;
		}
		function get_yTrace(){return $this->yTrace;}
		function get_aArticles(){return $this->aArticleObjs;}
		function get_status(){return $this->status;}

		function get_userPermission($REQUEST){
			$result=0;
			if ($this->urole==__USER_isROOT)
				$result++;
			else
				if ($this->urole >=$REQUEST)
					$result++;
			return $result;
		}
		
		function get_user(){return $this->urole;}
		function get_uid(){
			
			return $this->uid;
		}
		
		function get_yNextNo($i,&$Value)
		{
				$iMax=count($this->yNext);
				$Value='';
				if ($iMax>$i):
					$Value=$this->yNext[$i]['name'];
					return $this->yNext[$i]['link'];
				else:
					return '';
				endif;
				
		}
			
		function get_yNextcount(){return count($this->yNext);}
		function unset_yNext(){unset($this->yNext);$this->yNext=array();return;}
		function add_yNext($link,$Value)
		{
			$iCount=count($this->yNext);
			$this->yNext[$iCount]=array();
			$this->yNext[$iCount]['link']=$link;
			$this->yNext[$iCount]['name']=$Value;
			
			return;
		}
		function insert_yNext($name,$pos){insertToArray($this->yNext,$pos,$name,TRUE);return;}
		
		// URL
		function get_URIcount(){return count($this->URL);}
		function get_URI($i){
			$result='';
			if ((func_num_args()==0)||($i<0)):
				$result= $this->get_URLRequest();
			else:
				if (count($this->URL)>$i)
					$result= $this->URL[$i];
			endif;
			return $result;
		}
		function get_URIfirst(){
			$result='';
			if (count($this->URL)>0):
				$result=$this->URL[0];
			endif;
			return $result;
		}
		function get_URIlast(){return $this->URL[$this->get_URIcount()-1];}
		function get_UParamCount(){return count($this->URLparams);}
		function get_UParam($iCount,$iMode){
			
			$result='';
			
			if ($iCount<$this->get_UParamCount()):
				$s=$this->URLparams[$iCount];
			
				$ipos=strpos($s,'=');
				if ($ipos!==false):
					if ($iMode==0):
						$result=substr($s,0,$ipos);
					else:
						$result=substr($s,$ipos+1,9999);
					endif;
				endif;
			endif;
			
			return $result;
		}
		
		function get_UParamByName($name,$default=-1){//will deliver -1 if nothing found/set
			$result=$default;
			$icount=0;
			
			$iMax=$this->get_UParamCount();
			while ($icount<$iMax):
				
				$s=$this->get_UParam($icount,0);
			
				if ($s==$name):
					
			
					$result=$this->get_UParam($icount,1);
					if (empty($result))$result=-1;
			
					$iCount=$iMax;
				endif;
				$icount++;
			endwhile;
			return $result;
		}
		
		
		function unset_yTrace(){
			
			unset($this->yTrace);
			$this->yTrace=array();
			return;
		}
		
		function _hasArtId($ID)
		{
			$i=0;
			$result=0;
			while ($i<count($this->aArticleObjs))
			{
				if ($this->aArticleObjs[$i]->ArticleRow['artid']==$ID)
				{
					$result++;
					$i=count($this->aArticleObjs);
				}
				else
					$i++;
			}
			return $result;
		}
		function addArtObject($aobj)
		{
			if (is_object($aobj))
			{
				$Value=$aobj->ArticleRow['artid'];
				if ($this->_hasArtId($Value)<1)//security
				{
					$this->aArticleObjs[]=$aobj;
					$r=$aobj->ArticleRow;
					$this->add_MetaDataKW($r['keywords_meta']);
					$this->add_MetaDataDesc($r['description_meta']);
					//when in admin Mode we need to load that here as well
					//in order to display the dataobjects
					//if ($this->get_URIfirst()!=$qmd_const_URL_Params[2])://NOT admin
					
				}
			}
			else
				msgbox('can not add arrays');
			
		}
		function add_Article($Value,$row=null,$skiplang=1)
		{														//$skiplang =1 skip articles that are not available for current language
																//$skiplang =0 load also articles that are in a non selected language
			
			$status=0;
			if ($this->_hasArtId($Value)<1)//security
			{
				$iCount=count($this->aArticleObjs);

				if ($row==null)
					$row=$this->seekArticlebyID($Value, $this->language);//use this lang or system default
				if ((!is_object($row))&&($skiplang==0))
					$row=$this->seekArticlebyID($Value, '');//use this lang or system default
				if (is_object($row))
				{
					$status++;
					$this->addArtObject($row);
					
				}
				else
				{
					if (is_array($row))
					{
						$row=$this->load_Article_Data($row);
						if (is_object($row))
							$this->addArtObject($row);
						else
							$status--;
					}
					else
						$status--;
				}
			}
			return;
		}
		function add_yTrace($link,$Value,$id,$newTraceMode){
			
			$iCount=count($this->yTrace);
			$this->yTrace[$iCount]=array();
			$this->yTrace[$iCount]['link']=$link;
			$this->yTrace[$iCount]['name']=$Value;
			$this->yTrace[$iCount]['id']=$id;
			$this->yTrace[$iCount]['traceMode']=$newTraceMode;
			
			return;
		}
		
		function countTrace(){return count($this->yTrace);}
		
		function insert_yTrace($name,$pos,$link,$name,$id,$newTraceMode){
			$VAL=array();
			$VAL['link']=
			$VAL['name']=$name;
			$VAL['id']=$id;
			$VAL['traceMode']=$newTraceMode;
			insertToArray($this->yTrace,$pos,$VAL,TRUE);
			return;
		}
			
	
		function get_Breadcrumbs()
		{
		global $qmd_const_URL_Params;
		global $qmd_sefLink;
			
			$slUser='';
			
			if (($this->urole>=8)&&($this->uid>0)):
				$slUser=$qmd_const_URL_Params[2];
				$slTitle=l('administration');
				$slText=l('administration');
				
				
			else:
				if (($this->urole>=4)&&($this->uid>0)):
					
					$slUser=$qmd_const_URL_Params[5];
					$slTitle=l('moderation');
					$slText=l('moderation');
				
				else://TODO link to userpanel
					if (($this->urole>=1)&&($this->uid>0)):
						$slUser=$qmd_const_URL_Params[6];
						$slTitle=l('userpanel');
						$slText=l('userpanel');
					endif;
				
				endif;
			endif;
			
			if (empty($slUser)) $out='';
			else
				$out=qmd_createLink($slUser,
											$slTitle,
											$slText)
											.l('divider').' ';
			
			for ($iCount=$this->countTrace()-1;$iCount>=0;$iCount--):
			
				$out.=qmd_createLink($this->yTrace[$iCount]['link'],$this->yTrace[$iCount]['name']);
				
				if ($iCount>0):
					$out.=l('divider').' ';
				endif;
			endfor;
			if (($this->Func==$qmd_sefLink[7])||($this->Func==$qmd_sefLink[15]))
				$out.= l('userpanel');
			
			$out='<p class="qmd_breadcrumbs">'.$out.'</p>';
			return $out;

		}
		
		function get_MetaDataKeywords()
		{
		global $default_MetaDataKW;
		
			$result=$this->MetaDataKeywords;
			if (empty($result)):
				$result=$default_MetaDataKW[$this->language];
			endif;
			return $result;
			
		}
		function get_MetaDataDescription()
		{
		global $default_MetaDataDesc;
			
			$result = $this->MetaDataDesc;
			if (empty($result)):
				$AO=$this->qmdA();
				if ($AO!==null):
					$result=$AO->getField('description_meta');
				endif;
				if (empty($result)):
					if (is_null($AO))
						$result=$default_MetaDataDesc[$this->language];
					else
					{
						$result=cleanMeta($AO->getArticleTeaser(2));//Mode=2 for SEO-Description
						if (empty($result))
							$result=$default_MetaDataDesc[$this->language];
						else
							$result=substr($result,0,s('default_teaser_lengt',255));
					}
				endif;
			endif;
			return $result;
		}
		
		function add_MetaDataKW($sMetaData)
		{
			if (!empty($sMetaData))
			{
				if (!empty($this->MetaDataKeywords))
					$this->MetaDataKeywords.=',';
				
				$this->MetaDataKeywords.=$sMetaData;
			}
			return;
		}
		function add_MetaDataDesc($sMetaData)
		{
			if (!empty($sMetaData))
			{
				if (!empty($this->MetaDataDesc))
					$this->MetaDataDesc.=',';
				
				$this->MetaDataDesc.=$sMetaData;
			}
			return;
		}
		/*******************************************************************************************************************
		//Now on to something completely different:
		//this is the place where an article with all it's required properties is actually loeaded
		//I have to admint that it's hard to read
		// ... but it was hard to code as well.
		// I was struck by a phenomenon called: 'requirements creeping'
		/******************************************************************************************************************/
		function load_Article_Data($r,$MainArticle=true,$loader='',$instantiateproperty=0)
		{//$r requires 'seftitle','scheme' to be set!
			
			//BUG: this is loaded twice even if there is one article loaded.
			
			global $qmd_const_URL_Params;
			global $qSQL;
			global $qmd_knownLoaders;

			$option='';//now we just initialize some variables...
			$action='';
			$result=null;
			$parent_obj=null;
			
			$parent=-1;
			if($r!==null)
				$parent=$r['art_parent'];


			$onTargetItem=0;
			$resetLoadcount=0;
			
			//check if we're coming from something like parent or master...
			if (in_array($loader,$qmd_knownLoaders)==TRUE)$this->loading++;
				
			//--------------------------DEBUG-------------------------
			//msgbox('INIT Article 1: '.$this->loading);
			//--------------------------DEBUG-------------------------
			//Are we being told to do something...?
			if (count($this->URLparams)>0)//this might be too raw TODO!!!
			{

				if ($this->loading==0)://this is actually for loading a new/empty or existing article for editing
												//but it is called as well for display article
					$resetLoadcount++;
					$this->loading++;
					
					if (isset($_POST['articleobject']))
						$loader=$_POST['articleobject'];
					
					$parent=$this->get_UParamByName('parent');
					if ($parent==-1):
						$parent=isset($_POST['articleParent'])?$_POST['articleParent']:-1;
						//articleParent ???
					endif;
					if ($parent==-1):
						
						//here we need a field
						if (is_null($r)):
							
							if ($this->get_URIlast()=='article_new'):
								//this is the only option when a complete empty params list is allowed
								$option='create';
								$action='admin_article';
								$MainArticle=TRUE;
								
							else:
								
								$action=$this->get_UParamByName('action');
								$option=$this->get_UParamByName('task');
								if (($action=='process')&&($option=='admin_article')):
									$MainArticle=TRUE;
								else:
									
									qmd_die('ERROR - no sufficient data for loading article');
								endif;
							endif;
						else:
							
							if (isset($r['art_parent'])):
								$parent=$r['art_parent'];
							
							endif;
							
						endif;
					endif;
					
					
					if (empty($option))				
						$option=$this->get_UParamByName('option');
					if (empty($action))
						$action=$this->get_UParamByName('action');
						
					//--------------------------DEBUG-------------------------
					//msgbox('INIT Article 2 - inner: '.$this->loading);
					//--------------------------DEBUG-------------------------
				endif;
			}//no query
			
			if (in_array($loader,$qmd_knownLoaders)==TRUE)
				$this->loading--;
			
			//--------------------------DEBUG-------------------------
			//msgbox('INIT Article 3 - outer RESET: '.$this->loading);
			//--------------------------DEBUG-------------------------
			
			//the next is outside the loop where $parent is modified
			//probably we want to give this as a param
			//in this case we better do this here instead of a part of the code that's not executed always

			if ($parent!==null)
				$parent_obj=$this->seekArticlebyID($parent);

			if ($MainArticle==true):
				//we load these only when we are loading the central object(s) not for the VACs...

				if ($r==null):

					if ($parent_obj<>null):
						if ($action=='admin_article'):
							if ($option=='create'):
								if ($parent_obj==null):
									$loader='';
								else:
									if ($parent_obj instanceof qmd_LIST==TRUE):
										$loader=$parent_obj->getChildLoader();
									endif;
								endif;
							endif;
						endif;
					else:
						//msgbox('3 - '.$action);
						//the next switch statement is quite a good place to make a decision and initialize something or other...
						//But actually I would not recommend this.
						switch ($action)://this part is under construction - we probably need to initialize more here
							case 'process':
								$task=$this->get_UParamByName('task');
								if ($task==-1):
									
								else:
									if ($task=='admin_article'):
										$schemeord= $_POST['cmbscheme']; //
										$aschemes=get_scheme_array();
										$xscheme=$aschemes[$schemeord];
										$this->selectedScheme=$xscheme.'/'; //this is always a valid scheme
									else:
									
									endif;
								endif;
								break;
							case 'admin_article':
								
								break;
							default:
								if ($loader=='qmd_msg_list_item')
								{//action =showItem
									
									//$loader='qmd_msg_list'
								}
						endswitch;
					endif;
				else://we need to set scheme here even if it is only temporary but we probably need the paths
					if (!empty($r['scheme'])):
						$xscheme=$r['scheme'];
				
						if (!empty($xscheme)):
							$this->set_selectedScheme($xscheme); 
								
						endif;
					endif;
				endif;
			endif;
			
			if ($r!=null)
				$loader=$r['objectloader'];

			if (empty($loader)):

				$result = new qmd_base_article($this,$r,'','');//using defaults
				
			else:
				if (in_array($loader,$qmd_knownLoaders)==FALSE)
				{
					$loader=$this->get_Path().$loader;
					//$list=glob('schemes/excursions/*');
					
					if (file_exists($loader)||(file_exists('/'.$loader))):
						include_once($loader);
					else:
						msgbox('check Database: '.$loader);
						qmd_die('internal error: Database Corrupt');
					endif;
				}

				/*###################################################################################
				/*###################################################################################
				/*###################################################################################
				/*###################  This is where you put the object-initialization  #############
				/*###################            of your own article-objects            #############
				/*###################################################################################
				/*###################################################################################
				/*###################################################################################
				/*#################################################################################*/
				
				switch ($loader):
					case 'qmd_msg_list':
						$result = new message_list($this,null);
						
						break;
					case 'qmd_msg_list_item':
						
						$parent_obj= new message_list($this,null);
						if ($parent_obj == null):
							//ok we could just hardcode the next - but let's stick to integers
							qmd_die('could not find parent object!');
						endif;
						$result = new message_list_item($parent_obj,null);
						break;
					case 'schemes/excursions/exc_list.php':
						
						$result = new excursions_list($this,$r);
						

						break;
					case 'schemes/excursions/exc_list_item.php':
						
						if ($parent_obj == null)
							qmd_die('could not find parent object! p-[2]');
				
						$result = new excursions_list_item($parent_obj,$r);

						break;
					case 'schemes/excursions/exc_contact.php':
						$result=new exc_contact_form($this,$r,'','');
						break;
					case 'schemes/digital/readme_loader.php':
						$result = new qmd_readme($this,$r);
						break;
					default:
						$result = new qmd_LIST($this,$r);
				endswitch;
				/*###################################################################################
				/*###################################################################################
				/*###################################################################################
				/*#################################################################################*/
			endif;
			
			if ($result!=null)
			{
				//$result->initialization(); 
				
				if ($onTargetItem>0)
				{
					if (is_null($result->ArticleRow['art_parent']))
					{
						$ix=$this->get_ID();
					}	
					else
						{$ix=$result->ArticleRow['art_parent'];}
					
					$sql='select a2m.*,m.menulink,m.show_sub_in_article_head,a.id as artid from '._PRE.'qmd_article2menu a2m 
						left join '._PRE.'qmd_menu m on (m.id=a2m.menu_id)
						left join '._PRE.'qmd_articles a on (a.id=a2m.article_id)';
					$sql.=' where article_id=?';
				
					$res=$qSQL->qSQLquick($sql,array($ix));
					if (is_array($res)&&(count($res)>0))
					{
						$ix=$res[0]['menu_id'];
						$this->fill_trace_to_men($ix);
						
						if ($res[0]['show_sub_in_article_head']>0)
							$this->fill_next_to_men($ix);
					}
					else
					{
						if (($action=='admin_article')&&($option=='create'))
							{/*everything ok here*/}
						else
						{
							if (($action=='process')&&($option=='admin_article'))
							{}
							else
							{
								msgbox('This should not happen 2! - ID: '.$ix);
								
							}
						}
						
					}	
				}
			}		
			
			
			if ($resetLoadcount>0)$this->loading=0;
			
			if ($instantiateproperty>0)
				$this->addArtObject($result);
				
			return $result;
		}//(F) load_Article_Data()
		
		function get_ArticleRec()
		{
			$result=NULL;
			$AO=$this->qmdA();
			if ($AO!=NULL):
				$result= $AO->ArticleRow;
			endif;
			return $result;
		}
		
		function get_ArticleField($Item)//may result NULL if no data loaded or FALSE if !xist $Item
		{
			$result=NULL;
			$AO=$this->qmdA();

			if ($AO!=NULL):
				if ((is_array($AO->ArticleRow))&&(count($AO->ArticleRow)>0)):
					if (array_key_exists($Item,$AO->ArticleRow)):
						$result= $AO->ArticleRow[$Item];
					else:
						$result=FALSE;
					endif;
				else:
					$result=FALSE;
				endif;
			endif;
			return $result;
		}
		function get_title($MetaDC=0)
		{
			//According to google they want to have title individually for each site
			//so we could just combine Title and Subject...
			
			
			$result='';			//TODO what about lists???? TODO
			$title=$this->get_ArticleField('title');
			
			if ((is_null($title))||(empty($title)))
				$title=s('website_title');//use default
				
			if ($MetaDC==0)
			{
				$result.= '<base href="'._SITE.'/" />';
				$result.= '<title>'.$title.'</title>';
			}
			else
				$result=$title;
			
			
			return $result;
		}
		
		function get_Meta_Date()
		{
		global $meta_default_date;
		global $qSQL;
			$result=null;

			$icountArticles=count($this->aArticleObjs);
			
			if ($icountArticles>0)
			{
				
				for ($iCount=0;$iCount<$icountArticles;$iCount++)
				{
					$A=$this->aArticleObjs[$iCount]->ArticleRow;
					if (is_array($A))
					{
						if ($result==null)
							$result=new datetime($A['date']);
						else
						{
							$dtdb=new datetime($A['date']);
							if ($dtdb>$result)
								$result=$dtdb;
						}
						
					}
					
				}
			}
			if ($result==null)
			{
				$result=new datetime;
			}
			
			return $result->format('c');
			
		}
		//function l
		function article_show_fullscreen(&$txt)//this is only to be called from the master index.php in /www/
		{//if you need the mode afterwards just get $qmdC->displayMode
			//$result = 0 no fullscreen mode - proceed with regular index.php
			//$result = 1 page mode show center
			//$result = 2 fullscreen mode - show $txt
			//$result = 3 fullscreen mode - include $txt
		
		global $qmd_const_URL_Params;
			$result=0;
			$txt='';
			$sURL='';
			$iArticlecount=count($this->aArticleObjs);
			if (($this->get_userPermission(__USER_isMod)>0)&& ($this->get_SEF()==$qmd_const_URL_Params[2]))
				$result++;
			else
			{
				switch ($iArticlecount):
					case 0;
						break;
					case 1:
						$AO=$this->qmdA();
						if ($AO<>null):
							if (count($this->URL)>0)
							{
								$sURL=$this->URL[0];
								if (($AO->getField('display_mode') & __pagemode)>0)
									$result++;


								if (($AO->getField('display_mode') & __fullscreen)>0):
									$result=2;
									$txt=$AO->getField('body');
									$i= strpos($txt,'[/include]');
									if ($i!==FALSE):
										$result++;
									endif;
								endif;

							}
						endif;
					
						break;
					default:
						//more than one article we use default 0 which is already set
				endswitch;
			}
			
				
			$this->displayMode=$result;
			return $result;
		}
		function set_SEFActive()
		{
			$this->callSEFFunc++;
		}
		function get_SEFActive()
		{
			return $this->callSEFFunc;
		}
		
		function _skipTrace($id,$modus)
		{
			
			$iCount=count($this->yTrace);
			while ($iCount>0):
				$iCount--;
				$x=$this->yTrace[$iCount];
				if (($x['traceMode']==$modus)&&($x['id']==$id)):
					dropFromArray($this->yTrace,$iCount);
					$iCount=0;
				endif;
				
			endwhile;
			return;
		}
		function set_skipMenu($menid)
		{
			$this->_skipTrace($menid,0);
			
			return;
		}
		function set_skipCat($catid)
		{
			$this->_skipTrace($catid,1);
			
			return;
		}
		
		function get_Path($useScheme=TRUE,$drop=0){
		//this will always result in a trailing slash!
			$result='';
			
			if ($drop>0):
				$i=0;
			
			
				if ($this->trailingSlash==TRUE) $i++;
				
				$i=$i+$drop;
				$result=str_repeat('../',$i);
				
			endif;
			
				
			if ($useScheme==TRUE):
				$result.='schemes/'.$this->selectedScheme;
			else:
				if (empty($result)):
					$result.='/';
				endif;
			endif;
			return $result;  	//this will always result in a trailing slash!
		}
		
		function user_link($Mode=0)
		{								//$Mode = 0 default design for footer (show only logoff or login)
										//$Mode = 1 username links 2 userpanel
										//$Mode = 2 show logoff & link 2 userpanel
										//$Mode = 4 link for breadcrumbs if logged in as Mod or higher
										//$Mode = 8 register
										//design for right side VAC = 13
										//design for footer = 0
										//design for breadcrumbs = 4
		//CAUTION: do apply 
		//					echo '<div class="qmd_user_link">';
		//				before calling this function or any other div-class that suits your needs
		//				and don't forget to close the div afterwards
			global $qmd_const_URL_Params;
			global $qmd_sefLink;
			
			$result='';
			$login='';
			$logoff='';
			//$register='';
			$userPanel='';
			//echo '<div class="qmd_user_link">';
			if ($this->urole==0):
				$login = qmd_createLink('login',l('login'),l('login'),1,0);
				if (($Mode & 8 >0)&&(s('multiuser')==1)):
					$login.= '<hr/>';
					$login.= qmd_createLink('/register',l('register'));
				endif;
			else:
				//echo 'Modus:'.$Mode;
				
				if ($Mode>0):
					$login.=l('user_greeting').'<b> '.$this->username.'</b>';
					if ($this->usrMSGs > 0)
						$login.= gethtmlspacer(4).'<b><a href="/'.$this->language.'/'.$qmd_sefLink[15].'"><img src="/dev.img/mail_in.png" alt="mail" />'.$this->usrMSGs.'</a></b>';//.'<br/>';
					$login.='<br/>';
				endif;
				
					
				$logoff 		= qmd_createLink('/logoff',l('logoff'));
				$userPanel	= qmd_createLink('/'.$qmd_const_URL_Params[6],l('userpanel'));;
				if ($this->urole==__USER_isMod):
					$sAdmin = qmd_createLink('/'.$qmd_const_URL_Params[5],l('moderation'));
				else:
					if ($this->urole>__USER_isMod):
						$sAdmin = '<br/>'.qmd_createLink('/'.$qmd_const_URL_Params[2],l('administration'));
					endif;
				endif;
			endif;
			
			$result=$login.$logoff;
			if ((!empty($userPanel))&&(($Mode & 1)>0))
				$result.=l('divider').$userPanel;
			if ((!empty($sAdmin))&&(($Mode & 4)>0))
				$result.=$sAdmin;
			echo $result;
			//echo '</div>';
		}
		function get_Func()
		{
			$result=$this->Func;
			
			return $result;
		}
		function resetTo($value)
		{
			$this->Func=$value;
			
		}
		
		function showArticlesFromList()
		{
			
			for ($iCount=0;$iCount<count($this->aArticleObjs);$iCount++):
				
				$ro=$this->aArticleObjs[$iCount];
					
				$this->ID=$ro->ArticleRow['artid'];
				
				if ($ro->displayArticle(0)==FALSE)//try showing the article - teaser (=0)
					qmd_die('ERROR showing this Article!');
			endfor;
			
		}
		/******************************************************************************************************************/
		function loadArticleRec($sql,$lang,$langID=-1)
		//we need a ready do run sql-statement, that may be changed and the language in question of the article.
		{
			$result=TRUE;
			
			$row=seekArticleWithLangSQL($sql,$lang,$this->SeekModeLang,$langID);//-1 for using the article in question anyway

			if ($row<>null):

				$this->ID=$row['artid'];
				
				$xObj=$this->load_Article_Data($row,true,'',0);
				if (is_null($xObj))
					msgbox('can not load item');
				else
					$this->addArtObject($xObj);
			else:

				$result=FALSE;
			endif;
			return $result;
		}
		
		function loadArticlebySEF($sef,$lang='')
		{
			
			$result=TRUE;
			$sql=query_get_art(6);//allow loading content of VAC
			$sql.=' AND (a.seftitle="'.$sef.'")';
			if (!empty($lang)):
				
				$this->SeekModeLang=-1;	//	1 seek for $lang exactly $lang will handed by param
												//-1 deliver any that can be found 
												//this is applicable by sef!
			endif;

			$result=$this->loadArticleRec($sql,$lang);
			
			return $result;
		}
		function load_default_article4scheme($scheme)
		{
		global $qSQL;
			$sql=query_get_art();
			$sql.=' AND (display_mode&'.__default4scheme.'>0) AND (scheme="'.$scheme.'")';
			$res=$qSQL->qSQLsimple($sql);

			$result=$this->loadArticleRec($sql,$this->language);
			return $result;
			
		}
		function loadArticlebyID($id,$lang='',$force=0,$langID=-1)
		{
		global $qmd_Lang_ALL;
			
			$result=TRUE;
			if ($force==0):
				$sql=query_get_art(6);//allow loading content of VAC
				$sql.='AND (a.id='.$id.')';
			else:
				$sql=query_get_art(0);//allow loading of unpublished/future articles
				$sql.=' WHERE (a.id='.$id.')';
				if ($langID>0)
					$sql.=' AND ML.id='.$langID;
			endif;
			if ($langID<0)
				if (!empty($lang)):
					if ($lang==$qmd_Lang_ALL):
						$this->SeekModeLang=-1;
					else:
						$this->SeekModeLang=1;	//	1 seek for $lang exactly $lang will handed by param
													//this is applicable by id cause we'll probably edit or delete the article!
					endif;
				endif;
			
			$result=$this->loadArticleRec($sql,$lang,$langID);
			
			return $result;
		}
		
		function seekArticlebyID($id,$lang='')//this seeks without loading the article but returning the object
		{
			global	$qmd_Lang_ANY;
			$result=null;
			$sql=query_get_art(6);//allow loading content of VAC
			
			$sql.='AND (a.id='.$id.')';
			
			if (!empty($lang)):
				if ($lang==$qmd_Lang_ANY):
					//this mode is used for deleting all languages of an article
					$this->SeekModeLang=-1;
				else:
					$this->SeekModeLang=1;	//	1 seek for $lang exactly $lang will handed by param
													//this is applicable by id cause we'll probably edit or delete the article!
													//
				endif;
			endif;

			$row=seekArticleWithLangSQL($sql,$lang,$this->SeekModeLang);//-1 for using the article in question anyway
			
			
			if (is_array($row))
				$result=$this->load_Article_Data($row,true);
			
			return $result;
		}

		//--------------------------------------------------------------------------
		
		function load_JS_CSS()
		{
			usort($this->AloadCSS,_cmp_css);
			for ($iCount=0;$iCount<count($this->AloadCSS);$iCount++)
			{
				echo '<link rel="stylesheet" type="text/css" href="'.$this->AloadCSS[$iCount].'" />'."\r\n";
			}

			for ($iCount=0;$iCount<count($this->AloadJS);$iCount++)
			{
				
				echo $this->AloadJS[$iCount];
				echo "\r\n";
			}
		}
		
		function load_js($js,$useTheme=TRUE,$drop=0,$preSlash=FALSE,$UseInclude=FALSE,$prependJS=TRUE,$UseQueue=TRUE)
		{
			$loadThis=1;
			$result='';
			//$list=glob('*');
			//yecho($list);	WE ARE on Web ROOT
			$sPath=$this->get_Path($useTheme,$drop);
			if ($sPath[0]=='/'):
				$sPath=substr($sPath,1,strlen($sPath));
			endif;
			
			
			if ($prependJS==TRUE):
				$sPath='js/'.$sPath;
			endif;
			
			if ($preSlash==TRUE):
				if ($sPath[0]!='/'):
					$sPath='/'.$sPath;
				endif;
			else:
				if ($sPath[0]=='/'):
					$sPath=substr($sPath,1,strlen($sPath));
				endif;
			endif;
			$this->_load_js2queue($sPath.$js,$UseInclude,$debug);
			
			return;
		}
		
		function _load_js2queue($js,$UseInclude,$debug=0)
		{
			
			if ($js[0]!=='/')
			{
				$js='/'.$js;
			}
			

			if ($UseInclude==TRUE)://this one is executed directly!
				$result='<script type="text/javascript">';
				$result.='include("'.$sPath.$js.'");';
				$result.='</script>';		
			else:
				$result.='<script type="text/javascript" ';
				$result.='src="'.$js.'"></script>';
			endif;
		
			if (!in_array($result,$this->AloadJS))//don't load twice
					$this->AloadJS[]=$result;// add to array with javascript files to load

		}
		
		function _load_css2queue($css,$debug=0)
		{
			$sPath=$this->get_Path(TRUE,-1);
			
			$loadThis=1;
			if ($debug>0)
				msgbox($css.' '.$sPath);
			
			if (!file_exists($css))
			{
				if ($css[0]!='/')
					$css='/'.$css;
				//if (!file_exists($css))
					//$loadThis--;	
			}
			if ($debug>0)
				msgbox($loadThis);
			if ($loadThis>0)
			{
				$result = $css;
				if (!in_array($result,$this->AloadCSS))//don't load twice
					$this->AloadCSS[]=$result;
			}
			else
			{	msgbox($css);
				send_sys_message('CSS-JavaScript file doesn\'t exist',$sPath.$css,1);
			}
		}
		function load_css($css,$useTheme=TRUE,$drop=0,$preSlash=TRUE,$appendCSS=TRUE,$Force=0,$debug=0)
		{
		/* $css Name of the file 
			$useTheme prepend current Theme
			$drop drop preceding dirs
			$preSlash should the name start with a slash
			$appendCSS should /css/ be appended to the path
			$Force = load anyway - even if if not fileexists
		
		*/
			if ($debug>0)
				msgbox($css);
			$loadThis=1;
			$sPath=$this->get_Path($useTheme,$drop);
			if ($appendCSS==TRUE)
				$sPath.='css/';
			
			if ($preSlash==TRUE)
			{
				if ($sPath[0]!='/')
					$sPath='/'.$sPath;
				
			}
			else
			{
				if ($sPath[0]=='/')
					$sPath=substr($sPath,1,strlen($sPath));
			}	
			
			$this->_load_css2queue($sPath.$css,$debug);
			return;
		}//-------------------------------------------
		
		function doLoad_css_js($Mode,$scheme)//$mode = 0 ->css 1->js
		{
			$result=0;
		
			if ($Mode==0)
				$loadAction='css';
			else
				$loadAction='js';
			$tmp='load_scheme_';
			
			$result=FALSE;
			$loadAny=s($tmp.$loadAction,1);
			
			if (getLastChar($scheme)=='/')
				$scheme=substr($scheme,0,strlen($scheme)-1);
			if ($loadAny>0)
			{
				$sPath='schemes/'.$scheme.'/'.$loadAction.'/';
				
				$iLen=strlen($sPath);
				
				$list = glob($sPath.'*.'.$loadAction); 

				for ($i=0;$i<count($list);$i++)
				{
					$loadThis=0;
					
					$sName=$list[$i];


					if ($loadAny>1)//load all
						$loadThis=1;
					else
						if (substr($sName,$iLen)==$scheme.'.'.$loadAction)
							$loadThis=1;

					if ($loadThis>0)
						if ($Mode==0)
						{
							$this->load_css($sName,FALSE,0,TRUE,FALSE);
							$result++;
						}
						else
						{
							$this->load_js($sName,FALSE,0,TRUE,FALSE,FALSE);	
							$result++;
						}
				}
				
			}
			
		}
		//#######################################################################
		function menushowNext(){
			$icount=$this->get_yNextcount();
			
			if ($icount>0):
			
				$caption='';
				for ($jCount=0;$jCount<$icount;$jCount++):
					$sLink=$this->get_yNextNo($jCount,$caption);
					echo '<h3>'.qmd_createLink($sLink,
														$caption).'</h3>';
				
				endfor;
				
			endif;
		}
		
		function showarticleEditLink($ARTICLE=null)
		{
			
			global $qmd_const_URL_Params;
			if ((s('admin_art_edit')>0)&&($this->get_userPermission(__USER_isMod)>0))
			{
				if ($ARTICLE==null)
					$ARTICLE=$this->qmdA();
				if ((!is_null($ARTICLE))&&($this->get_URIfirst()!==$qmd_const_URL_Params[2]))

				{
					$stype=get_class($ARTICLE);
					if (($stype!=='message_list')&&(($stype!=='message_list_item')))
					{
						echo '<div class="qmd_clearer"></div>';
						$edit_link = '<div class="qmd_button">'
												.qmd_createLink('/'.$qmd_const_URL_Params[2].'/?action=admin_article%26id='.$ARTICLE->ArticleRow['artid'].'%26editLang='.$ARTICLE->ArticleRow['lang'],
												l('edit'),l('edit').' '.l('article'))
												.'</div>';
						echo $edit_link;
						echo '<div class="qmd_clearer"></div>';
					}
				}
			}
		}
		
		//---------------------------------------------------------------------------------
		/**********************************************************************************
		/**********************************************************************************
		/**********************************************************************************
		/**********************************************************************************
		/**********************************************************************************
		/**********************************************************************************
		/**********************************************************************************
		/**********************************************************************************
		/**********************************************************************************/
		//=====================================================================URL-Handling
		
		function fill_next_to_men($parentid)
		{
			
			$iDBStatus=0;
			$iRowCount=0;
			
			$this->unset_yNext();
			
			$sql=query_get_menu().' WHERE parent='.$parentid;
			$sql.=' order by m.sort ';
			
			$rows=getSQL($sql,$iDBStatus,$iRowCount);
			
			if (($iDBStatus>=0)&&($iRowCount>0)):
				for ($iCount=0;$iCount<$iRowCount;$iCount++):
					$this->add_yNext($rows[$iCount]['menulink'],$rows[$iCount][$this->language],$rows[$iCount]['menid'],0);
				endfor;
			endif;
			
		}

		function fill_next_to_cat($parentid)
		{
			
			global $qmd_const_URL_Params;
			
			$iDBStatus=0;
			$iRowCount=0;
			
			$this->unset_yNext();
			
			$sql=query_get_cat().' WHERE parent='.$parentid;
			$rows=getSQL($sql,$iDBStatus,$iRowCount);
			
			if (($iDBStatus>=0)&&($iRowCount>0)):
				for ($iCount=0;$iCount<$iRowCount;$iCount++):
					$this->add_yNext($qmd_const_URL_Params[1].'/'.$rows[$iCount]['catlink'],$rows[$iCount][$this->language],$rows[$iCount][$catid],1);
					
				endfor;
			endif;
		}

		function fill_trace_to_men($parentid)
		{
			$iDBStatus=0;
			$iRowCount=0;
			
			$sql=query_get_menu().' WHERE m.id='.$parentid ;
			//$sql.=' order by m.sort ';
			$rows=getSQL($sql,$iDBStatus,$iRowCount);
			
			if (($iDBStatus>=0)&&($iRowCount>0)):
				
				if ($rows[0]['show_condition']==1)
					$this->add_yTrace($rows[0]['menulink'],$rows[0][$this->language],$rows[0]['menid'],0);
				$this->fill_trace_to_men($rows[0]['menparent']);
			endif;
		}

		function fill_trace_to_cat($parentid)
		{
			
			global $qmd_const_URL_Params;
			
			$iDBStatus=0;
			$iRowCount=0;
			
			$sql=query_get_cat().' WHERE id='.$parentid;
			
			$rows=getSQL($sql,$iDBStatus,$iRowCount);
			
			if (($iDBStatus>=0)&&($iRowCount>0)&&($rows[0]['published']>0)):
				
				$this->add_yTrace($qmd_const_URL_Params[1].'/'.$rows[0]['catlink'],$rows[0][$this->language],$rows[0]['catid'],1);
				$this->fill_trace_to_cat($rows[0]['catparent']);
			endif;
		}



		function get_article_by_sef($sef)
		{
			
			global $qmd_const_URL_Params;
			
			global $retr_cache_cat_id;
			
			$result=FALSE;
			$iDBStatus=0;
			$iRowCount=0;
			
			
			if ($sef!=s('home_sef')):
				
				if ($this->loadArticlebySEF($sef,$this->language)==TRUE):
					$result=true;
					
					if ($this->get_URIcount()>1)://need to include the trace
			
						//$this->unset_yNext();
						//$this->unset_yTrace();
						$this->set_SEF($sef);
						if ($this->get_URIfirst()==$qmd_const_URL_Params[1]):
							
							//TODO this should actually also look for the other one
							$ix=array_search($this->get_URI(1),$retr_cache_cat_id);
							
							
							if ($ix===FALSE):
								
							else:
								$this->fill_trace_to_cat($ix);
								$this->fill_next_to_cat($ix);
							endif;
						
						endif;
						
					endif;	
				endif;
				
			endif;
			return $result;
		}

		function _get_articles_by_men_getSQL($menulink)
		{

			$sql='select a2m.*,m.menulink,a.id as artid,a.show_on_home,ML.lang from '._PRE.'qmd_article2menu a2m 
					left join '._PRE.'qmd_menu m on (m.id=a2m.menu_id)
					left join '._PRE.'qmd_articles a on (a.id=a2m.article_id)
					left join '._PRE.'qmd_articles_ML ML on (ML.parent=a.id)';
			
			if ($menulink==s('home_sef')):
				
				if (s('display_page')<=0):
					$sql.=' where ((menulink="'.$menulink.'") OR (show_on_home=1))';
				else:
					$sql.=' where a.id='.s('display_page');
				endif;
			else:
				$sql.=' where (menulink="'.$menulink.'")';
			endif;
			$sql.=' AND ((display_mode & 1) >0)';
			$sql.=' AND (VAC=0)';
			$sql.=' ORDER by date DESC';
			
			return $sql;
		}
		
		function get_articles_by_men($menulink)
		{
			
			$ch=getLastChar($menulink);
			if ($ch=='/')$menulink=substr($menulink,0,strlen($menulink)-1);
			
			
			$result=FALSE;
			$iDBStatus=0;
			$iRowCount=0;

			$sql=query_get_menu().' WHERE menulink="'.$menulink.'"';
			
			$mrows=getSQL($sql,$iDBStatus,$iRowCount);
			
			if (($iDBStatus>=0)&&($iRowCount>0)):
				
				
				//$this->unset($this->aArticleObjs);
				$this->unset_yNext();
				$this->unset_yTrace();
				//TODO: maybe we should reverse the order of the next calls
				
				if ($mrows[0]['show_sub_in_article_head']>0)
					$this->fill_next_to_men($mrows[0]['menid']);
				
				$this->fill_trace_to_men($mrows[0]['menid']);
				
				$sql=$this->_get_articles_by_men_getSQL($menulink);
				$rows=getSQL($sql,$iDBStatus,$iRowCount);
				
				if ($iDBStatus>=0):
					if ($iRowCount>0)
					{
						$result=true;
						
						for ($iCount=0;$iCount<$iRowCount;$iCount++):
							$row=$rows[$iCount];
							
							$this->add_Article($row['artid'],null,0);
								
						endfor;
					}	
					else
					{
						if (is_callable($menulink)):
							$result=TRUE;
							$this->Func=$menulink;
						endif;
					}
					###
				
				endif;
				
				if (count($this->aArticleObjs)!=1):
				
					$this->set_selectedScheme($mrows[0]['scheme']);
				endif;
			
			endif;
			
			return $result;
		}

		function get_articles_by_cat()
		{
			
			global $qmd_const_URL_Params;
			$catname=$this->get_URIlast();//last 1
			$ch=getLastChar($catname);
			if ($ch=='/')$catname=substr($catname,0,strlen($catname)-1);
			
			
			$result=FALSE;
			
			$iDBStatus=0;
			$iRowCount=0;
			$this->unset_yTrace();
			$this->unset_yNext();
			
			if (($this->get_URIfirst()==$qmd_const_URL_Params[1])&&($this->get_URIcount()==1)):
				
				$this->fill_next_to_cat(0);
				
				$this->add_yTrace($qmd_const_URL_Params[1],l('categories'),-1,1);
				$result=TRUE;
				
			else:
				
				$sql=query_get_cat().' WHERE catlink="'.$catname.'"';
				$sql.=' AND (published =1)';
				
				$catrows=getSQL($sql,$iDBStatus,$iRowCount);
				
				if (($iDBStatus>=0)&&($iRowCount>0)):
					
					$catid=$catrows[0]['catid'];
					$parent=$catrows[0]['parent'];
				
					$sql='SELECT id,category,scheme from '._PRE.'qmd_articles WHERE category='.$catid;
					$sql.=' AND ((display_mode & 3) =3)';
					//$sql.=' AND (show_in_cats =1)';
					$sql.=' AND (VAC=0)';
					$sql.=' ORDER by date DESC';
					debuglog($sql,'by cat');
					$arows=getSQL($sql,$iDBStatus,$iRowCount);
					
					
					if ($iDBStatus>=0):
						
						$result=TRUE;
						$this->set_defaultCAT($catid);
						
						$this->fill_next_to_cat($catid);
						
						$this->fill_trace_to_cat($catid);
						
						
						$this->add_yTrace($qmd_const_URL_Params[1],l('categories'),-1,1);
						if ($iRowCount>0):
							for ($iCount=0;$iCount<$iRowCount;$iCount++):
								$row=$arows[$iCount];
								$this->add_Article($row['id'],null,0);
							endfor;
						endif;
					endif;
					if (count($this->aArticleObjs)!=1):
						$this->set_selectedScheme($catrows[0]['scheme']);
					endif;
					
				else:
				
					$result=$this->get_article_by_sef($catname);
				
				endif;
				
			endif;
			return $result;
		}


		function collect_call_params()
		{
			global $qmd_const_URL_Params;
			
			$result=FALSE;
			
			$s1=$this->URL[0];
			$s2=$this->get_URIlast();
			
			switch ($s1):
				case s('home_sef'):
					
					if ($this->get_articles_by_men($s1))://
						
						$result=true;
					endif;
					break;
					
				case $qmd_const_URL_Params[1]:
					//show categories
					if (count($this->URL)==1):
						$this->Func='categories';
						$result=TRUE;
					else:
						
						$result=$this->get_articles_by_cat();
					endif;
					
					break;
			endswitch;
				
			if ($result==FALSE):
				
				if ($this->get_article_by_sef($s2))://
					$result=TRUE;					//U1	
				else:
					
					if ($this->get_articles_by_men($s2))://this probably fails on listitem
						
						$result=TRUE;
					endif;
				endif;
			endif;
			
			return $result;
		}
		
		/************** URL Handling and Article selection ends*****************/
		
	function evalURL()
	{
	global $qmd_sefLink;
			
		$result=FALSE;
		
		$action=$this->get_UParamByName('action');
		//
		//in order to load css and JavaScript properly in time
		//we need to instatiate some 'pseudo-articles'

		if (!empty($this->Func)):
			switch ($this->Func):
				case $qmd_sefLink[5]://CONTACT
					//this is loaded additionally maybe the author of the site
					//wants to display more info to the contactform
					$result=$this->loadArticlebySEF('contact',$this->language);
					if (!$result)
						
					{	
						$result=$this->get_articles_by_men($this->Func);
						if ($result)
							$this->Func='';
						
					}
					
					//we do not check the result
					//if there is no article with 'contact' as seftitle it is not
					//loaded and we just display an empty contactform
					$result=TRUE;//we load function contact
					break;
				case 'usermessages'://this has been translated from user-messages [=$qmd_sefLink[15]]
					
					//this one requires JS being loaded
					$param=$this->get_URIlast();
					
					if (($action!='showItem')&&($action!='process'))//this is NOT mapped due to being a function
					{										// I know it's dirty ... )-;
						
						$this->load_Article_Data(null,TRUE,'qmd_msg_list',1);//instantiate
					}
					else
					{
						$this->load_Article_Data(null,TRUE,'qmd_msg_list_item',1);//instantiate
					}
					$result=TRUE;
					break;
			endswitch;
		else:
			
			if ($this->URL[0]==''):
				$result=FALSE;
			else:
				
				if ($this->ControllerMode>1):
					$result=TRUE;//admin and higher is handled automagically
				else:
					
					if ($this->get_ID()>0)://we have an ID to work with
						
						$result=$this->loadArticlebyID($this->get_ID(),$this->language);
					else:
						
						if (($action==-1)||($action=='comment')):
							
							$result=$this->collect_call_params();
						else:
							$this->set_SEF($action);
							$result=TRUE;
						endif;
						

						if ($result==TRUE):

							if ((count($_POST)>0)&&(empty($this->SEF))):
								
								switch(true):
									case isset($_POST['search_query']):
										$this->set_SEF('search_query');
										break;
									case isset($_POST['comment']):
										if ($action==-1):
											$this->set_SEF('comment');
										else:
											$this->set_SEF($action);
										endif;
										
										break;
									case isset($_POST['contactform']):
										$this->set_SEF('contactform');
										break;
									case isset($_POST['Loginform']):
										$this->set_SEF('login');
										break;
									case isset($_POST['submit_text']):
										$this->set_SEF('submit_text');
										break;
									default:
										if (isset($_POST['id'])):
											$this->ID=$_POST['id'];
										endif;
								endswitch; //switch
							
								
							endif;
							
							if (($this->get_ID()>0)&&($this->get_ArticleRec()==null)&&(count($this->aArticleObjs)<2)):
							
								$curLang=$this->get_UParamByName('editLang');
								if ($curLang==-1)://this is for displaying regular articles
							
									$this->loadArticlebyID($this->get_ID(),$this->language);
							
								else:
									//this is for edit an article and we need to load something different than default language
									
									$task=$this->get_UParamByName('task');
									$parentLang=$this->get_UParamByName('master');
									if (($task=='create')&&($parent<>-1)):
										$this->loadArticlebyID($this->get_ID(),$parentLang);
									else:
										$this->loadArticlebyID($this->get_ID(),$curLang);
									endif;
								endif;
							endif;
							
						endif;
					endif;
				endif;
			endif;
			
		endif;
		$iMax=count($this->aArticleObjs);
		
		$aschemes=get_scheme_array();
		
		if (count($this->aArticleObjs)==1)
		{
			
			
			$scheme=$this->aArticleObjs[0]->ArticleRow['scheme'];
			if (empty($scheme))
				$scheme=s('scheme');
			else
				if (array_search($scheme,$aschemes)===FALSE)
				{
					$this->aArticleObjs[0]->ArticleRow['scheme']=s('scheme');
					if (__y_local_test==1)
						msgbox('Invalid Scheme for: '.$this->aArticleObjs[$i]->ArticleRow['seftitle'].' '.$scheme.' Using: '.s('scheme'));
				}
		}
		else
		{
			$scheme=$this->selectedScheme;
			if (getLastChar($scheme)=='/')
				$scheme=substr($scheme,0,strlen($scheme)-1);
			
			if (array_search($scheme,$aschemes)===FALSE)
				$scheme=s('scheme');
			
			if (count($this->aArticleObjs)==0)
			{
				if (
						(empty($this->Func))
						&&
							(
								($this->ControllerMode<2)
								||
								($this->ControllerMode>5)
							)
					)
				{
					if ($this->load_default_article4scheme($scheme))
					{
						$result=TRUE;
						$this->set_SEF($this->aArticleObjs[0]->ArticleRow['seftitle']);
					}
				}
				else
				{if (($this->ControllerMode==2))
					$this->set_selectedScheme(s('scheme4admin'));
					$result=TRUE;
				}
			}
		}
		unset($aschemes);
		//if ($result)
		
			$this->doLoad_css_js(0,$this->selectedScheme);
			$this->doLoad_css_js(1,$this->selectedScheme);
		
		
		for ($i=0;$i<count($this->aArticleObjs);$i++)
		{
			$AO=$this->aArticleObjs[$i];
			$AO->initialize;
		}
		
		return $result;
	}
		
			
	//-------------------------------------------------------------------URL-Handling ends
	/*************************************************************************************
	/*************************************************************************************
	/*************************************************************************************
	/************************************************************************************/
	function qmd_initialize()//default scheme from qmdcms.php
	{
	global $qSQL;
		
		$scheme=s('scheme','default');
		$x=getLastChar($scheme);
			if ($x!='/')
				$scheme.='/';

		$this->selectedScheme=$scheme;//ok now a valid scheme has been set
		
		$result=$this->evalURL();//here scheme may be re-evaluated due to article
		
		if ($this->uid>0)
		{
			$sql='select count(id) as msgs from '._PRE.'qmd_user_msg where user_to=? and seen=?';

			$r=$qSQL->qSQLquick($sql,array($this->uid,0));

			$this->usrMSGs=$r[0]['msgs'];
		}
		else
			$this->usrMSGs=0;
		include_once('../qMDCMS/qmd_menu.php');//ok
	
		//----------------------------------------------------------------------------------------------
		include('../qMDCMS/qmd_meta.php');	//DON'T PUT YOUR METADATA HERE!! put it in file:../GLOBALS/qmd_app_config.php !!!
		
		return $result;
	}
	function InitDebug()
	{

		if (__y_DEBUG>3)
		{
			
			$_DEBUG_CSS=array();
			$_DEBUG_CSS['/css/lert.css']='blue on yellow Courier';
			$_DEBUG_CSS['/css/qmd_list.css']='blue on white';
			$_DEBUG_CSS['/css/qmd.css']='pink on transparent';
			$_DEBUG_CSS['/css/qmd_admin.css']='white on red';
			$_DEBUG_CSS['/css/qmd_menu_css.php']='black on pink';
			$_DEBUG_CSS['/css/qstyle.css']='white on black';
			$_DEBUG_CSS['/css/bodystyle.php']='black on white';
			$_DEBUG_CSS['/css/qmd_menu.css']='blue on red';
			$_DEBUG_CSS['/css/qmd_vac.css']='black on light blue';
			$_DEBUG_CSS['/schemes/default/css/bodystyle.php']='black on white Arial';
			$_DEBUG_CSS['/schemes/default/css/qstyle.php']='yellow on dark';
			$_DEBUG_CSS['/schemes/sha-mash.de/css/xcursions.css']=' xxx on yyy';
			$_DEBUG_CSS['schemes/excursions/exc_list.css']=' orange on blue';
			$_DEBUG_CSS['/schemes/excursions/css/bodystyle.php']=' black on yellow';
			$_DEBUG_CSS['/schemes/excursions/css/qstyle.css']=' yellow on black';
			$_DEBUG_CSS['/schemes/qimanfaya/css/bodystyle.php']='Arial white on black';
			$_DEBUG_CSS['/schemes/qimanfaya/css/qimanfaya.css']='Times yellow on black';
			$_DEBUG_CSS['/schemes/qimanfaya/css/qstyle.css']='Courier yellow on brown';
			for ($iCount=0;$iCount<count($this->AloadCSS);$iCount++)
			{
				$cssName=$this->AloadCSS[$iCount];
				$i=strlen($cssName);
				$jMax=$i;
				$search=TRUE;
				while ($search==TRUE)
				{
					if ($cssName[$i]=='/')
						$search=FALSE;
					else
						if ($i==0)
							$search=FALSE;
						else
							$i--;
				}
				
				if(array_key_exists($cssName,$_DEBUG_CSS))
				{
					$txtexpected=$_DEBUG_CSS[$cssName];
				}
				else
					$txtexpected=' -- undefined --';
				$cssItem=substr($cssName,$i+1,$jMax);
				$cssItem=substr($cssItem,0,strlen($cssItem)-4);	
				debug_css($cssItem.'_DEBUG_loadtest','Lorem Ipsum '.$txtexpected,$cssName.' '.$cssItem);
			}
			
			for ($iCount=0;$iCount<count($this->AloadJS);$iCount++)
			{
				$s=$this->AloadJS[$iCount];
				$i=strpos($s,'src="');
				$s=substr($s,$i+5);
				$i=strpos($s,'"');
				$s=substr($s,0,$i);
				$i=strrpos($s,'/');
				$s=substr($s,$i+1);
				
				$i=strrpos($s,'.');
				$s=substr($s,0,$i);
				
				$s.='_DebugLoadTest();';
				execJS($s);
			}
			unset($_DEBUG_CSS);
		
		}
	}
	//************************************************************************************
	/*************************************************************************************
	/*************************************************************************************/
	//====================================================================================
	function editArticle($artid,$loader='',$force=0)
	{
		global $qmd_const_URL_Params;
		global $LANG;
		global $qmd_Lang_ANY;
		
		$curLang=$this->get_UParamByName('editLang');
		if ($curLang==-1):
			$curLang=$this->language;
		endif;
		$parentLang=$this->get_UParamByName('master');
		$task=$this->get_UParamByName('task');
		if (($task=='create')&&($parentLang!=-1)):
			$AO=$this->qmdA();
			
			$loaded=($AO->ArticleRow['artid']==$artid);
			if ($loaded==false):
				
				$loaded=$this->loadArticlebyID($artid,$parentLang,1);//empty parameter will reset SeekModeLang to 1 and deliver anyway
				if (!$loaded):
					
					msgbox('Error loading Master');
				endif;
			endif;
			$AO=$this->qmdA();
			$MLID=$AO->createLangCopy($curLang);
			
			unset($this->aArticleObjs);//clear this here...
			$loaded=$this->loadArticlebyID($artid,$curLang,1,$MLID);
			//die('STOP');
		else:
			if ($artid>0):
				$AO=$this->qmdA();
				if (!is_null($AO)):
					
					if ($AO->getArticleID()!=$artid):
						unset($this->aArticleObjs);//clear this here...
						$loaded=$this->loadArticlebyID($artid,$curLang,1);
					else:
						
						if ($AO->ArticleRow['lang']==$curLang):
							
							$loaded=true;
						else:
							unset($this->aArticleObjs);//clear this here...
							$loaded=$this->loadArticlebyID($artid,$curLang,1);
							if ($loaded):
								$loaded=$AO->ArticleRow['lang']==$curLang;
							endif;
							
						endif;
					endif;
				else:
					
					$loaded=$this->loadArticlebyID($artid,$curLang,1);
					if ($loaded==FALSE):
						
						//$this->SeekModeLang=1;
						$this->SeekModeLang=-1;
						$loaded=$this->loadArticlebyID($artid,'',1);//empty parameter will reset SeekModeLang to 1 and deliver any
						if ($loaded==FALSE)msgbox('can not load article: '.$artid);
					endif;
				endif;
			else:
				//we need to keep in mind that there might be a new article for an existing loader
				
				$this->load_Article_Data(null,TRUE,$loader,1);//instantiate to aArticleObjs
				
				$loaded=TRUE;
			endif;
		endif;

		if ($loaded==TRUE):
			$AO=$this->qmdA();
			$AO->DoEditArticle();
		else:
			qmd_die('unable to load this article - FIN');
		endif;
	
	}//editArticle

}
?>