<?php	
/*
/*
	Program: qmd-cms [qimanfaya-Menu-Driven-CMS]
	
	------------------------------
   qmd-cms - DATABASE Library File #1
   qmd-cms 0.8.2
	last update: 03/09/2014

	--------------------------------

	qmd_db.php
	=============

	This file is part of the qmd-php-library
	
	Author: ***hy
	For further reference regarding this code see qmdcms.php and the readme-files.
	
	This code was developed by ****hy
	Copyright: qimanfaya/hy-soft 2012,2014
	
	Licence:		GPL V.3

	A copy of the GNU General Public License is available:
	in the root of this folder
	and on the World Wide Web
	at <http://www.gnu.org/licenses/gpl-3.0.txt>. You can also obtain it by writing
	to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
	MA 02111-1307, USA.
			
			
	USAGE:
	------
	Please keep this code free of anything related to your Website/System
	so we can reuse it for other project.
*/


/*
		This is in order to encapsulate DB-Queries
		so this is the place where you should alter the code if you're not having mySQL
		
*/
//************************************Utility ****************************


function findfirstlimit($hay,$char,$default)
{
	
	
	$iPos=strpos($hay,$char);
	if ($iPos===FALSE):
		$result=$default;
	
	else:
		if ($iPos<$default):
			$result=$iPos;
	
		else:
			$result=$default;
	
		endif;
	endif;
	
return $result;
}


function cleanInput($input,$mode=15) {
 
	$search = array(
		'@<script[^>]*?>.*?</script>@si',   // Strip out javascript				1
		'@<[\/\!]*?[^<>]*?>@si',            // Strip out HTML tags					2
		'@<style[^>]*?>.*?</style>@siU',    // Strip style tags properly			4
		'@<![\s\S]*?--[ \t\n\r]*>@'         // Strip multi-line comments			8
	);
	//mode for leaving HTML in the input: 13
	
	$i=8;
	while ($i>=1):
		if (($mode & $i)==0)array_pop($search);
	
		$i=$i/2;
	endwhile;
 
	$output = preg_replace($search, '', $input);
   return $output;
}
function sanitize($input,$mode=15)
{//this is from http://css-tricks.com/snippets/php/sanitize-database-inputs/
//thanks

	global $DATABASE;

   if (is_array($input)):
		foreach($input as $var=>$val):
			$result[$var] = sanitize($val);
		endforeach;
	else:
		$input = stripslashes($input);
		
		$input  = cleanInput($input,$mode);
		$result = $DATABASE->real_escape_string($input);
	endif;
	return $result;

}
function cleanMeta($txt)
{
	
	$qHTML_pattern='(.+)';
	//$result = preg_replace('/\"/U', '!quote!', $txt); // 

	$result = preg_replace('/<'.$qHTML_pattern.'>/U', '', $txt); // 

	
	$result=htmlentities($result,ENT_COMPAT | ENT_HTML401 ,'UTF-8' ,false);

		
	return ($result);
}

function cleanText($txt)
{
	
	$qHTML_pattern='(.+)';
	$result = preg_replace('/\"/U', '!quote!', $txt); // 

	$result = preg_replace('/<'.$qHTML_pattern.'>/U', '[[$1]]', $result); // 

	
	$result=htmlentities($result,ENT_COMPAT | ENT_HTML401 ,'UTF-8' ,false);

	$result = preg_replace('/!quote!/U', '"', $result); // 

	$result = preg_replace('/\[\['.$qHTML_pattern.'\]\]/U', '<$1>', $result); // 

	
	return ($result);
}
//************************************Utility ends ****************************
// CONNECT TO DATABASE

function _sanitize_article($body,$mode)//mode 0 sanitize 1 unsanitize
{
	$search = array(
		'(\\r\\n)',
		'(\')',
		'(")'
		
	);
	$replace = array(
	'<br/>',
	"'",
	'"'
	);
	if ($mode==0):
		$output = preg_replace($search,$replace, $body);
	else:
		$output = preg_replace($replace,$search, $body);
	endif;
   return $output;
}
function sanitize_article($body)//mode 0 sanitize 1 unsanitize
{
	return _sanitize_article($body,0);
}
function unsanitize_article($body)//mode 0 sanitize 1 unsanitize
{
	return _sanitize_article($body,1);
}

function connect_to_db($DBName='')
{
	$result=false;
	global $DATABASE;
	
	if ($DBName!==''):
		
		$i=1;
		while ($i<=db('known_dbs')):
			$sItem='Item'.$i;
			$kdba=db('known_dbA');
			$sDB=$kdba[$sItem];
			
			if ($sDB['dbname']==$DBName):
			
				$dbHost=$kdba[$sItem]['dbhost'];
				$dbUser=$kdba[$sItem]['dbuname'];
				$dbPwd =$kdba[$sItem]['dbpass'];
				
				$i=db('known_dbs');
				
			endif;
			$i++;
		endwhile;
		if ($sDB['dbname']!==$DBName)$DBName='';
	endif;
	if ($DBName==''):
		$DBName=db('dbname');
		$dbHost=db('dbhost');
		$dbUser=db('dbuname');
		$dbPwd =db('dbpass');
	endif;
	if ($DATABASE==NULL):
		$DATABASE = new mysqli($dbHost, $dbUser, $dbPwd);
	endif;
	
	$DATABASE->select_db($DBName);
	/* check connection */
	if ($DATABASE->connect_errno):
	
		printf("Connect failed: %s\n", $DATABASE->connect_error);
		qmd_die('DB-ERROR');
	else:
		
		$result=TRUE;
	endif;
	return $result;
}


function runSQL($SQL,&$Res,&$newID=-1)
{
	/*
		This is in order to encapsulate DB-Queries
		so this is the place where you should alter the code if you're not having mySQL
		
	*/
	global $DATABASE;
	
	$result=0;
	/* result:
		SELECT = count ROWS -1=ERROR
		DELETE : -1 error 1 ok
		INSERT : -1 error 1 ok
		UPDATE : -1 error or count ROWS affected
		ALTER  : -1 error 1 ok
	*/
	$SQL=ltrim($SQL);
	$iPos=findfirstlimit($SQL,chr(32),9999000);
	$iPos=findfirstlimit($SQL,chr(9),$iPos);
	
	$iPos=findfirstlimit($SQL,chr(10),$iPos);
	$iPos=findfirstlimit($SQL,chr(13),$iPos);
	

	$mode=substr($SQL,0,$iPos);
	
	
	$mode=strtoupper($mode);
	
	$Res=$DATABASE->query($SQL);
	
	
	$oresult=-43;
	if ($Res===false):
		msgbox('runSQL FALSE');
		
		debuglog($DATABASE->error,'[runSQL-Error]',true);
		$result--;
		$oresult--;
	else:
		switch ($mode):
			case 'SHOW':
			case 'SELECT':
						$oresult=$Res->num_rows;
						if ($oresult===TRUE):
							$result=0;
						else:
							if ($oresult===FALSE):
								msgbox('oresult false');
								$result=-1;
							else:
								if ($oresult<0):
									if ($oresult==-44):
										msgbox('oresult: -44');
									endif;
									$result=0;
								else:
									$result=$oresult;
									
								endif;
							endif;
						endif;
					break;				// = count ROWS -1=ERROR

			case 'DELETE' : 

					$result=$DATABASE->affected_rows; //-1 error 0..n ok count ROWS affected
					$oresult=41;
					break;
			case 'INSERT' : $result++;//-1 error 1 ok

					$oresult=49;
					$newID=$DATABASE->insert_id;
					break;
			case 'UPDATE' :  $result=$Res->affected_rows; //-1 error 0..n ok count ROWS affected

					$oresult=47;

					if (!$result):
						$result=1;
					endif;
					break;
			case 'DESC':
						$oresult=$Res->num_rows;
						if ($oresult===TRUE):
							$result=0;
						else:
							if ($oresult===FALSE):
								msgbox('false');
								$result=-1;
							else:
								if ($oresult<0):
									if ($oresult==-44):
										msgbox('foo oresult -44');
									endif;
									$result=0;
								else:
									$result=$oresult;
								endif;
							endif;
						endif;
				break;
			default: $result--;
				$oresult=90;

				msgbox('runSQL: '.$mode.' not allowed here');
				
		endswitch;
	endif;//$res=TRUE
	//$Res->close();
	if ($result<0):
		debuglog($mode,'MODE:');
		debuglog($oresult,'Orig. result:');
		debuglog($result,'result:');
		debuglog($SQL,'SQL');
		//qmd_die($DATABASE->errorInfo());
	endif;
	
	return ($result);
}
function getSQL($sql,&$iStatus,&$rowCount,$DEBUG=0)
{
/* the result may be checked like this

	$iDBStatus=0;
	$iRowCount=0;
	
	$resultSet=getSQL($test,$iDBStatus,$iRowCount);
	
	if ($iDBStatus * $iRowCount >0):
		//we have data
	else:
		if ($iDBStatus<1):
			//we have an error
		else
			if ($iRowCount=0):
				//we have no data
			else
				//should not happen
			endif;
		endif:
	endif;
	
	*/
	//$res=TRUE;
	$rowCount=0;
	$iStatus=-1;
	
	$rowCount=runSQL($sql,$res);
	
	if ($rowCount>=0):
		$iStatus++;
		if ($DEBUG>0):

		endif;
		
		$result=array();
		if ($rowCount>0):
		
			while ($row=$res->fetch_assoc())://((PDO::FETCH_ASSOC));

				if (count($row)==0) continue;

				$result[] = $row;

			endwhile;
			$iStatus++;
		endif;
		
	else:
		$result=FALSE;
		msgbox('getSQL: Error retrieving DATA: '.$rowCount);
		debuglog($sql,'getSQL: Error retrieving DATA: '.$rowCount);
	endif;
	$res->close();
	return $result;
}

function insertSQL($SQL,&$id)
{
	$result=0;
	$res=NULL;
	$ins=runSQL($SQL,$res,$id);
	if ($ins>0):
		$result++;
	else:
		msgbox('insert failed');
		$result--;
	endif;

	return $result;
}

function execSQL($SQL)
{
	$result=0;
	$res=NULL;
	$newID=-1;
	$x=runSQL($SQL,$res,$newID);
	if ($x>0):

		$result++;
	else:
		msgbox('Error on ExecSQL: '.$x);
		$result--;
	endif;

	return $result;
}

function create_new_language($newlang,$fromlang='EN')// this is not working and not complete you have to do it manually
{	
	global $qmdC;
	
	if (!row_exists(db('dbname'),'qmd_menu_ML ',$newlang)):
		$sql = 'ALTER TABLE '._PRE.'qmd_menu_ML add COLUMN '.$newlang.' CHAR(25)';
		
		$res=execSQL($sql);
	
		if (row_exists(db('dbname'),_PRE.'qmd_menu_ML ',$fromlang)):
			$sql = 'UPDATE  '._PRE.'qmd_menu_ML as ML set ML.'.$newlang.' =  ML.';
		else:
			$sql = 'update '._PRE.'qmd_menu_ML as ML, qmd_menu as m set ML.'.$newlang.' =  '.$qmdC->language.' where ML.mid=m.id';
		endif;

		$res=execSQL($sql);
	endif;
}

// ***************************************mySQL-s7uff

function DESC_TABLE($tablename)
{
	global $qSQL;
	
	$xID=0;

	$sql='DESC '._PRE.$tablename;
	
	$r=$qSQL->qSQLsimple($sql,1);//0=don't show errors
	
	if (!is_array($r)):
		unset($r);
		$r=null;
	endif;
	return $r;
}

function table_exists($tablename)
{
	$result=false;
	$r=DESC_TABLE($tablename);
	
	if (is_array($r)):
		$result=true;
	else:
		$result=false;
	endif;
	return $result;
}
	
function field_exists($databasename,$tablename,$testfield)
{
	$result=false;

	$iDBStatus=0;
	$iRowCount=0;
	
	$sql='SHOW COLUMNS FROM '._PRE.$tablename;
	$res=getSQL($sql,$iDBStatus,$iRowCount);
	if (is_array($res)):
		$iMax = count($res);
		$i=0;

		while ($i<$iMax):
			$row=$res[$i];

			if ($testfield==$row['Field']):
				$i=$iMax;
				$result=true;
			endif;
			$i++;
		endwhile;
	endif;
	return $result;
}
// ***************************************mySQL-s7uff ends

//CONTENTS COUNTER
function count_table_entries($table, $field="id", $where="")
{

 	$result=0;
	$iDBStatus=0;
	$iRowCount=0;

	$query = 'SELECT count('.$field.') Y FROM '._PRE.$table.' '.$where;
	$rows = getSQL($query,$iDBStatus,$iRowCount);
	if (($iDBStatus>=0)&&($iRowCount>=0)):
		$result=$rows[0]['Y'];
	endif;
	
	return $result;
}
function map_URIs($URI,$sURLComplete){
	
	$iDBStatus=0;
	$iRowCount=0;
	$lStop=FALSE;
	$iMax=count($URI);
	
	$extSeek=array();
	
	if ($iMax==0):
		$URI[0]=s('home_sef');
	else:
		if (($iMax==1)&&($URI[0]==s('home_sef'))):
			//nothing to do
		else:
			$SQL='SELECT * from '._PRE.'qmd_URL_mappings';
			
			$maprows=getSQL($SQL,$iDBStatus,$iRowCount);
			
			if (($iDBStatus>=0)&&($iRowCount>0)):
				for ($jCount=0;$jCount<$iRowCount;$jCount++):
					$s2=$maprows[$jCount]['URL'];
					$xx=strpos($s2,'/');
					if (($xx==FALSE)||($xx<0)):
						$testkey=array_search($s2,$URI);
						if ($testkey!==FALSE):
							$URI[$testkey]=$maprows[$jCount]['map_to'];
						endif;
					else:
						$extSeek[]=$jCount;
					endif;
				endfor;
			
				if (count($extSeek)>0):
					$iCount=0;
					while ($iCount<count($extSeek)):
						$ItemIndex=$extSeek[$iCount];
						$Item=$maprows[$ItemIndex]['URL'];

						$Item=str_replace('/','\/',$Item);
						$testItem=preg_match('/'.$Item.'/',$sURLComplete);
		
						if ($testItem==1):
							unset($URI);
							$URI=array($maprows[$ItemIndex]['map_to']);
							$iCount=count($extSeek);
						else:
							$iCount++;
						endif;
					endwhile;
				endif;
			endif;
		endif;
	endif;
	
	unset($extSeek);

	return $URI;
}

?>