<?php
/*
	Program: qmd-cms [qimanfaya-Menu-Driven-CMS]
	
	------------------------------
   qmd-cms - DATABASE Library File #2
   qmd-cms 0.8.6
	last update: 04/11/2014

	--------------------------------

	qmd_db_class.php
	=============

	This file is part of the qmd-php-library
	
	Author: ***hy
	For further reference regarding this code see qmdcms.php and the readme-files.
	
	This code was developed by ****hy
	Copyright: qimanfaya/hy-soft 2012,2014
	
	Licence:		GPL V.3

	A copy of the GNU General Public License is available:
	in the root of this folder
	and on the World Wide Web
	at <http://www.gnu.org/licenses/gpl-3.0.txt>. You can also obtain it by writing
	to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
	MA 02111-1307, USA.
			

*/

class qmd_SQL
{
/*

	DO NOT add the WHERE clause if you supply WHERE-params!!!
	WHERE CLAUSE is added automagically!
	
	fetch data via SQL
		use: 	qSQLdirect
		or:	qSQLquick
		or:	qSQLsimple
		
	update 
		if ($qSQL->prepareupdate($aFields,$aValues,$aWhereFields,$aWhereVals,$aOPs)>0):
			$res=$qSQL->updateSQL($sTable,$iRows);//			iRows will return the number of rows affected
			if ($res==1):
				msgbox($iRows.' affected');
			endif;
		endif;
		
		
	insert
		if ($qSQL->prepareinsert($aFields,$aVals)>0):
			$res=$qSQL->insertSQL($sTable,$iNewID);
			if ($res==1):
				//iNewID is the new ID
			else:
				//error on isert
			endif;
		else:
			//error
		endif;
		
	delete  
		if ($qSQL->preparedelete($aWhereFields,$aWhereVals,$aOPs)>0):
			$res=$qSQL->deleteSQL($sTable,$iRows); 	//iRows will return the number of rows affected
			if ($res>0):
				msgbox($iRows.' affected');
			else:
				//error
			endif;
		else:
			//error
		endif;
		
	or do any with 
		qSQLdirect($sql,aVALS,$xID)
	
		
*/
	var $connlink;
	var $SQL;
	var $ar;
	var $aFields;	//array of fields for insert or update
	var $aValues;	//array of values -"-
	var $WHEREF;	//array of fields for where
	var $WHEREV;	//array of values for where
	var $WHEREOP;	//array of Where Operators AND OR & | ...
	var $MODE;		//SELECT,UPDATE,INSERT,DELETE
	var $sOrderBy;
	var $iFields;
	var $iWhere;
	var $rowsfetched;
	
	function __construct(){	//
		$this->reset();
	}
	
	private function _checkMode()
	{
		$result=-1;
		
		$s=ltrim($this->SQL);
		$iPos=findfirstlimit($s,chr(32),9999000);
		$iPos=findfirstlimit($s,chr(9),$iPos);
		
		$iPos=findfirstlimit($s,chr(10),$iPos);
		$iPos=findfirstlimit($s,chr(13),$iPos);
		

		$mode=substr($s,0,$iPos);
			
		$mode=strtoupper($mode);
		
		
		if (empty($this->MODE)):
			$this->MODE=$mode;
			$result++;
		else:
			if ($mode==$this->MODE)$result++;
		endif;
		return $result;
	}
	
	private function reset(){
		$this->rowsfetched=-1;
		$this->iFields=-1;
		$this->iWhere=-1;
		
		$this->MODE='';
		$oldSQL=$this->SQL;
		$this->SQL='';
		$this->sOrderBy='';
		
		
		
		if (isset($this->connlink)):	//array of fields for insert or update
			
			try
				{

				//$this->connlink->close();
				//$this->connlink->free_result();
				
				}
			catch  (\Exception $e) 
				{
					debuglog($e,'EXCEPTION');
				}
			
				unset($this->connlink);
			
			
		endif;
		
		if (isset($this->ar))	//array of fields for insert or update
			unset($this->ar);
		
		if (isset($this->aFields))	//array of fields for insert or update
			unset($this->aFields);
		//$this->aFields=Array();
			
		if (isset($this->aValues))	//array of values -"-
			unset($this->aValues);
		//$this->aValues=Array();
		
		if (isset($this->WHEREF))	//array of fields for where
			unset($this->WHEREF);
		//$this->WHEREF=Array();
		
		if (isset($this->WHEREV))	//array of values for where
			unset($this->WHEREV);
		//$this->WHEREV=Array();
		
		if (isset($this->WHEREOP))	//array of Where Operators AND OR & | ...
			unset($this->WHEREOP);
		//$this->WHEREOP=Array();
		
		return;
	}
	private function _debuglog($sError,$showError=0)
	{
		
		if ($showError>0)msgbox($sError);
		debuglog($sError);
		yecho($this->ar);
		debuglog('DB-ERROR');
		debuglog($this->SQL,'SQL in _SQLsecureDataMod',FALSE);
		debuglog($this->ar,'AR');
		
		debuglog($this->connlink,'CONNLINK' );
	}
	private function _SQLsecureDataMod(&$iNew,$showError=1)
	{	//will result in 0 if some error (DESC...)
		//-1 on grave errors
		//1 on success
		global $DATABASE;
		$result=-1;
		
		
		$this->connlink = $DATABASE->prepare($this->SQL);
		if ($this->connlink==FALSE):
			msgbox('ERROR DB 1xa',6);
			$this->_debuglog('error preparing SQL: '.$this->SQL,$showError);
			
			unset($this->connlink);
		else:
			$continue=1;
			
			if (isset($this->ar[0])):
			
				if (call_user_func_array(array($this->connlink,'bind_param'),$this->ar)==FALSE):
					
					$this->_debuglog('error for instantiating params',$showError);
					qmd_die('error for instantiating params');
					
					$continue=-1;
				endif;
			
			endif;
				
			if ($continue>0):
				
				$iRes=$this->connlink->execute();
				if ( $iRes==TRUE):
	
					$result =1;
				else:
					if ($this->MODE=='DESC'):
						//no need for Error output DESC may be called from (f) table_exists() ...
						
						$result=0;
					else:
						$this->_debuglog('error on SQL',1);
						$result =-1;
					endif;
					
				endif;
				
				if ($result<>0):
					if ($this->connlink->errno!=0):
				
						$this->_debuglog('Error excuting SQL',$showError);
						qmd_die($this->connlink->error);
					else:
						
				
						if ($this->MODE=='INSERT'):
							$iNew=$this->connlink->insert_id;
							
						else:
							
							$iNew=$this->connlink->affected_rows;
							
						endif;
					endif;
				endif;
			else:
				
			endif;
		endif;
		
		return $result;
	}

	private function _SQLsecureDM(&$NewVal,$showError=1)
	{
		if ($this->MODE=='INSERT'):

			for ($i=0;$i<$this->iFields;$i++):
				if ($i==0):
					$this->SQL.='(';
				else:
					$this->SQL.=',';
				endif;
				$this->SQL.=$this->aFields[$i];
			endfor;
		
			$this->SQL.=') VALUES (';

			for ($i=0;$i<$this->iFields;$i++):
				if ($i>0)		
					$this->SQL.=',';
				$this->SQL.='?';
				
			endfor;
			$this->SQL.=')';
		else:
			if ($this->MODE=='UPDATE'):
				
				for ($i=0;$i<$this->iFields;$i++):
					$this->SQL.=$this->aFields[$i].'=?';
					if ($i<$this->iFields-1):
						$this->SQL.=',';
					endif;
				endfor;
			endif;
			
			for ($i=0;$i<$this->iWhere;$i++):
				if ($i==0)$this->SQL.=' WHERE ';
				$this->SQL.=' '.$this->WHEREF[$i].'? ';
				if ($i<$this->iWhere-1):
					$this->SQL.=$this->WHEREOP[$i].' ';
					$this->WHEREV[$i]=sanitize($this->WHEREV[$i]);
				endif;
			endfor;
			
		endif;
		$this->SQL.=$this->sOrderBy;
		
		$result=$this->_SQLsecureDataMod($NewVal);
		
		return $result;
	}
	
	private function prepareData($aF,$aV,$aWF,$aWV,$aOP)
	{//returns 1 if ok -1 for any errors
		
		$result=0;
		
		$iWF=0;
		$iFF=0;
		
		if ($aF<>NULL)$this->aFields=$aF;
		if ($aV<>NULL)$this->aValues=$aV;
		if ($aOP<>NULL)$this->WHEREOP=$aOP;
		if ($aWF<>NULL)$this->WHEREF=$aWF;
		if ($aWV<>NULL)$this->WHEREV=$aWV;
		
		
		if ($this->MODE<>'INSERT')://we have to check WHERE only for NON-inserts
		
			if (isset($this->WHEREF))$iWF=count($this->WHEREF);
			if (isset($this->WHEREV)):
				if ($iWF!=count($this->WHEREV)):
					
					$result--;
				else:
					if (isset($this->WHEREOP)):
						
						if ($iWF>0):
							if (count($this->WHEREOP)+1!=$iWF):
								if (__y_local_test>0):
									msgbox('WHERE 2: '.$iWF.' '.count($this->WHEREOP));
								else:
									send_sys_message('DB-Error','WEHEREOP AND WHEREFIELDS DONT MATCH[br/]'.$this->SQL.' [br/]'.'',1);
								endif;
								
								$result--;
							endif;
						endif;
					else:
						if ($iWF<>1):
							$result--;
							msgbox('Where Operator missing [3]');
						endif;
					endif;
				endif;
			else:
				if ($iWF>0):
					$result--;
					if (__y_local_test>0):
						msgbox('DB-ERROR: 4');
					else:
						send_sys_message('DB-Error 4','WEHEVALUES NOT SET - WHEREFIELDS SET[br/]'.$this->SQL.' [br/]'.'',1);
					endif;
					
				endif;
			endif;
		endif;
		
		if (($result==0)&&($this->MODE<>'SELECT')&&($this->MODE<>'DELETE')):

			if (isset($this->aFields)):
				$iFF=count($this->aFields);
			endif;

			if (isset($this->aValues)):
				if ($iFF!=count($this->aValues)):
					$result--;
				endif;
			else:
				if ($iFF>0)$result--;
			endif;
			
		endif;
		
		if ($result==0):
			
			$this->iFields=$iFF;
			$this->iWhere=$iWF;
			
			
			$this->ar[] = str_repeat('s',$iFF+$iWF);
			for ($i=0;$i<$iFF;$i++):

				$this->ar[] = &$this->aValues[$i];
			endfor;
			for ($i=0;$i<$iWF;$i++):
				$this->WHEREV[$i]=sanitize($this->WHEREV[$i]);
				$this->ar[] = &$this->WHEREV[$i];
			endfor;
			if (count($this->ar)==1)$this->ar='';
			
			$result++;
		endif;
		
		if ($result<1):
			debuglog($this->ar,'AVAL Mode:'.$this->MODE);
			debuglog($this->aFields,'FIELDS: ');
			debuglog($this->aValues,'VALUES: ');
			debuglog($this->WHEREOP,'WHEREOP: ');
			debuglog($this->WHEREF,'WHERE FIELDS: ');
			debuglog($this->WHEREV,'WHERE VALS: ');
		
		endif;
		
		return $result;
	}
	
	
	public function prepareupdate($aF,$aV,$aWF=NULL,$aWV=NULL,$aOP=NULL)
	{
		//returns 1 if ok -1 for any errors
		$this->reset();
		$this->MODE='UPDATE';
		
		$result=$this->prepareData($aF,$aV,$aWF,$aWV,$aOP);
		
		return $result;
	}
	
	public function prepareinsert($aF,$aV)
	{	
		//returns 1 if ok -1 for any errors
		$this->reset();
		$this->MODE='INSERT';
		
		$result=$this->prepareData($aF,$aV,NULL,NULL,NULL);
		
		return $result;
	}
	
	public function preparedelete($aWhereFields,$aWhereVals,$aOPs=null)
	{	
		//returns 1 if ok -1 for any errors
		$this->reset();
		$this->MODE='DELETE';
		
		$result=$this->prepareData(NULL,NULL,$aWhereFields,$aWhereVals,$aOPs);
		
		return $result;
	}
	
	
	private function _execute(&$iResult){
	//$iResult = 0 for SQL
	//				=n for update (n rows affected)
	//				=x for insert (new ID)
		$result=0;
		$iResult=0;
		
		
		$result=$this->_SQLsecureDM($iResult);
		return $result;
	}
	

	private function _fetch()
	{
		$result=array();
		
		$metaResults = $this->connlink->result_metadata();

		$fields = $metaResults->fetch_fields();
		
		foreach($fields as $field){
			$rows[]=&$field->name;
			$fieldnames[]=$field->name;
		}
		
		call_user_func_array(array($this->connlink,'bind_result'), $rows);
		$this->rowsfetched=0;
		while($this->connlink->fetch()):
			for ($i=0;$i<count($fieldnames);$i++):
				
				$result[$this->rowsfetched][$fieldnames[$i]]=$rows[$i];
			endfor;
			$this->rowsfetched++;
		endwhile;
		return $result;
	}

	
	public function updateSQL($sTable,&$iRows)
	{
		$result=-1;
		$iRows=0;
		
		$this->SQL='UPDATE '.$sTable.' SET ';
		if ($this->MODE=='UPDATE'):
			$result=$this->_checkMode();
			if ($result==0):

				$result=$this->_execute($iRows);
			else:
				$result--;
			endif;
			//$this->connlink->close();
		endif;
		if ($result<=0):
			debuglog($this->connlink,'Error on Update');
		endif;
		return $result;
	}
	
	public function insertSQL($sTable,&$iNewID)
	{
		$result=-1;
		$iNewID=-1;
		
		$this->SQL='INSERT into '.$sTable. ' ';
		if ($this->MODE=='INSERT'):
			$result=$this->_checkMode();
			if ($result==0):
				try
				{
				$result=$this->_execute($iNewID);
				}
				catch (\Exception $e){$result--;}
			else:
				$result--;
			endif;	
			$this->connlink->close();
		endif;
		return $result;
	}
	//delete  
	
	
	public function deleteSQL($sTable,&$iRows)		//	iRows will return the number of rows affected
	{
		$result=-1;
	
		$iRows=0;
		
		$this->SQL='DELETE from '.$sTable.' ';
		
		if ($this->MODE=='DELETE'):
			$result=$this->_checkMode();
		
			if ($result==0):
				$result=$this->_execute($iRows);
			else:
				$result--;
			endif;	
			$this->connlink->close();
		endif;
		return $result;
	
	}
		
	public function qSQLdirect($sql,$aVALS,&$xID,$showError=1)
	/*...*/
	{	//do not set any output here
		$result=-1;
		$this->reset();
		$this->SQL=$sql;
		
		$this->_checkMode();
		
		if ($aVALS==null):
			$i=0;
		else:
			$i=count($aVALS);
		endif;
		
		$xID=0;
		
		$this->ar[] = str_repeat('s',$i);
		
		
		for ($j=0;$j<$i;$j++)
		{
			$x=$aVALS[$j];
			
			$aVALS[$j]=sanitize($x);
			$this->ar[] = &$aVALS[$j];
		}
		if (count($this->ar)==1)$this->ar='';
		
		$result=$this->_SQLsecureDataMod($xID,$showError);
		
		if (($result!=null)&&($result>0)):
			if (($this->MODE=='DESC')||($this->MODE=='SELECT')):
				
				$result=$this->_fetch();
				$xID=$this->rowsfetched;
				$this->connlink->close();
			endif;
		else:
			$result=-1;
		endif;
		return $result;
	}
	public function qSQLquick($sql,$aVALS)
	{
		$xID=-1;
		
		$result=$this->qSQLdirect($sql,$aVALS,$xID);
		return $result;
	}
	
	public function qSQLsimple($sql,$showError=1)
	{
		$xID=-1;
		$aVALS=null;
		$result=$this->qSQLdirect($sql,$aVALS,$xID,$showError);
		return $result;
	}
}
?>