<?php
/*
	Program: qmd-cms [qimanfaya-Menu-Driven-CMS]
	------------------------------
   qmd-cms - Main Debug File
   qmd-cms 0.8.4
	lup: 04/01/2014
	--------------------------------

	qdebug.php
	=============

	This file is part of the qmd-php-library
	
	Author: ***hy
	For further reference regarding this code see qmdcms.php and the readme-files.
	
	This code was developed by ****hy
	Copyright: qimanfaya/hy-soft 2012,2014
	
	Licence:		GPL V.3

	A copy of the GNU General Public License is available:
	in the root of this folder
	and on the World Wide Web
	at <http://www.gnu.org/licenses/gpl-3.0.txt>. You can also obtain it by writing
	to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
	MA 02111-1307, USA.
			

*/

function get_debug_backtrace($delimiter,$trace=999,$start=1)//default show all
{
	$result='';
	if ($trace>0):
		$result='Call Stack:'.$delimiter.'Last FUNCTION:';
		$B=debug_backtrace();
		$jMax=count($B);
		
		$jCount=$start;
		
		while (($jCount<$jMax) && ($trace>=0)):
			$r=$B[$jCount];
			if ($jCount+1<$jMax)
			{
				$r2=$B[$jCount+1];
				$result.='(F) '.$r2['function'].$delimiter;
				$result.= 'LINE:'.$r['line']. ' SRC:'.$r['file'].$delimiter;
			}
			else
			{
				$result.= ' called by:'.$delimiter.'LINE:'.$r['line']. ' SRC:'.$r['file'].$delimiter;
			}
			
			/*
			if ($jCount>$start)
				$result.= ' called by:'.$delimiter.'LINE:'.$r['line']. ' SRC:'.$r['file'].$delimiter;
			else
				$result.= ' called by:'.$delimiter.'LINE:'.$r['line']. ' SRC:'.$r['file'].$delimiter;
			*/
			$trace--;
			$jCount++;
			if ($jCount<count($B))
				$result.=$delimiter;
		endwhile;
		$result.=$delimiter;
	endif;
	return $result;
}
function _debuglog($item,$space='+')
{
	global $__y_debuglogfile;
	
	if (is_array($item)):
		
		foreach($item as $key => $value){
			
			if (is_array($item[$key])):
				_debuglog($item[$key],$space.'+');
			else:
				fwrite($__y_debuglogfile,$space." [".$key."]=".$value."\r");
			endif;
		}
	else:
		fwrite($__y_debuglogfile,$space." ".$item."\r");
	endif;
}
function debuglog($msg,$name='',$showtrace=false)
{
global $__y_debuglogfile;
global $__y_debuglog_is_open;
	if ($__y_debuglog_is_open>0): //do not write in live mode
		if (__y_DEBUG>1):
			
			if ($showtrace==TRUE):
				fwrite($__y_debuglogfile,"DEBUG ITEM-----------------------------------------"."\r");
				$QUU=debug_backtrace();

				_debuglog($QUU);
			endif;
			if (is_array($msg)):
				fwrite($__y_debuglogfile, $name.' is ARRAY: '."\r");
				_debuglog($msg);
			else:
				if (is_object($msg)):
					$res=print_r($msg,true);
					fwrite($__y_debuglogfile, $name.': '.$res."\r");
				else:
					fwrite($__y_debuglogfile, $name.': '.$msg."\r");
				endif;
			endif;
			
			if ($showtrace):
				fwrite($__y_debuglogfile,"DEBUG ITEM END-------------------------------------"."\r");
			endif;
		endif;
	endif;
}

function showDebugForm($msg)
{
	
	echo '<script type="text/javascript">';
	echo 'debugmessage="'.$msg.'";';
	echo 'alert(debugmessage);ShowDebugForm(debugmessage);</script>';
}

function msgbox($msg,$trace=6,$convert=false)
{

	$sOut='';
	if (__y_local_test==0)$trace=0;
	if ($trace>0):
		
		$sOut=get_debug_backtrace('\n',$trace).'\nMessage: \n';
		
	endif;
	
	if ($convert) $msg = str_replace('"','@',$msg);
	if ($convert) $msg = str_replace("'",'#',$msg);
	echo '<script type="text/javascript">';
	echo 'alert("'.$sOut.$msg.'");';
	echo '</script>';
	
}
function yecho($msg, $title='DEBUG OUTPUT', $debugout=false, $error=0)
{
	if ($error<>0):
		echo '<pre class="qmd_debugerrpanel">';
	else:
		echo '<pre class="qmd_debugpanel">';
	endif;
	
	//I know this is ugly!
	echo "++++++++++++++++++++++++++++++++++++++++\n";
	echo 'debug out [content of]: <b>'.$title.'</b><br/>';
	
	echo print_r($msg,true);

	if ($debugout):
		echo "\n============debug trace=================";
		//echo 'foo';
		//var_dump(debug_backtrace(),true);
		$B=debug_backtrace();
		
		for ($jCount=count($B)-1;$jCount>=0;$jCount--):
			$r=$B[$jCount];
			echo '<div>';
				$s=$r['function']. ' '.$r['line']. ' '.$r['file']. ' ';
				echo ($s);
			echo '</div>';
		endfor;
		//echo "<pre class=debug>".print_r(debug_backtrace(),true)."</pre>";
	endif;
	
	echo "</pre>";
}
function debug_css($style,$text,$filename)
{
	echo'<div id="'.$style.'">'.$text.'  ['.$filename.']</div>';
}
//
global $__y_debuglog_is_open;
global $__y_debuglogfile;
if (__y_DEBUG > 0)//this is a GLOBAL variable that is set in qmd_const_settings.php
{
	
	$__y_debuglogfile=fopen(debug_log_file_name,'a');

	if ($__y_debuglogfile==FALSE):
		msgbox('ERROR initializing Debuglogfile');
	else:
	endif;
	
	$__y_debuglog_is_open=1;

}
else
{
	$__y_debuglogfile=null;
	$__y_debuglog_is_open=0;
}

date_default_timezone_set('UTC');
debuglog("\rStart *** ".strftime('%G/%m/%d %H-%M-%S')."\r");
debuglog("URI: ".$_SERVER['REQUEST_SCHEME'].'://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']);

?>