<?php
/*
	Program: qmd-cms [qimanfaya-Menu-Driven-CMS]
	Module: qmd initialization
	..............................................
	qmd-cms 0.8.7
	last update: 04/29/2014

	--------------------------------

	qmd_init.php
	=============

	This file is part of the qmd-php-library
	
	Author: ***hy
	For further reference regarding this code see qmdcms.php and the readme-files.
	
	This code was developed by ****hy
	Copyright: qimanfaya/hy-soft 2012,2014
	
	Licence:		GPL V.3

	A copy of the GNU General Public License is available:
	in the root of this folder
	and on the World Wide Web
	at <http://www.gnu.org/licenses/gpl-3.0.txt>. You can also obtain it by writing
	to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
	MA 02111-1307, USA.
			
/* ..........................................................................................*/

/*---------------------------------qmdC-------------------------------------------------------
  To disable Error Reporting, use E_NONE
---------------------------------------------------------------------------------------------*/
//error_reporting(E_NONE); // #2 No Error Reporting
error_reporting(E_ALL ^ E_NOTICE); // #1 Report all Errors


//This is in order you need to debug on a live system - which is a bad idea in the first place.
//but it's sometimes better than having to turn on all error reportings.
//Feel free to decomment that debug code.
//init DEBUG

// **************************Read settings **********************************************
//***hy basic includes...................................................................
// EXPLANATION: There is debug code after each line of include
// in order to be able to track down anything ...
//set __y_DEBUG in ../GLOBALS/qmd_globals.php to zero if you don't need these
//1 only show current set of DEBUG
// ...
//10 show all

//******************************************************
//the next is more or less some settings
//the actual globals for the program are loaded within qMDCMS
global $DATABASE;
$DATABASE=NULL;
global $ASCHEMES;
$ASCHEMES=array();


//***************************************************************************************************
//we need this b4 URL handler
//contains debug parameters and must be loaded b4 DEBUG

include_once('../GLOBALS/qmd_const_settings.php');

ini_set("SMTP",__y_SMTPSERVER); 
ini_set('sendmail_from',__y_sendMailFrom);

//***************************now the includes
include_once('qmd_debug.php');

include_once('qmd_phputil.php');			//programming utility
include_once('qmd_sys.php');		//system utility

//now we start language stuff..............LANGUAGE needs to be called b4 URL Handler

$LANG=array();

init_languages();

include_once('qmd_control.php'); //global system object
//DATABASE
include_once('qmd_db.php');	//system library for qmd-cms Database s7uff

include_once('qmd_db_class.php');

// Prefix
define('_PRE',db('prefix'));
connect_to_db();

//constructing the qmd_CONTROL-Object
$qSQL = new qmd_SQL();
$site_settings=array();

//the following should not be a problem if coded directly
$query = 'SELECT name,value FROM '._PRE.'qmd_settings';

$this_site_settings = $qSQL->qSQLsimple($query);

if (is_array($this_site_settings)):
	for ($iCount=0;$iCount<count($this_site_settings);$iCount++):
		$set=$this_site_settings[$iCount];
		$site_settings[$set['name']] = $set['value'];	
	endfor;
else:
	die('FATAL INIT');//we don't have qmd_die available yet
endif;

//now we initialize the main control object
global $_ReloadPending;
$_ReloadPending=0;

$qmdC = new qmd_CONTROL();//$_ReloadPending will be set to 1 for logoff()

// **************************On With the includes
// this must be first

include_once('qmd_users.php');	//users - also needed when not on multiusers due to admin login

if ($_ReloadPending==0)
{
	srand ();
	include_once('qmd_htmlutil.php');		//html utility

	include_once('qmd_queries.php');	//system library for qmd-cms Database s7uff - the actual queries

	include_once('qmd_mods.php'); //extensions for qmd-cms

	//***************************************************************************************************

	include_once('qmd_lib.php');	//system library for qmd-cms application logic

	include_once('qmd_categories.php');	//system library for qmd-cms categories

	include_once('qmd_comments.php');	//comments

	include_once('qmd_vac.php');	//Value added containers

	include_once('qmd_articles.php');	//article handling

	include_once('qmd_article_class.php');	//multiuser module

	//***************************************************************************************************
	//*************************NOW we access the Database************************************************

	populate_retr_cache(); //populate retrieve cache


	if (s('multiuser')==1)
		include_once('qmd_multi_users.php');	//multiuser module
		
	if (s('forum')==1)
		include_once('qmd_forum.php');	//forum module
		

	if (s('blog')==1)
		include_once('qmd_blog.php');	//blog module
		
	include_once('qmd_list.php');	//LIST module

	include_once('qmd_list_item.php');	//LIST module for the items

	//Now we can include usesrmessages
	include('qmd_msg_list.php');

	//Now we can include message items
	include('qmd_msg_list_item.php');

	//***************************************************************************************************


global $qSQL;
global $qmdC;
global $qmd_sefLink;
	
	$usercount=count_table_entries('qmd_users');
	if ($usercount==0)
	{
		$sysID=createUser('system','','system@'.puresitename(1),0,FALSE);
		if ($sysID>=0)
		{
			$res=$qSQL->qSQLsimple('Update '._PRE.'qmd_users set id=1 WHERE id='.$sysID);
			if ($res>0)
				$usercount++;
			else
				qmd_die('Error initializing system - 1');
		}
		else
			qmd_die('Error initializing system');
		
	}
	
	if ($usercount==1)
	{
		$pass=rand_pwd(10);
		$adminid=createUser('admin',$pass,'',8,FALSE);
		if ($adminid>0)
		{
			msgbox('Hello Admin! Your new password: '.$pass,0);
			$qmdC->URL[0]=$qmd_sefLink[0];
			$qmdC->Func=$qmd_sefLink[0];
		}
		else
			qmd_die('Error creating admin');
	}
	else
	{
		
		if (check_login()):	//this is in users and checks if user logs in or is already logged in
			if ($qmdC->get_userPermission(__USER_isMod)>0):
				
				include_once('qmd_admin_util.php');
				include_once('qmd_admin.php');
				
				//if (__y_local_test==1)
				{	
					include_once('qmd_test.php');
				}
			endif;
		endif;
		clear_session(1);//clear default;
	}

	//this is just testing sysmessage
	//enable if you need some messages to play around with ...
	//send_sys_message('Script started',$_SERVER['REMOTE_ADDR']);
}
//***************************************************************************************************
?>