<?php
/*------------------------------
	Program: qmd-cms [qimanfaya-Menu-Driven-CMS]
	Module: qmd initialization evaluate URL-Params
	..............................................
	qmd-cms 0.8.6
	last update: 04/26/2014

	--------------------------------

	qmd_lists.php
	=============

	This file is part of the qmd-php-library
	
	Author: ***hy
	For further reference regarding this code see qmdcms.php and the readme-files.
	
	This code was developed by ****hy
	Copyright: qimanfaya/hy-soft 2012,2014
	
	Licence:		GPL V.3

	A copy of the GNU General Public License is available:
	in the root of this folder
	and on the World Wide Web
	at <http://www.gnu.org/licenses/gpl-3.0.txt>. You can also obtain it by writing
	to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
	MA 02111-1307, USA.
	
*/



/*
	In order to run a list you should:
	1. make a derivate of this Object in xxx_list.php
	2. the article containing the list should have the 'objectloader'-field filled with the name of xxx_list.php
	3. the function 'center' in qmd_articles.php will try the rest
	- or rather the public qmdC-Object
	
	
*/

class qmd_LIST extends qmd_base_article{
		//var $_CONTROLLER;
		
		var $sql_list;//the sql statement for retrieving the list
		//var $sql_item;//the sql statement for retrieving a single items in the list
		
		var $_list_rows;//result of sql_list
		
		var $_listItems;//a list with sefTitles of all items
		
		var $arlistsize;
		var $arlistsel;
		var $arSortFields;
		
		var $URLfieldName;	//this is the field containing the ID that links to the parent article
		var $LinkFieldName;	//this is the field that gets the anchor
		var $IDField;		//this should be set properly in order to retrieve the comments
		
		var $ItemTitlefield;
		
		var $listHeader;
		
		var $ListHeadDivClass;
		var $ListItemsDefaultDiv;
		
		var $defaultSortDIV;

		var $default_list_row_oddDIV;
		var $default_list_row_evenDIV;
		
		var $ListCOLs;	//these are the columns shown for the overview
		var $ListDIVs;//these are the DIVS for each column
		var $ListColLabels;
		var $noDatainList;
		//internal usage
		var $__curSortItem;	
		
		
		function __construct($controller,$BaseRec,$tablename,$dbName=''){
			
			parent::__construct($controller,$BaseRec,$tablename,$dbName);
			//$this->_CONTROLLER=$controller;
			
			$this->ItemTitlefield='';
			
			$this->defaultSortDIV='__list_hidden_';//you may override this 1
			
			$this->ListColLabels=null;
			$this->_listItems=null;
			$this->LinkFieldName='';
			$this->URLfieldName='';//-"-
			$this->IDField='id';
			
			$this->sql_list='';//the sql statement for retrieving the list

			$this->_list_rows=null;
			$this->arSortFields=array();
			
			$this->arlistsize=array();
			
			$this->arlistsize[0]=15;
			$this->arlistsize[1]=30;
			$this->arlistsize[2]=50;
			$this->arlistsize[3]=l('all');
			$this->arlistsel=0;//default selection
			
			$this->ListHeadDivClass='default_list_row_head';
			$this->default_list_row_oddDIV='default_list_row_odd';
			$this->default_list_row_evenDIV='default_list_row_even';
			$this->ListItemsDefaultDiv='default_list_item';
			
			$this->ListCOLs='';	//these are the columns shown for the overview
			$this->ListDIVs=null;//these are the DIVS for each column
		

			//here it begins
			
			//IMPORTANT!!!
			//override this default text ACCORDING to YOUR DATA
			switch ($this->_CONTROLLER->language):
				case 'de':
					$this->noDatainList='Keine Daten verf&uuml;gbar';
					$this->listHeader=
						"Hier finden Sie eine &Uuml;bersicht unseres Angebots. Durch einen Klick auf den Namen werden Details und Bilder angezeigt.";
					break;
				case 'en':
					$this->noDatainList='No data available';
					$this->listHeader=
						"Here you find an overview of our offers. By clicking one of the items details and images are displayed.";
					break;
				case 'es':
					$this->noDatainList='Los datos no se pueden encontrado';
					$this->listHeader=
						"Aqui encuentras un resumen de nuestros ofertas. Haga cliq para ver m&aacute;s informaci&oacute;n y imagenes.";
					break;
			endswitch;
			//we load this from here and don't want it to be loaded again by the parent::
			$this->_jsFile='qmd_list.js';
			$this->_cssFile='qmd_list.css';
			//load these anyway before the property gets overwritten by actual article-object
													//$js,		$useTheme=TRUE,$drop=0,$preSlash=FALSE,$UseInclude=FALSE,$prependJS=TRUE,$UseQueue=TRUE
			$this->_CONTROLLER->load_js($this->_jsFile,FALSE,				0,		TRUE,			FALSE,				TRUE,					TRUE);
			
			$this->_CONTROLLER->load_css($this->_cssFile,FALSE,0,TRUE,TRUE);
			$this->_jsFile='';
			$this->_cssFile='';
		}
		function __destruct(){//Do some housekeeping
			parent::__destruct();
			
			unset($this->arlistsize);
			if ($this->ListColLabels!=null):
				unset($this->ListColLabels);
			endif;
			if ($this->ListCOLs!=null):
				unset($this->ListCOLs);
			endif;	//these are the columns shown for the overview
			
			if ($this->ListDIVs!=null):
				unset($this->ListDIVs);//these are the DIVS for each column
			endif;
			if ($this->arSortFields!=null):
				unset($this->arSortFields);
			endif;
			
			if (!is_null($this->_list_rows)):
				unset($this->_list_rows);
			endif;
			
			
		}		
		
		
		function fetch_list ($getItem='')
		{
			//this will only fill $_list_rows
		global $qSQL;
			
			
			$result=-1;
			if ($this->_list_rows==null):
				
				$a=array();
				
				if (empty($this->sql_list)):
					$this->sql_list="SELECT * from ".$this->_tablename;
				endif;
				if (!empty($getItem)):
					if (!empty($this->LinkFieldName)):	
						$this->sql_list.=' WHERE '.$this->LinkFieldName.'=?';
						$a[]=$getItem;
					else:
						msgbox('error getting the item');
						qmd_die('error getting the item');
					endif;
				endif;
				
				$wasConnected=$this->DBconnected;
				//debuglog($this->sql_list,'fetch');
				if (!$wasConnected):
					$this->connect();
					
				endif;
				
				
				$this->_list_rows=$qSQL->qSQLquick($this->sql_list,$a);
				
				if (is_array($this->_list_rows))
					$result=count($this->_list_rows);

				if (!$wasConnected)://clean up
					$this->disconnect();
				endif;
			else:
				$result=count($this->_list_rows);
			endif;
			return $result;
		}
		
		function write_header(){
			
			echo $listHeader;
			return;
		}
		function __compare($a, $b) 
		{
			$result=0;
			
			//echo $this->__curSortItem.'||';
			$ax = $a[$this->__curSortItem];
			$bx = $b[$this->__curSortItem];
			//echo $ax.
			//echo $ax.' '.$bx;
			
			if ($ax !== $bx) 
			{
				if ($ax < $bx)
					$result--;
				else
					$result++;
			}
			return $result;
		}
		function doSortList($item)
		{
			$this->__curSortItem=$item;
			
			usort($this->_list_rows,array($this,'__compare'));
		}
		
		function createListItemLink($link,$text)
		{
			//this is the default way - override this function when other links are required (see user messages)
			$result=qmd_createLink('/'.$this->_CONTROLLER->URL[0].'/'.$link,$text);
			return $result;
		}
		function getListItemCellValue($row,$key,$value)
		{	//this is in order you want to diplsy only part of the data in list overview
			$result=$value;
			//you could enter
			//if (strlen($result)>40){
			//$result=substr($result,0,40).'...';
			//}
			return $result;
		}
		function createListItemCell($row,$key)
		{
			
			$result='';
			$value=$row[$key];
			if ($this->ListDIVs==null):
				$result.="<td>";
			else:
				$sDIV=$this->ListDIVs[$key];
				$result.="<td class='".$sDIV."'>";
			endif;
			
			
			if ($key==$this->LinkFieldName):
				if (empty($value))
				{
					$value='---no value---';
					
				}
				if (empty($row[$this->URLfieldName]))
				{
					
					$jump='?id='.$row[$this->IDField];
				}
				else
					$jump=$row[$this->URLfieldName];
				$result.=$this->createListItemLink($jump,$value);
			else:
				if (empty($value))
					$result.=gethtmlspacer(3);
				else
					$result.=$this->getListItemCellValue($row,$key,$value);
			endif;
			$result.='</td>';
			return $result;
		}
		
		function fillListRow($RowNo,$row)
		{
			$result='';
			if ($RowNo % 2 == 0):
				$result.="<tr class='".$this->default_list_row_evenDIV."'>";
			else:
				$result.="<tr class='".$this->default_list_row_oddDIV."'>";
			endif;
		
			for ($i=0;$i<count($this->ListCOLs);$i++):
				$fieldname=$this->ListCOLs[$i];
				$result.=$this->createListItemCell($row,$fieldname);
				
			endfor;
			$result.="</tr>";//close list row
			return $result;
		}
		
		function FillData2HTML_tbl()
		{
			
			$listData='<table border="1px">';
			
			$listData.='<tr class="default_list_row_head">';//div class='".$this->ListHeadDivClass."'>&nbsp;";
			//$HEAD=array_keys($this->_list_rows[0]);
			if (count($this->ListCOLs)==0)
				$this->ListCOLs=array_keys($this->_list_rows[0]);
			
			$iCount=0;
			
			for ($i=0;$i<count($this->ListCOLs);$i++):
				$fieldname=$this->ListCOLs[$i];
			
					
				if (($this->ListColLabels!=null)&&(count($this->ListColLabels)>$iCount)):
					$label=$this->ListColLabels[$iCount];
				else:
					$label=$fieldname;
				endif;
				
				if (in_array($fieldname,$this->arSortFields)==TRUE):
					$listData.='<td class="default_list_sort_item" onclick="doSortList(\''.$fieldname.'\')">'.$label.'</td>';
				else:
					$listData.='<td>'.$label.'</td>';
				endif;
				$iCount++;
		
			endfor;
			$listData.='</tr>';//close header div
			
			$iMax=count($this->_list_rows);
			
			if ($iMax==0):
				msgbox(l('list_no_data'),0);
				$listData.='<tr><td colspan='.$iCount.'></tr>';
			else:
				for ($iRowCount=0;$iRowCount<$iMax;$iRowCount++):
					$row=$this->_list_rows[$iRowCount];
					$listData.=$this->fillListRow($iRowCount,$row);
					
					//$listData.='||';
				endfor;
			endif;//>0 records
			$listData.='</table>';
			
			return $listData;
		}
		//Do not use Mode for divs cause it won't work
		
		function _List2HTML($mode=1){
			//don't worry if this is being called several times. Depends on how much sort fields you have!
			$result='';

			if ($mode==1):
				$result= $this->FillData2HTML_tbl();
			else:
				//not implemented
			endif;
			
			return $result;
		}
		function savesortedlist($LISTDATA,$divName){
			
			
			echo '<div id="'.$divName.'" style="display:none">';
			echo $LISTDATA;
			echo '</div>';
			
		}
		function collectdata()
		{	
			
			$result=$this->fetch_list();
			
			if ($result>0):
			
				if ((count($this->arSortFields)==0)&&(!isset($this->arSortFields[0]))):
			
					$xsort=$this->_List2HTML(1);
					
					$this->savesortedlist($xsort,$this->defaultSortDIV);
				else:
			
					$xDiv=$this->defaultSortDIV.$this->arSortFields[0];
			
					foreach ($this->arSortFields as $foo):
			
						$this->doSortList($foo);
						
					
						$xsort=$this->_List2HTML(1);
						$this->savesortedlist($xsort,$this->defaultSortDIV.$foo);
					endforeach;
				endif;
			
				echo "<div id='qmd_ListContainer'>";
				//....................1.......2.....3.....4......5.......6......7......8........9......10.....11.......12.......13.......14........15.....            16..............
				//function html_input($type, $name,    $id,  $value, $label, $css, $script,                                             $checked, $rows, $cols, $method, $action, $legend,$cmbsql='',$cmbarray=array(),$label_right='')
				echo html_input     ('combobox','listsize','listsize',15,l('list_nums_show'),    'opt_date','onchange="fill_qmd_list()"','',       '',    '', '',          '',     '',    '',         $this->arlistsize, l('entries_in_list'));

				echo '&nbsp;&nbsp;&nbsp;&nbsp;<input type="button" name="prev" id="prevBtn" value="'.l('prev').'" onclick="showprevlist()"  disabled="disabled" />';
				echo '&nbsp;&nbsp;&nbsp;&nbsp;<input type="button" name="next" id="nextBtn" value="'.l('next').'" onclick="shownextlist()"/>';
			
				echo '<div id="qmd_list_items">';
				echo "</div>";//
				echo "</div>";//qmd_ListContainer
			else:
				if (count($this->_list_rows==0))
					msgbox(l('list_no_data'),0);
				else
					msgbox(l('Error_retrieving_list_data'));
			endif;
			return $result;
		}
		function displayListData()
		{
			
			if ($this->_list_rows==null):
				
				$result=FALSE;
			else:
				
				$result=TRUE;
				if ((count($this->arSortFields)==0)&&(!isset($this->arSortFields[0]))):
					$xDIV=$this->defaultSortDIV;
				else:
					$xDIV=$this->defaultSortDIV.$this->arSortFields[0];
				endif;
				echo '<script type="text/javascript">';
				echo "fill_qmd_list('".$xDIV."');";
				echo "</script>";
			
			endif;
			return $result;
			
		}
		function runList()
		{
			
			//$this->connect();

			$this->write_header();	//override this one or set listHeader properly
			
			$result = $this->collectdata();	//
			if ($result>0):
				
				$result = $this->displayListData();
				
			else:
				$result=FALSE;
				echo $this->noDatainList;
			endif;
			//$this->disconnect();
			return $result;
		}
		
		//$ListDIVs
		function setListDIVs($aDIVs)
		{
			$this->ListDIVs=$aDIVs;
		}
		
		function showArticleHead($Mode=1)
		{
			parent::showArticleHead($Mode);
		}
		function showArticleComments(){
			$this->disconnect();//comments are always in the main database
			comment($this->ArticleRow['artid']);	
		}
		function getArticleTeaser($Mode)
		{

			$result=$this->listHeader;
			
			return $result;
		}
		function ArticleShow($Mode=1){
			
			parent::initArticleShow();

			echo '<div class="qmd_article_box">';

			$this->showArticleHead($Mode);//////////////  HEAD  ///////////////////////////////////////////////////////////////////
			
			$this->showArticleTeaser($Mode);//////////////  TEASER ////////////////////////////////////////////////////////////////
			if ($Mode>0)
			{
				$result=$this->runList();
				$this->_CONTROLLER->showarticleEditLink($this);
			}
			else
			{
				echo '...';
					
				//Only teasers are shown
				
				$sMore=l('read_more');

				echo '<div class="qmd_article_readmore">'.qmd_createLink($this->ArticleRow['seftitle'],	
																							$sMore)
																							.'</div>';
			}
			$this->disconnect();
			
			echo '</div>';
			if ($Mode>0):
				$this->showArticleComments();
			endif;
			
			return $result;
		}
		
		function displayArticle($Mode=1)
		{

			$result=parent::displayArticle($Mode);
			
			if ($Mode>0)
			{
				if (count($this->_list_rows)==0)
					echo '<div class="qmd_warning">'.$this->noDatainList.'</div>';
			}
			return $result;
		}
		
		
		//YOU MUST OVERRIDE THIS ONE IN YOUR LIST
		public function getChildLoader()
		{	$result='';
			return $result;
		}
		function createLangCopy($targetLanguage,$newArtID=-1)
		{
			$result=parent::createLangCopy($targetLanguage,$newArtID);
			return $result;
		}
		function createArticleCopy($targetLanguage)
		{
			$result=parent::createArticleCopy($targetLanguage);
			return $result;
		}
		/*
		public function getListItems()//Override this (F) if you make descendants of this List-Object
		{
			if (is_null($this->_listItems)):
				$this->_listItems=array();
				if (is_null($this->_list_rows)):
					$this->fetch_list();
				endif;
				for ($iCount=0;$iCount<count($this->_list_rows);$iCount++):
					$row=$this->_list_rows[$iCount];
					$this->_listItems[]=$row[$URLfieldName];
				endfor;
				
			endif;
			return $this->_listItems;
		}
		*/
		
	}
?>
