<?php
/*------------------------------
	Program: qmd-cms [qimanfaya-Menu-Driven-CMS]
	Module: qmd menu loader
	..............................................
	qmd-cms 0.8.5
	last update: 03/03/2014

	--------------------------------

	qmd_menu.php
	=================

	This file is part of the qmd-php-library
	
	Author: ***hy
	For further reference regarding this code see qmdcms.php and the readme-files.
	
	This code was developed by ****hy
	Copyright: qimanfaya/hy-soft 2012,2014
	
	Licence:		GPL V.3

	A copy of the GNU General Public License is available:
	in the root of this folder
	and on the World Wide Web
	at <http://www.gnu.org/licenses/gpl-3.0.txt>. You can also obtain it by writing
	to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
	MA 02111-1307, USA.
	
*/
//NOTE some initialization is done below after the functions
/**********************MENU *******************/

function get_menuChildren ( $menu, $el_id,$LinkPrefix)
{
	global $qmdC;
	
	

	$has_subcats = FALSE;
	$out = '';
	$out .= "\n".'	<ul>' . "\n";
	
	for ( $i = 0; $i < count ( $menu ); $i++ ):
		
		if ( $menu [ $i ] [ 'show_condition' ] && $menu [ $i ] [ 'menparent' ] == $el_id ) {//are we allowed to see this menu?
			
			$has_subcats = TRUE;
			$hasSubMen=get_menuChildren ( $menu, $menu[$i]['menid'],$LinkPrefix.'/'.$menu[$i]['menulink'] );
			
			$add_class = (  $hasSubMen!= FALSE ) ? 'subsubl' : '';
				//---------------------------------------THIS ONE IS omitted from using qmd_createLink
				$out .= '	<li class="default_menuitem" ><a href="/'.$qmdC->language.'/' .$LinkPrefix.'/'. $menu [ $i ] [ 'menulink' ] . '">';
			
			$out .= $menu [$i][$qmdC->language];
			
			if (!empty($add_class)):
				$out.= '&nbsp;&nbsp;&nbsp;[...]';//'<img src="/dev.img/sq_next_icon_16.png" />';//style="margin-top:10px"/>';
			endif;
			
			$out .= '</a>';

			
			if ($hasSubMen!==FALSE):

				$out .= $hasSubMen;
			endif;
			$out .= '</li>' . "\n";
		}
	endfor;//for
	$out .= '	</ul>'."\n";
	return ( $has_subcats ) ? $out : FALSE;
}


function _showhome()
{
global $qSQL;
global $qmdC;
	$class='main_menuitem';
	$result= '<li class="' . $class . '"><a href="/'.$qmdC->language.'/">';
	$res=$qSQL->qSQLsimple(query_get_menu().' WHERE menulink="home"');
	
	
	if ((is_array($res))&&(count($res)>0))
		$result.=$res[0][$qmdC->language];
	else
		$result .= l('home');
	$result .= '</a>';
	
	$result .= '</li>' . "\n";
	return $result;
	
}

function build_menu ($startfrom='',$exclude='',$showhome=1)
/*please check that you enclose this function with
	echo '<nav><ul>'
	echo build_menu(...);
	echo '</ul></nav>';
*/
{
	
	global $qmdC;
	global $qSQL;
	
	//............................................................................
	//GET MENU from DB
	
	$curLevel=0;
	$xID=0;
	$startID=-1;
	
	$sql='SELECT id from '._PRE.'qmd_menu WHERE menulink=?';
	$r=$qSQL->qSQLdirect($sql,array($startfrom),$xID);
	if ((is_array($r))&&(count($r)>0)){
		$startID=$r[0]['id'];
	}	
	$qmdC->set_skipMenu($startID);
	$sql=query_get_menu(1);
	$sql.=' order by m.sort ';
	
	$iDBStatus=0;
	$iRowCount=0;
	
	$menu=getSQL($sql,$iDBStatus,$iRowCount);
	
	$cond=-1;

	//............................................................................
	// 	$out = '<div class="qmd_menucontainer">' . "\n";
	//$out = '<div class="qmd_menuItem">' . "\n";
// 	echo '<nav>TEST<ul><li></nav>';
	
	//$out = "\n".'<ul>' . "\n";//unordered list starts
	$out='';
	
	$DO=1;
	if (count ( $menu )==0):
		$out.=_showhome();
		
	else:
		if ($showhome>0):
			$out.=_showhome();
		endif;
		
		for ( $i = 0; $i < count ( $menu ); $i++ ):
		

			//the next is for displaying the menu item
			//if it is the currently selected item it will be the class ###.current
			//....................................................................
			//the next one is obsolete
			//must be by construction but let's keep the errors home
			if ( is_array ( $menu[$i] )):
				
				//YES it is an array

				//are we allowed to see this menu?
				
				if (($startID<0)||($startID==$menu[$i]['menparent'])):
					if (($menu [$i] ['show_condition']>0)&&($menu[$i]['menulink']!=s('home_sef'))):
						if (($menu [$i] ['menparent'] == -1 )||(strlen($startfrom)>0)):
							if (empty($exclude)):
								$DO=1;
							else:
								if ($menu [$i] ['menulink'] ==$exclude ):
									$DO=0;
								
								endif;
							endif;
							
							if ($DO):
								//okay 
								if ($curLevel==0):
									$class='main_menuitem';
								else:
									$class = 'default_menuitem';
								endif;
								
								if ($qmdC->get_URIfirst() == $menu [$i] ['menulink']) :
									$DoLink=0;
									$class.='current';
								else:
									$DoLink=1;
								endif;
								
								
								$out .= '<li class="' . $class . '">';
								if ($DoLink>0):
									$out .='<a href="/'.$qmdC->language.'/' . $menu[$i]['menulink'] . '">';
								endif;
									if (isset($menu [$i][$qmdC->language])):
										$out .= $menu [$i][$qmdC->language];
									else:
										$out .= $menu [$i]['menucaption'];
									endif;
								if ($DoLink>0):
									$out .= '</a>';
								endif;
								
								$sTmp=get_menuChildren ( $menu, $menu[$i]['menid'],$menu[$i]['menulink'] );
								if ($sTmp!==FALSE):
								
									$out .= $sTmp;
								endif;
								
								
								$out .= '</li>' . "\n";
							
							endif;
							
						
						endif;
					
					endif;
				endif;//startfrom
			
			else:
			
				die ( sprintf ( 'menu nr %s must be an array', $i ) );
			
			endif;


		endfor;
	
	endif;
	//------------------------------------------------------
   //------------------------------------------------------
	
	return $out . "\n\t";
	
//
}
/**********************MENU ends*******************/

//INITIALIZATION
	global $qmdC;
	$sPath=$qmdC->get_Path(TRUE,-1).'css';	//we are here on the root so -1 is applied even if we also need the SCHEME
	
	if (file_exists($sPath.'/qmd_menu_css.php')):
		
		$qmdC->load_css('qmd_menu_css.php',TRUE,-1,TRUE);
	else:
		
		$qmdC->load_css('qmd_menu_css.php',FALSE,-1);
	endif;
	
	
?>