<?php
/*
	Program: qmd-cms [qimanfaya-Menu-Driven-CMS]
	Module: qmd modules - the central modules
	..............................................
	qmd-cms 0.8.7
	last update: 05/06/2014

	--------------------------------

	qmd_mods.php
	=============

	This file is part of the qmd-php-library
	
	Author: ***hy
	For further reference regarding this code see qmdcms.php and the readme-files.
	
	This code was developed by ****hy
	Copyright: qimanfaya/hy-soft 2012,2014
	
	Licence:		GPL V.3

	A copy of the GNU General Public License is available:
	in the root of this folder
	and on the World Wide Web
	at <http://www.gnu.org/licenses/gpl-3.0.txt>. You can also obtain it by writing
	to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
	MA 02111-1307, USA.
	*/

/**********************MENU************************/

function searchform()
{ 
global $qmdC;
$searchaction='"/'.$qmdC->language.'/search"';
?>
		<form id="search_engine" method="post" action=<?php echo $searchaction;?> accept-charset="<?php echo s('charset_encoding');?>">
			<div><!-- this is required in order to validate 2 W3C the inputs -->
			<input class="qmd_searchfield"
							name="search_query"
							type="text"
							id="keywords"
							value="<?php echo l('search_keywords');?>"
							onfocus="document.forms['search_engine'].keywords.value='';"
							onblur="if (document.forms['search_engine'].keywords.value == '')
										document.forms['search_engine'].keywords.value='<?php echo l('search_keywords'); ?>';" 
							/>

			<input class="qmd_searchbutton" name="submit" type="submit" value="<?php echo l('search_button')?>" />
			</div><!-- this is required in order to validate 2 W3C the inputs -->
		</form>
		
<?php
}



/**************LANGUAGE stuff ends*****************/
function get_according_articles($xid)
{
global $qmdC;
global $qSQL;
global $qmd_Lang_ANY;
	$result=NULL;
	$aShown=array();
	$articles=array();
	$artgetWhere='';
	$goon=true;
	if ($xid<0)//we do not have a menu but we want to see all articles w/o menu assigned
	{
		$artget='SELECT id as article_id from '._PRE.'qmd_articles WHERE id not in (
					select article_id from '._PRE.'qmd_article2menu ) AND art_parent is null';
	}
	else
	{
		$artget='SELECT article_id FROM '._PRE.'qmd_article2menu WHERE menu_id ='.$xid;
	}
	
	$artavail= $qSQL->qSQLsimple($artget);
	
	if (is_array($artavail))
	{
		$iCount=count($artavail);
		
		if ($iCount>0)
		{
			for ($i=0;$i<$iCount;$i++)
				$articles[]=$artavail[$i]['article_id'];
			$artget='SELECT a.id as artid,a.seftitle,a.art_parent,a.date,a.seftitle,a.display_mode,
						ML.id as MLID, ML.title,ML.lang as lang ';
			
			$artget.=' from '._PRE.'qmd_articles a left join ('._PRE.'qmd_articles_ML AS ML)on(ML.parent=a.id)';
			
			$artget.=' WHERE VAC=0 ';
			$artget.=' AND ML.title<>"" ';
			$artget.=' AND ((display_mode &  '.__visible.')>0) ';
			
			$artget.=' AND ((ML.lang ="'.$qmdC->language.'") OR(ML.lang="'.$qmd_Lang_ANY .'"))';
			$artget.=' AND a.id <> '.s('display_page');
			$artget.=' AND (date<NOW()) ';
			
			$artgetWhere=' ORDER BY artorder ASC, DATE DESC';
			$artget.='  AND a.id in (';
			for ($i=0;$i<count($articles);$i++)
			{
				if ($i>0)
					$artget.=',';
				
				$artget.=$articles[$i];
			}
			$artget.=')';
			unset($articles);
			$articles = $qSQL->qSQLsimple($artget.$artgetWhere);
			if (is_array($articles))//we have found something
			{
					//ok now we prepare the results
					//we filter dupes which could be done with a refinement of SQL .... )-;
					//but this is faster for now.
					//TODO
	
				$iCount=count($articles);
				if ($iCount>0)
				{
					for ($j=0;$j<$iCount;$j++):
						$rec=$articles[$j];
						$aid=$rec['artid'];
						if (array_search($aid,$aShown)===FALSE)
						{
							if (is_null($result))
								$result=array();
							$result[]=$rec;
							$aShown[]=$aid;
						}
					endfor;
				}
			}
		}
	}
	unset($aShown);
	unset($articles);
	return $result;

}
// SITEMAP
function show_according_articles($articles)
{
global $qSQL;
	$aShown=array();
	$iCount=count($articles);
	
	if ($iCount>0)
	{
		
		echo '<ul>';
		//yecho($articles);
		for ($j=0;$j<$iCount;$j++):
			$rec=$articles[$j];
			//yecho($rec);
			$aid=$rec['artid'];
			if (array_search($aid,$aShown)===FALSE)
			{
				$aShown[]=$aid;
				if (empty($rec['title']))
					$title=$rec['seftitle'].' [empty title]';
				else
					$title=$rec['title'];
				echo '<li>'.qmd_createLink('/'.$rec['seftitle'],$title,$title).'</li>';
				$sql=query_get_art(7).' AND VAC=0 AND art_parent='.$aid;
				$subart=$qSQL->qSQLsimple($sql);
				if ((is_array($subart))&&(count($subart)>0))
					show_according_articles($subart);
			}
		endfor;
		
		echo '</ul>';
	}
	unset($aShown);
}
function _doSiteMapByMen($parentMen,$level=0)
{
global $qmdC;
global $qSQL;
	//echo $level.'<br/>';
		
	$menCount=0;
	$men_query = 'SELECT m.id, m.menulink, m.show_condition,m.parent,ML.'.$qmdC->language.' as lang
						FROM '._PRE.'qmd_menu m
						Left JOIN '._PRE.'qmd_menu_ML ML on (ML.mid=m.id)
						WHERE show_condition= 1 AND parent='.$parentMen; 
	
	//$men_query.=' AND parent='.$parentMen;

	$men_query.=' ORDER BY sort,id';
	
	$men_result = $qSQL->qSQLsimple($men_query);
	//yecho ($men_result);
	if (is_array($men_result))
		$menCount=count($men_result);
	
	if ($menCount <1)
	{	if ($parentMen<1)
			echo '<ul><li>no menu found</li></ul>';
	}
	else
	{
		echo '<ul>';
		for ($iCount=0;$iCount<$menCount;$iCount++):
		
			$m= $men_result[$iCount];
			$menid = $m['id'];
			if (is_callable($m['menulink']))
			{
				$sHint=gethtmlspacer(2).'1 '.l('entry');
				echo '<li><p class="qmd_sm_subcat">'.qmd_createLink('/'.$m['menulink'],$m['lang']).$sHint.'</p>';
			}
			else
			{
				if ($level==0)
					$sHint=l('sm_MainMenuEntry');
				else
					$sHint=l('sm_subMenuEntry');
				
				$articles=get_according_articles($menid);
				$sHint=gethtmlspacer(2).'['.$sHint.']';	
				

				if (!is_null($articles))
				{
					$sHint.=gethtmlspacer(2).(count($articles)).' '.l('entries');
				}
				echo '<li><p class="qmd_sm_subcat">'.qmd_createLink('/'.$m['menulink'],$m['lang']).$sHint.'</p>';
				
				show_according_articles($articles);
				
			}
			_doSiteMapByMen($menid,$level+1);
			echo '</li>';
		endfor;
		echo '</ul>';
	}
}


function doSiteMapByMen()
{
global $qmd_const_URL_Params;
global $qmdC;	
	$result=TRUE;
	echo '<h2>'.l('sitemap').'&nbsp;-&nbsp;'.l('sm_byMen').'</h2>';
	
	_doSiteMapByMen(-1,0);
	return $result;
}

function sitemap() 
{
global $qmdC;
	//if ($qmdC->get_UParamByName('sitemap')==-1)
		$result=doSiteMapByMen();
		
	return $result;
}
	
	

/*---------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/

//FILE INCLUSION
function file_include($text, $shorten,$mode=0)//mode=0 include mode=1 return content as string
{
	clearstatcache();
	
	$result=null;
	$fulltext = substr($text, 0, $shorten);
	if(substr_count ($fulltext, '&')>0):
		$fulltext = str_replace('&', '&amp;', str_replace('&amp;', '&', $fulltext));
	endif;
	
	if ($shorten < 9999000 && preg_match('<p>',$fulltext)):
	
		if (substr_count ($fulltext, '<p>') > substr_count ($fulltext, '</p>')) $fulltext .='</p>';
		
	endif;
	
	$ins = strpos($fulltext, '[/func]');
	if ($ins !==false):
	
		$text = str_replace('[func]', '|&|', $fulltext);
		$text = str_replace('[/func]', '|&|', $text);
		$text = explode('|&|', $text);
		$num = count($text) - 1;
		$i = 1;
		while ($i <= $num):
		
			$func = explode(':|:', $text[$i]);
			ob_start();
			$returned = call_user_func_array($func[0], explode(',',$func[1]));
			$text[$i] = ob_get_clean();
			if (empty($text[$i])):
			
				$text[$i] = $returned;
			endif;
			$i = $i + 2;
		endwhile;
		$fulltext = implode($text);
	endif;
	$inc = strpos($fulltext, '[/include]');
	if ($inc !==false):
		$text = str_replace('[include]', '|&|', $fulltext);
		$text = str_replace('[/include]', '|&|', $text);
		$text = explode('|&|', $text);
		$num = count($text);
		$extension = explode(',', s('file_extensions'));
		if ($num>0):
			for ($i = 0; $i<$num; $i++):
				if (!in_array(substr(strrchr($text[$i], '.'), 1), $extension)):
					echo substr($text[$i], 0);
				else:
					//include($filename);
					if (preg_match('/^[a-z0-9_\-.\/]+$/i', $text[1])):
						
						$filename=$text[1];
						
						if ($mode==0):
							file_exists($filename) ? include($filename) : print l('error_file_not_exists').' '.$filename;
						
						else:
							$result=file_get_contents($filename);
						
						endif;
					else:
						echo l('error_file_name');
					endif;
				endif;
			endfor;//for
		endif;

	else:
	
		echo $fulltext;
	endif;
	return $result;
}
/*----------------------------------------------------------------------------*/

// CONTACT FORM - 
function contact() 
{
global $qmdC;
	$result=TRUE;
	
	if (!isset($_POST['contactform'])):
		$AO=$qmdC->qmdA();
		if ($AO!=null):
			$AO->ArticleShow();
		endif;
		$_SESSION[_SITE.'/time'] = time();//TODO here the _SITE should be set to current site selected
		
		echo
			'<div class="qmd_commentsbox"><h2>'.l('contact').'</h2>
			<p>'.l('required').'</p>
			<form method="post" action="/contact" id="post" accept-charset="UTF-8">
			<p><label for="name">* ',l('name'),'</label>:<br />
			<input type="text" name="name" id="name" maxlength="100" class="text" value="" /></p>
			<p><label for="email">* ',l('email'),'</label>:<br />
			<input type="text" name="email" id="email" maxlength="320" class="text" value="" /></p>
			<p><label for="weblink">',l('url'),'</label>:<br />
			<input type="text" name="weblink" id="weblink"  maxlength="160" class="text" value="" /></p>
			<p><label for="message">* ',l('message'),'</label>:<br />
			<textarea name="message" rows="5" cols="5" id="message"></textarea></p>
			',mathCaptcha(),'
			<p><input type="hidden" name="ip" id="ip" value="',$_SERVER['REMOTE_ADDR'],'" />
			<input type="hidden" name="time" id="time" value="',time(),'" />
			<input type="submit" name="contactform" id="contactform" class="buttonbig" value="',l('submit'),'" /></p>
			</form>
			</div>';
	else:
		
		if( isset( $_SESSION[_SITE.'/time'] ) ):
		
		
			$count = $magic = 0;
			if( get_magic_quotes_gpc() ){ $magic = 1; }
			
			foreach($_POST as $k => $v):
			
				if($count === 8 ) die;
				if( $magic ) $$k = stripslashes($v);
				else $$k = $v;
				++$count;
			endforeach;
			
			$to = s('website_email');
			$subject = s('contact_subject');

			$name = (isset($name[0]) && ! isset($name[300]) ) ? trim($name) : null;
			$name = ! preg_match('/[\\n\\r]/', $name) ? $name : die;

			$mail = (isset($email[6]) && ! isset($email[320]) ) ? trim($email) : null;
			$mail = ! preg_match('/[\\n\\r]/', $mail) ? $mail : die;

			$url = (isset($weblink[4]) && ! isset($weblink[160]) ) ? trim($weblink) : null;
			$url = ( strpos($url, '?') === false && ! preg_match('/[\\n\\r]/', $url)) ? $url : null;
			$message = (isset($message[10]) && ! isset($message[6000]) ) ? strip_tags($message) : null;
			$time = ( $_SESSION[_SITE.'/time'] === (int)$time && (time() - $time) > 10) ? $time : null ;

			if ( isset($ip) && $ip === $_SERVER['REMOTE_ADDR'] && $time):
				
				if (checkMathCaptcha()):
					if ($name && $mail && $message):
				
						unset($_SESSION[_SITE.'/time']);
					
						$send_array = array(
											'to'=>$to,
											'name'=>$name,
											'email'=>$mail,
											'message'=>$message,
											'ip'=>$ip,
											'url'=>$url,
											'subject'=>$subject);
						
						$x=send_email_c($send_array);
						if ($x==1):
							
							qmd_notify(0, l('contact_sent') ,array(l('backhome')),array('/'));
						else:
							qmd_notify(3, l('contact_not_sent').' '.l('severeSYSERROR') ,array(l('backhome')),array('/'));
						endif;
					else:
						qmd_notify(2, l('contact_not_sent').' '.l('err_emptyFields') ,array(l('back')),array('/contact'));
						//$notifytype		0	ok	1 Warning 2 Error 3 SystemError 4 FORWARD 5 coming from Forward
						//$usermsg 		message to be displayed to user
						//$aLinkLabel	Array with labels 4 Links
						//$aLinkList	Array with Links
						//$Reload		
						//$ReloadTimeOut time message is displayed
					endif;
				else:
					qmd_notify(2, l('contact_not_sent').' '.l('err_math_captcha') ,array(l('back')),array('/contact'));
				endif;
	 		else:
	 			qmd_notify(1,l('contact_not_sent').' [time]',array('contact'),array('/contact'));
	 			msgbox(l('contact_not_sent'));
	 		endif;
		else:
			qmd_notify(-1,'Internal ERROR');
		endif;
	endif;
	return $result;
}

function contactform()	//heritage... )-;
{
	contact();
}



// SEARCH ENGINE
function search_add_sql($keyword)
{
	$result = '(lower(title) LIKE "%'.$keyword.'%" ||
				lower(body) LIKE "%'.$keyword.'%" ||
				lower(keywords_meta) LIKE "%'.$keyword.'%"
				|| lower(subject_meta) LIKE "%'.$keyword.'%"
				|| lower(description_meta) LIKE "%'.$keyword.'%")';
	return $result;
}
function search($limit = 20) 
{
	global $qmdC;
	$result=TRUE;
	
	$iDBStatus=0;
	$iRowCount=0;
	
	$search_query = strtolower(clean(cleanXSS($_POST['search_query'])));
	echo '<h2>'.l('search_results').'</h2>';
	
	if (strlen($search_query) < 4 || $search_query == l('search_keywords')) {
		echo '<p>'.l('charerror').'</p>';
	}
	else
	{
		$keywords = explode(' ', $search_query);
		$keyCount = count($keywords);
		
		$query = query_get_art_cat($qmdC->language);
		//$query.=' AND lang="'.$qmdC->language.'"';
		$query.=' AND ';
		
		for ($i = 0; $i < $keyCount; $i++)
		{
			if ($i > 0)
				$query = $query. ' && '.search_add_sql($keywords[$i]);
			else
				$query = $query. search_add_sql($keywords[$i]);
		}//for
		
		$query = $query.' ORDER BY id DESC LIMIT '.$limit;
		//debuglog($query);
		$AR = getSQL($query,$iDBStatus,$iRowCount);

		if (is_array($AR)):
			
			$numrows = count($AR);
			
			if ($numrows==0)
			{
				echo '<p>'.l('noresults').'
				<strong>'.stripslashes($search_query).'</strong>.</p>';
			}
			else
			{
				$iCount=$numrows-1;
				$lastArtID=$AR[$iCount]['artid'];
				
				$iCount--;
				while ($iCount>=0):
				
					if ($AR[$iCount]['artid']==$lastArtID)
					{
						if ($iCount<$numrows-1)
						{
							if ($qmdC->language==$AR[$iCount]['lang'])
								dropFromArray($AR,$iCount+1);
							else
								dropFromArray($AR,$iCount);
						}
					}
					else
						$lastArtID=$AR[$iCount]['artid'];
					$iCount--;
				endwhile;
				
				echo '<p><strong>'.$numrows.'</strong> '.l('resultsfound').' <strong>'.
				stripslashes($search_query).'</strong>.</p>';
				
				$numrows = count($AR);
				for ($i=0;$i<$numrows;$i++):
					$rec=$AR[$i];
						
						//{
					$date = date(s('date_format'), strtotime($rec['date']));
					$title= $rec['title'];
					$sef=$rec['seftitle'];
					
					echo '<p><b>'.qmd_createLink($sef,$title,$title).'</b> - '.$date.' ['.l('category').': <b>'.$rec['catlink'].'</b>]</p>';
					//}//while
				endfor;
			}
		else:
			msgbox('ERROR on Query for this search');
		endif;
	}
	echo '<p>'.qmd_createLink('/',l('backhome')).'</p>';
	return $result;
}//search engine

function usermessages()
{
global $qmdC;

	$result=TRUE;
	
	
	if ($qmdC->get_uid()>0)
	{
		
		default_display_article();
		
	}
	else
	{
		$qmdC->set_SEF('400');
		$result=FALSE;
	}
	return $result;
}

/*----------------------------------------------------------------------------*/
?>