<?php

/*------------------------------
	Program: qmd-cms [qimanfaya-Menu-Driven-CMS]
	Module: qmd List class extension for excursions
	
	..............................................
	qmd-cms 0.8.6
	last update: 04/26/2014
	--------------------------------

	qmd_msg_list.php
	================

	This file is part of the qmd-php-library
	
	Author: ***hy
	For further reference regarding this code see qmdcms.php and the readme-files.
	
	This code was developed by ****hy
	Copyright: qimanfaya/hy-soft 2012,2014
	
	Licence:		GPL V.3

	A copy of the GNU General Public License is available:
	in the root of this folder
	and on the World Wide Web
	at <http://www.gnu.org/licenses/gpl-3.0.txt>. You can also obtain it by writing
	to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
	MA 02111-1307, USA.
	
*/
//This is a demo object that shows lists in a functional mode

	class message_list extends qmd_LIST{
		var $ATypes;

		function __construct($controller,$BaseRec){
		
			parent::__construct($controller,$BaseRec,'qmd_user_msg','');
			//$this->db_Name=;
			
			$this->sql_list='Select m.id,m.date,m.user_from,m.user_to,m.subject,m.msg,u.uname,
									case m.seen WHEN 0 THEN "'.l('msg_not_seen').'" ELSE "'.l('msg_seen').'" END as seen
									from '._PRE.'qmd_user_msg m 
									left join '._PRE.'qmd_users u on u.id=m.user_from
									WHERE user_to='.$controller->uid.' ORDER by seen ASC, date DESC';
			
			$this->URLfieldName='id';//this is the field containing the ID that links to the parent article
			$this->LinkFieldName='subject';//this is the field that gets the anchor
			$this->IDField='id';

			switch ($this->_CONTROLLER->language):
				case 'de':
					$this->listHeader=
						"Folgende Nachrichten liegen f&uuml;r Sie bereit. Durch einen Klick auf das Subject wird die Nachricht angezeigt
						und als gelesen markiert.";
					
					break;
				case 'en':
					$this->listHeader=
						"Here you find an overview of your messages. By clicking on the subject the message will be displayed - and marked as read.";
					
					break;
				case 'es':
					$this->listHeader=
						"Aqui encuentras un resumen de sus mensajes. Haga cliq en el enlace/sujeto para ver y marcar el mensaje como leido.";
					
					break;
			endswitch;
			$this->ListColLabels=array(l('msg_number'),l('date'),l('msg_subject'),l('msg_body'),l('msg_from'),l('msg_seen'));
			//Now we define the fields
			$this->ListCOLs=array('id','date','subject','msg','uname','seen');
			
			$this->arSortFields=array('date','name','subject');
			
			
			$this->_cssFile='./css/msg_list.css';
			
			//this should be the end of initialization
			$this->_ArticleType=2;//this is a list
			//$this->register_ArticleType();
			$this->ItemTitlefield='subject';//i2s2bt-btwostp
		}
		
		function __destruct(){
			parent::__destruct();
			
		}
		function articleInit()
		{global $qSQL;
		
			parent::articleInit();
			if ($this->ArticleRow==null)
			{
				$sql=$this->sql_list;
				$this->ArticleRow=$qSQL->qSQLquick($sql,null);
					
				
			}
		
		}
		function ArticleShow($Mode=1)//Mode=0 show teaser Mode=1 show all
		{
			$result=parent::ArticleShow($Mode);
			
			return $result;
		}
		
		function objectEdit(){
			msgbox('You can not edit this item');
		}
		function objectSave($parentID){
			$result=FALSE;
			msgbox('You can not edit this item - so you can not save it');
			return $result;
		}
		//YOU MUST OVERRIDE THIS ONE IN YOUR LIST
		public function getChildLoader()
		{	
			$result='qmd_usr_msg_item.php';
			return $result;
		}
		//we are overriding these functions
		function getListItemCellValue($row,$key,$value)
		{	//this is in order you want to diplsy only part of the data in list overview
			$result=$value;
			
			if (strlen($result)>40){
			$result=substr($result,0,40).'...';
			}
			return $result;
		}
		
		function createListItemLink($link,$text)
		{
			//this is the overriden function 
			$result=qmd_createLink('/'.$this->_CONTROLLER->URL[0].'/?action=showItem%26item='.$link,$text);
			return $result;
		}
		
	}//end of object
	
?>