<?php
/*	Program: qmd-cms [qimanfaya-Menu-Driven-CMS]
	Module: qmd default query definitions
	..............................................
	qmd-cms 0.8.7
	last update: 04/28/2014

	--------------------------------

	qmd_queries.php
	===============

	This file is part of the qmd-php-library
	
	Author: ***hy
	For further reference regarding this code see qmdcms.php and the readme-files.
	
	This code was developed by ****hy
	Copyright: qimanfaya/hy-soft 2012,2014
	
	Licence:		GPL V.3

	A copy of the GNU General Public License is available:
	in the root of this folder
	and on the World Wide Web
	at <http://www.gnu.org/licenses/gpl-3.0.txt>. You can also obtain it by writing
	to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
	MA 02111-1307, USA.
	
*/
function query_get_menu($allLang=0){
global $qmdC;
global $LANG;

$result='SELECT m.id as menid,m.menulink,m.parent as menparent,m.show_condition,m.sort,m.show_sub_in_article_head,m.scheme';
if ($allLang=1):
	for ($i=0;$i<count($LANG);$i++):
		
		if ($LANG[$i]==$qmdC->language)
		{	$result.=',ML.'.$LANG[$i];
			$result.= ' as menucaption ,ML.'.$LANG[$i];
		}
		else
		{$result.=',ML.'.$LANG[$i];}
	endfor;
else:
	$result.=',ML.'.$qmdC->language.' as menucaption ';
endif;

$result.=' from ' ._PRE.'qmd_menu m left join ('._PRE.'qmd_menu_ML ML) on (m.id=ML.mid) ';
return($result);
}
function query_get_cat(){

global $qmdC;

$result='SELECT c.id as catid,c.catlink,c.parent as catparent,c.description,c.published,c.catorder, c.scheme,
			ML.* ,ML.'.$qmdC->language.' as name from '._PRE.'qmd_categories c'
			.' left join ('._PRE.'qmd_categories_ML AS ML)on(ML.mcid=c.id)';

return($result);
}

function _query_get_art($Mode=6){
//Mode 
//0 = do not add where-clause

//2 = limit where to visible
//4 = limit where to date<now()



	$result='SELECT a.id as artid,a.art_parent,a.date,a.seftitle,a.category,a.commentable,a.display_mode,
			a.show_on_home,a.artorder,a.default_page,a.displaytitle,a.showdate,a.VAC,a.scheme,
			a.objectloader,a.DCType,a.DOCtypeHTML,a.optXtra,
			ML.id as MLID, ML.parent, ML.body,ML.title,ML.keywords_meta,ML.description_meta,ML.lang as lang ,ML.subject_meta
			from '._PRE.'qmd_articles a left join ('._PRE.'qmd_articles_ML AS ML)on(ML.parent=a.id)';
	if ($Mode>0):
	
		$result.=' WHERE (1=1)';
	
		if (($Mode & 2) > 0)
			$result.=' AND ((display_mode &  '.__visible.')>0) ';
		if (($Mode & 4) > 0)
			$result.=' AND (date<NOW()) ';
	
	endif;

	return($result);
}

function query_get_art($Mode=7){
//Mode 
//0 = do not add where-clause
//1 = limit where to Articles
//2 = limit where to visible
//4 = limit where to date<now()


$result = _query_get_art($Mode);
if (($Mode & __VAC) == 1):
	$result.=' AND(VAC=0) ';
endif;

return($result);
}

function query_get_VAC($Mode){

//Mode 
//0 = do not add where-clause
//1 = limit where to VAC
//2 = limit where to visible
//4 = limit where to date<now()

$result = _query_get_art($Mode);
if (($Mode & __VAC) > 0):
	$result.=' AND(VAC>0) ';
endif;
return($result);
}

function query_get_art_cat($lang,$lAddWhere=TRUE){
global $qmd_Lang_ANY;

$result='SELECT a.id as artid,a.date,a.seftitle,a.category,a.commentable,a.display_mode,
			a.show_on_home,a.artorder,a.default_page,a.displaytitle,a.showdate,a.DCType,a.DOCtypeHTML,
			ML.id, ML.parent, ML.body,ML.title,ML.keywords_meta,ML.description_meta,ML.lang as lang,ML.subject_meta,
			c.id as catid,c.catlink,c.parent as catparent,c.description,c.published,c.catorder,';
if ($lang==$qmd_Lang_ANY):
	$result.= 'MLC.'.s('language').' as catlang';
else:
	$result.= 'MLC.'.$lang.' as catlang';
endif;
$result.=' from '._PRE.'qmd_articles a left join ('._PRE.'qmd_articles_ML AS ML)on(ML.parent=a.id)'
.' left join ('._PRE.'qmd_categories AS c)on(a.category=c.id)'
.' left join ('._PRE.'qmd_categories_ML AS MLC)on(MLC.mcid=c.id)';

if ($lAddWhere==TRUE):
	$result.='WHERE (a.VAC=0)';
endif;


return($result);
}
function get_ArticleLangsAvail($id)
{
	$result=array();
	$sql=query_get_art(0).' WHERE a.id='.$id;

	$iDBStatus=0;
	$iRowCount=0;
	
	$rows=getSQL($sql,$iDBStatus,$iRowCount);

	if (($iDBStatus>=0)&&($iRowCount>0)):
		for ($iCount=0;$iCount<$iRowCount;$iCount++):
			
			$result[$iCount]=$rows[$iCount]['lang'];
		endfor;
	endif;
	return $result;
}

function seekArticleWithLangSQL($sql,$lang,$Mode,$langID=-1)
															//$Mode=0: seek for $lang
{															//				or deliver s('language')
															//				or deliver @ANY
															//$Mode=1 seek for $lang exactly
															//$Mode=-1 deliver any
															//$Mode is ignored if $langID>0
															//in this case we're just looking for the exact ID in ML
	global $qmd_Lang_ANY;
	
	
	$result=null;
	$iDBStatus=0;
	$iRowCount=0;
	
	
	if (empty($lang))$Mode=-1;//we probably just need a parent
	
	$rows=getSQL($sql,$iDBStatus,$iRowCount);

	if (($iDBStatus>=0)&&($iRowCount>0)):	//we have a result
	
		$id=$rows[0]['artid'];	//save this id
		$kCount=0;					//lets go through the entries	
		$iDef=-1;					//iDef will deliver the exact row in question
		$iLang=-1;					//iLang will either have the @any row or the exact 1
		$anyLang=-1;
		if ($langID>0)
		{	
			while (($kCount<$iRowCount)&&($rows[$kCount]['MLID']<>$langID))
				$kCount++;
			if ($rows[$kCount]['MLID']==$langID)
				$result=$rows[$kCount];
		}
		else
		{
			while (($kCount<$iRowCount)&&($iLang<0)):
				$row=$rows[$kCount];
				if ($row['lang']==$lang):
					$iLang=$kCount;	//exit
				else:
					if ($row['lang']==$qmd_Lang_ANY):
						$anyLang=$kCount;
					else:
						if ($row['lang']==s('language')):	//we save this to deliver at least the system language...
							$iDef=$kCount;
						endif;
					endif;
				endif;
				
				$kCount++;
			endwhile;
		}
		if ($row['lang']==$lang):
			$result=$row;	//we use this one
		else:
			
			switch ($Mode):
				case -1://deliver any
					
					if ($iDef>=0):	//system default Language
						$result=$rows[$iDef];
					else:
						if ($anyLang>=0):
							$result=$rows[$anyLang];
						else:
							$result=$rows[0];//just pick one
						endif;
					endif;
					
					break;
				case 0://lang or s('language')
					if ($iDef>=0):	//system default Language
						$result=$rows[$iDef];
					else:
						if ($anyLang>=0)
							$result=$rows[$anyLang];
					endif;
					break;
				case 1://do nothing result remains null
					if ($anyLang>=0):
						$result=$rows[$anyLang];
					endif;
					break;
			endswitch;
		endif;
		
		
	else:
		if ($iDBStatus<0):
			msgbox('ERROR on seeking Article with Lang');
			debuglog($sql,'seekArticleWithLang results in an error',TRUE);
		endif;
	endif;	
	return $result;
}
function _seekArticleWithLang($artid,$sef,$lang,$Mode)//$Mode=0: seek for $lang
{															//				or deliver s('language')
															//$Mode=1 seek for $lang exactly
															//$Mode=-1 deliver any
															//$Mode=-2 create a copy of any/nearest
	
	
	$result=null;
	
	$sql=query_get_art(0);
	if ($artid>0):
		$sql.=' WHERE a.id='.$artid;
	else:
		$sql.=' WHERE a.seftitle="'.$sef.'"';
	endif;
	$result=seekArticleWithLangSQL($sql,$lang,$Mode);
	if (($result!=null)&&($Mode==-2)&&($result['lang']<>$lang)):
		//okay we have a result
		//but it doesn't match 
		//and we need to create a copy
		$ArtObj=$qmdC->load_Article_Data($result,true,$result['objectloader']);
		if (is_null($ArtObj)):
			
			qmd_die('Can not create an object instance of this data');
		else:
			$result=$ArtObj->createLangCopy($lang);
			if ($result==TRUE):
				$result=seekArticleWithLang($result[artid],$lang,1);
			else:
				qmd_die('Error finding the proper language');
			endif;
		endif;
		
	endif;
	return $result;
															
}

function seekArticleWithLang($artid,$lang,$Mode)//$Mode=0: seek for $lang
{															//				or deliver s('language')
															//$Mode=1 seek for $lang exactly
															//$Mode=-1 deliver any
															//$Mode=-2 create a copy of any/nearest
	$result=_seekArticleWithLang($artid,'',$lang,$Mode);
	return $result;
}
//this is not used up to now!
function seekArticleWithLangBySef($sef,$lang,$Mode)//$Mode=0: seek for $lang
{															//				or deliver s('language')
															//$Mode=1 seek for $lang exactly
															//$Mode=-1 deliver any
															//$Mode=-2 create a copy of any/nearest
															
	$result=_seekArticleWithLang(-1,$sef,$lang,$Mode);
	return $result;
}

// *************************************** utility
function retrieve2($column, $table, $field, $value,$chkField2='',$chkVal2='') {
	global $qmdC;
	global $qSQL;
	
	$result = NULL; 

	if (!is_null($value)):
		
		if ($table == 'qmd_categories'):
			global $retr_cache_cat_id, $retr_cache_cat_sef;

			if ($column == 'name'):
			
				$result = $retr_cache_cat_sef[$value];
			
			else:
				if ($column == 'catlink'):
					$result = $retr_cache_cat_id[$value];
				endif;
			endif;
		else:
			if (($table=='qmd_articles')&&($column=='title')):
				
				$sql=query_get_art(0).'WHERE '.$field.' = "'.$value.'"';

				$r=seekArticleWithLangSQL($sql,$qmdC->language,-1);//-1 for using the article in question anyway
				if ($r<>null):
					$result = $r[$column];
				else:
					msgbox('ERR2 retrieve: '.$sql);
				endif;
			else:
				
				$sql="SELECT $column FROM "._PRE."$table WHERE $field = ?";
				if (empty($chkField2)):
					$aVALS=array($value);
				else:
					$sql.=" AND $chkField2=?";
					$aVALS=array($value,$chkVal2);
				endif;
				
				$r=$qSQL->qSQLquick($sql,$aVALS);
				//
				if (is_array($r)):
					$result = $r[0][$column];
				else:
					msgbox('failed 2 retrieve: '.$sql);
				endif;
			endif;
		
		endif;
	else:
		
	endif;
	
	return $result;
}//end retrieve()
function retrieve($column, $table, $field, $value) {
	
	$result=retrieve2($column, $table, $field, $value);
	return $result;
}
function get_Menu2Article($articleID)
//results in an empty array if no menue attached or otherwise the ids of all attached menus
{
global $qSQL;
	$result=array();
	if (isset($articleID)):
		$sql='Select menu_id from '._PRE.'qmd_article2menu where article_id='.$articleID;
		$resultset=$qSQL->qSQLsimple($sql);
		
		for ($iCount=0;$iCount<count($resultset);$iCount++)
		{
			$result[]=$resultset[$iCount]['menu_id'];
		}
		
	else:
 		qmd_die('-(3): get_Menu2Article needs id of article but is missing','should NOT happen');
	endif;
	
	return $result;
}//get_Menu2Article()

function insert_article2menu($artid,$menuid)
{
global $qSQL;

	//msgbox('ART: '.$artid.' Men: '.$menuid);
	$sql='Select menu_id from '._PRE.'qmd_article2menu where article_id='.$artid.' AND menu_id='.$menuid;
	$resultset=$qSQL->qSQLsimple($sql);
	if ((is_array($resultset))&&(count($resultset)==0))
	{
		if ($qSQL->prepareinsert(array('menu_id','article_id'),array($menuid,$artid))>0):
			$res=$qSQL->insertSQL(_PRE.'qmd_article2menu',$xdummy);
			if ($res>0):
				
				$processStatus=1;
			else:
				msgbox('Error Insert article2Menu 2');
				$processStatus=-1;//-1 Error +1ok
			endif;
		else:
			msgbox('Error Insert article2Menu 1');
			$processStatus=-1;//-1 Error +1ok
		endif;
	}
}

function delete_article2menu($artid,$menuid)
{
global $qSQL;
	if ($qSQL->preparedelete(array('menu_id=','article_id='),array($menuid,$artid),array(' AND '))>0):
		$res=$qSQL->deleteSQL(_PRE.'qmd_article2menu',$xdummy);
		if ($res>0):
			
			$processStatus=1;
		else:
			msgbox('Error Insert article2Menu 2');
			$processStatus=-1;//-1 Error +1ok
		endif;
	else:
		msgbox('Error Insert article2Menu 1');
		$processStatus=-1;//-1 Error +1ok
	endif;
}
function query_get_comment($artid,&$aVALs,$coid=NULL,$approved=1)
{
	$aVALs[]=$artid;					
	$result= 'SELECT
						c.id as coid,c.title,c.articleid,c.name,c.url,c.comment,c.time,c.approved,c.userid,c.answer2comment,
						u.id,u.uname
						FROM '._PRE.'qmd_comments c left join(qmd_users u)on(u.id=c.userid)
						WHERE articleid = ? ';
	
	if ($approved==1)
	{
		$result.=	' AND approved = ? ';
		$aVALs[]=1;
	}
	if (is_null($coid))
		$result.= ' AND ((answer2comment is NULL)';
	else
	{
		$result.= ' AND ((answer2comment=?)';
		$aVALs[]=$coid;
	}
	$result.= ') ORDER BY c.id '.s('comments_order');
	
	return $result;
}
?>