<?php
/*
	Program: qmd-cms [qimanfaya-Menu-Driven-CMS]
	Module: qmd sys - some system functions
	..............................................
	qmd-cms 0.8.6
	last update: 04/26/2014

	--------------------------------

	qmd_sys.php
	=============

	This file is part of the qmd-php-library
	
	Author: ***hy
	For further reference regarding this code see qmdcms.php and the readme-files.
	
	This code was developed by ****hy
	Copyright: qimanfaya/hy-soft 2012,2014
	
	Licence:		GPL V.3

	A copy of the GNU General Public License is available:
	in the root of this folder
	and on the World Wide Web
	at <http://www.gnu.org/licenses/gpl-3.0.txt>. You can also obtain it by writing
	to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
	MA 02111-1307, USA.
	*/

function _droeselupTrace($item,$space='+')
{
	$result='';
	if (is_array($item)):
		
		foreach($item as $key => $value){
			
			if (is_array($item[$key])):
				$result.=_droeselupTrace($item[$key],$space.'+');
			else:
				$result=$space." [".$key."]=".$value."[br/]";
			endif;
		}
	else:
		$result=$item."[br/]";
	endif;
	return $result;
}

function	qmd_die($msg)
{

	$strace='[br/]'. get_debug_backtrace('[br/]');
	
	$s='[br/]'."URI: ".$_SERVER['REQUEST_SCHEME'].'://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'];
	$s.='[br/]Trace:[br/] '.$strace;
	$s.='[br/]Trace ... ends[br/] ';
	$s.='[br/]last Message: '.$msg;
	send_sys_message('System died!!!',$s);
	die($msg);
}

function send_sys_message($usermsg,$msgbody,$showTrace=0)//send message from system to admin
{
	global $qSQL;
	global $qmdC;
		$userTo=2;	//admin is #2 by default
		if (($qmdC->get_uid()>0)&&($qmdC->get_user==__USER_isAdmin))
		{
			$userTo=$qmdC->get_uid();
		}
		else
		{
			$sql='Select id from '._PRE.'qmd_users where uname=?';
			$res=$qSQL->qSQLquick($sql,array('admin'));
			if (is_array($res))
				$userTo=$res[0]['id'];
		}
		$sql='INSERT INTO '._PRE.'qmd_user_msg (user_from,user_to,subject,msg)VALUES(?,?,?,?)';
		$subj=$usermsg;
		$txt='IP: '.$_SERVER['REMOTE_ADDR'].'[br/]';
		$txt.=$msgbody;
		$txt.="[br/]Initiated from: ".$qmdC->get_URLRequest().'[br/]'
				.'[br/]';
		if ($showTrace>0)
			$txt.=get_debug_backtrace('[br/]');
		$txt.='[br/]'.'Greetings your friendly CMS-system qMD-CMS '.__y_qmd_cms_version;
		$A=array(1,$userTo,$subj,$txt);
		$res=$qSQL->qSQLquick($sql,$A);
		if ($res<=0)
			msgbox('ERROR sending system message');
}
function init_languages(){

	$result=FALSE;
	global $LANG;

	$LANG=array();
	$L2=array();
	
	$L2[0]='en';
	$L2[1]='es';
	$L2[2]='eo';
	$L2[3]='jp';
	$L2[4]='cn';
	$L2[5]='pt';
	$L2[6]='de';
	//EXTENDING LANGUAGES:
	//###############################################
	//1.) extend this list to your needs here...!!!
	//2.) translate en.php to your new language
	//3.) put a banner/flag regarding the country
	//		of your language into www/dev.img
	//4.) move down to (F) show_SelectLanguage()
	//		enter your flag-name in the case statement
	//###############################################
	
	$i=count($L2);
	$i--;
	
	while ($i>=0):
		if (file_exists('lang/'.$L2[$i].'.php'))$LANG[count($LANG)]=$L2[$i];
		$i--;
	endwhile;
	
	
	//we also check if a possible language has been selected via URL - for Permalinks
	/*$sLang=$qmdC->get_UParamByName('lang');
	
	if ($sLang<>-1):
		if (in_array($sLang,$LANG)):
			$qmdC->set_language($sLang);
			$result=TRUE;
		endif;
	endif;
	*/
	return $result;
}//init_languages();

function show_SelectLanguage()
{
	global $qmdC,$LANG;
	// 		<!--***hy show Language selection -->
	//Display bandera first for different length of output depending on language
	$sband= '<div id="langSelectbandera">';
		$sband.='<img src="/dev.img/';
		switch ($qmdC->language):
			case 'de':$sband.='bandera_de.png';break;
			case 'en':$sband.='bandera_en.png';break;
			case 'es':$sband.='bandera_es.png';break;
			default: $sband='bandera_en.png';
		endswitch;
		$sband.='" alt="Flag"/>';
	$sband.='</div>';
	
	$sOut='';
	
	$sOut.= html_input('combobox', 'cmbLang', 'cmbLang', $qmdC->language, l('selLanguage'), 'opt_Lang', 'onchange="changeLanguage(\'cmbLang\')"', '',       '',    '',    '',      '',      '',     '',        $LANG);
	
	$sOut=$sband.$sOut;
	// 		<!-- Language ends-->
	return $sOut;
}


function get_scheme_array(){
global $ASCHEMES;
	if (count($ASCHEMES)==0)
	{
		$sPath='schemes/';
		$ASCHEMES=array();
		$files = scandir($sPath);
	
		for ($i=0;$i<count($files);$i++):
			if (is_dir($sPath.$files[$i])):
				if (($files[$i]!='.')&&($files[$i]!='..')):
					$ASCHEMES[]=$files[$i];
				endif;
			endif;
		endfor;
	}
	return $ASCHEMES;
}

?>