<?php

/*
	Program: qmd-cms [qimanfaya-Menu-Driven-CMS]
	Module: qmd user module
	..............................................
	qmd-cms 0.8.7
	last update: 04/28/2014

	--------------------------------

	qmd_users.php
	=============

	This file is part of the qmd-php-library
	
	Author: ***hy
	For further reference regarding this code see qmdcms.php and the readme-files.
	
	This code was developed by ****hy
	Copyright: qimanfaya/hy-soft 2012,2014
	
	Licence:		GPL V.3

	A copy of the GNU General Public License is available:
	in the root of this folder
	and on the World Wide Web
	at <http://www.gnu.org/licenses/gpl-3.0.txt>. You can also obtain it by writing
	to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
	MA 02111-1307, USA.
	
*/

// LOGIN

function login() {
	
	$result=TRUE;
	
	global $qmd_const_URL_Params;
	global $qmdC;
	
	if ($qmdC->get_uid() < 0):
	
		echo '<div class="qmd_userpanel">
		<h2>'.l('login').'</h2>';
		//checklogin is never ever checked - we evaluate this form on startup of script
		echo html_input('form', '', 'post', '',  '', '', '', '', '', '', 'post', '/'.$qmdC->language.'/?action=checklogin');
		echo '<p>'.l('login_limit').'</p>';
		echo html_input('text', 'uname', 'uname', '', l('username'), 'text');
		echo html_input('password', 'pass', 'pass', '', l('password'), 'text');
		echo mathCaptcha();
		echo '<p>';
		echo html_input('hidden', 'Loginform', 'Loginform', 'True','');
		echo html_input('submit', 'submit', 'submit', l('login'), '', 'button');
		//$ref=@$HTTP_REFERER;
		$ref=$_SERVER['HTTP_REFERER'];
		//POST will be deleted after checklogin
		$_SESSION[_SITE.'/return2']=$ref;
		//echo html_input('hidden', 'return2', 'return2', $ref);
		
		echo '</p></form></div>';
	
	else:
	
		echo '<h2>'.l('logged_in').'</h2>
		<p>'.qmd_createLink('/logoff',l('logoff')).'</p>';
	endif;
	return $result;
}


function dropcookies()
{	

	$cookiesSet = array_keys($_COOKIE);
	
	for ($x=0;$x<count($cookiesSet);$x++):
		

		setcookie($cookiesSet[$x],$_COOKIE[$cookiesSet[$x]],time()-3600*24,'/',puresitename(1),0);
	endfor;

}

function logoff()
{
	$result=TRUE;
	//from: http://7php.com/php-5-3-how-to-completely-destroy-session-variables-in-php/
	//remove PHPSESSID from browser
	if ( isset( $_COOKIE[session_name()] ) )
		setcookie( session_name(), “”, time()-3600, “/” );
	//clear session from globals
	session_destroy();
	unset($_SESSION);
	$_SESSION = array();
	//clear session from disk
	
	echo '<meta http-equiv="refresh" content="0; url=http://'._SITE.'/?action=logoff">';
	echo '<h2>Log Off</h2>';//we don't have languages read yet
	return $result;
}

function gencookie($urec)
{
global $qmdC;

	$s=$qmdC->get_uid().$urec['eMail'].$urec['tmp'];
	
	$result=md5($s);
	
	return $result;
}

//This is not used ATM

function checkUID($uid)
{
	global $qSQL;
	$result=-1;
	$sql='SELECT * from '._PRE.'qmd_users WHERE (id=?)';
	$xID=0;
	
	$res=$qSQL->qSQLdirect($sql,array($uid),$xID);
	if (is_array($res)):
		
		
		if ($xID>0):
			$result=$res[0]['id'];
		endif;
	endif;
	return $result;
}
function verifyUser()
{
	global $qSQL;
	global $qmdC;
	$result=-1;
	
	$ruid=-1;
	$runame='';
	$rurole=0;
	
	if (isset($_COOKIE['user'])):
		$su1=$_COOKIE['user'];
		if (isset($_COOKIE['userdata'])):
			$su2=$_COOKIE['userdata'];
			$i=strrpos($su1,'%');
			if ($i>0):
				$su1=substr($su1,$i+1,999);
				if (empty($su1)):
					debuglog('USER NOT OK - su1 empty');
				else:

					$sql='SELECT * from '._PRE.'qmd_users WHERE (id=?) AND (OPMode>0)';
					$xID=0;
					
					$res=$qSQL->qSQLdirect($sql,array($su1),$xID);//we fetch userdata
					if (is_array($res)):
						if ($xID>0):
							$r=$res[0];
							
							$su3=gencookie($r);							//we check that user has not tampered with the cookie data
							if ($su3==$su2):
								debuglog('USER OK - '.$r['id']);
								$result=1;

								$ruid=$r['id'];
								$runame=$r['uname'];
								$rurole=$r['OPMode'];
							else:
								
								clear_session(-1);
								dropcookies();
								
								qmd_notify(-1,'something went wrong - use one of the links below and retry',
											array(l('backhome'),l('login')),array('/','/login'));
							endif;
						else:
							debuglog('USER NOT OK - dbquery');
						endif;
					endif;
						
				endif;
			else:
				debuglog('USER NOT OK - missing%');
			endif;
		else:
			debuglog('USER NOT OK - userdata not set');
		endif;
	else:
		debuglog('USER NOT OK - user not set');
	endif;
	
	$qmdC->set_uid($ruid,$runame,$rurole);
	debuglog('USER verification finished');
	return $result;
		
}

function createValidation()
{
	$result='';
	while (strlen($result)<64):
		$num=rand(1,255);
		$ch=dechex($num);
		$result.=$ch;
		
	endwhile;
	$result=substr($result,0,63);
	return $result;
}


function randString($iMax=8)
{//returns a pwd of $iMax printable characters i.e. "alphanumerics"
	$result='';
	//Allowed: 032 - 126 /x20 - x7E
	//                 "  '  /  <  >  [  \ ]  ^  '  {    |   }
	$AnotAllowed=array(34,39,47,60,62,91,92,93,94,96,123,124,125);
	$lastUsed=0;
	while (strlen($result)<$iMax)
	{
		$x=rand(32,126);
		$y=array_search($x,$AnotAllowed);
		if ($y===FALSE)
		{
			if ($x!==$lastUsed)
			{
				$result.=chr($x);
				$lastUsed=$x;
			}
			
		}
	}
	
	return $result;
}

function rand_pwd($iMax=8)
{//returns a pwd of $iMax printable characters i.e. "alphanumerics"
	$result=randString($iMax);
	return $result;
}

function genSALT($iMax=64)
{
	$result=randString($iMax);
	return $result;
}

function createPwdFromSALT($pwd,$userSALT)
{
	//see: http://es1.php.net/manual/en/faq.passwords.php#faq.passwords.fasthash
	//I would love to implement the native password hashing as introduced in PHP 5.5
	//http://es1.php.net/manual/en/book.password.php
	//but actually most servers still have PHP 5.3 installed so we just leave it to sha1
	
	$result=sha1($pwd.$userSALT);
	$result=sha1($result.$userSALT);
	return $result;
}

function createUser($user,$pass,$uMail,$OPMode,$sendMail=TRUE)
{
global $qSQL;
global $qmdC;
//1. we make an entry in the database
//2. we create the activation link
//3. we send an activation link
	$result=-1;
	$xID=0;
	
	$xLink=createValidation();
	$userSALT=genSALT();
	$userPWD=createPwdFromSALT($pass,$userSALT);
	$sql='insert into '._PRE.'qmd_users (uname,eMail,OPMode,passwd,tmp,SALT)VALUES(?,?,?,?,?,?)';

	$r=$qSQL->qSQLdirect($sql,array(
										$user,
										$uMail,
										$OPMode,
										$userPWD,
										$xLink,
										$userSALT
										)
										,$xID);//one week
	
	
	
	if ($xID>0):
		$result=$xID;
		if ($sendMail==TRUE):
			$ip = $_POST['ip'];
				
			$send_array = array(
						'to'=>$uMail,
						'name'=>$user,
						'comment'=>'Registration Request at '._SITE,
						'mail'=>$uMail,
						'ip'=>$ip,
						'verify'=>$xLink,
						'subject'=>'Registration Request at '._SITE);
						
					//****************SEND eMail
					
			$x=send_email_reg($send_array);
			if ($x==0):
				msgbox('error sending message');
			else:
				msgbox('message has been sent');
			endif;
		endif;//sendMail
	else:
		qmd_die('internal error creating user');
	endif;
		
	return $result;								
}


//check login
function check_login()
{

global $qmdC;
global $qmd_const_URL_Params;
global $_ReloadPending;
$result=false;

if ($qmdC->get_UParamByName('action')=='logoff'):
	$_ReloadPending=1;
	dropcookies();
	echo '<meta http-equiv="refresh" content="0; url=http://'._SITE.'/">';
	
else:
	if (verifyUser()>0):	//
		$result=true;
	else:
		if(isset($_POST['Loginform'])):
			
			$result=checkregistration(0);
		else:
			if(isset($_POST['registrationform'])):
				$result=checkregistration(1);
			else:
				$act=$qmdC->get_UParamByName('activate');
				if ($act<>-1):
					if (check_activation_key($act)):
						//weiterleitung auf login

					endif;
				endif;
			endif;
		endif;
	endif;//check login
endif;
return $result;
}


function set_user_pwd($newPass,$uid)
{
	global $qSQL;
	global $qmdC;
	$result=0;
	$xID=0;
	$sql='SELECT SALT,eMail,uname,tmp from '._PRE.'qmd_users WHERE (id=?)';
	
	$res=$qSQL->qSQLdirect($sql,array($uid),$xID);
	if ((is_array($res))&&(count($res==1)))
	{
		$SALT=$res[0]['SALT'];
	}
	else
	{
		qmd_die('something went wrong on updating user - can not find user');
	}
	
	
	$userPWD=createPwdFromSALT($newPass,$SALT);
		
	if ($qSQL->prepareupdate(array('passwd'),array($userPWD),array('id='),array($uid),null)>0):
		
		$iRows=0;
		if ($qSQL->updateSQL(_PRE.'qmd_users',$iRows)>0):
			if ($uid==$qmdC->get_uid())
			{//actually we don't need to set the COOKIE new
				$cookieVal=gencookie($res[0]);
				setcookie('userdata',$cookieVal,time()+__y_CookieUserLoginLifetime,'/',puresitename(1),0,0);
			}
			$result++;
		else:
			$result--;
			msgbox('err on up');
		endif;
	else:
		$result--;
		msgbox('error update');
	endif;
	return $result;
}

function userpanel($uid=0)
{
	global $qSQL;
	global $qmdC;
	global $qmd_const_URL_Params;
	global $qmd_sefLink;
	
	$result=TRUE;
	$u=$qmdC->get_uid();
	//qmd_die('so eine Scheisse');
	$userPermission=0;	//0 not allowed 1 view userdata of another user 2 show/edit data
	$aLinkLabel=array(l('backhome'),l('backlastpage'));
	$aLinkList=array('/',$_SERVER['HTTP_REFERER']);
	
	if ($uid==0)
		$uid=$u;
	if ($uid>0)
	{
	
		if ($qmdC->get_userPermission(__USER_isUser)>0)
			$userPermission++;
	}
	if ($userPermission==0):
			
		qmd_notify(1,l('invalid_access'),$aLinkLabel,$aLinkList);
		$result=FALSE;
	else:
		if ($u==$uid)
			$userPermission++;
		echo '<div class="qmd_userpanel">';//NOTE the div is open! we should seperate design and code more strictly 
		
		if ($userPermission<2):
			echo '<h2>'.l('userpanel').'</h2>';
			echo l('public_profile');
			echo l('not_implemented');
		else:
			
			$ia=$qmdC->get_UParamByName('action');
			$it=$qmdC->get_UParamByName('task');
			if (($ia=='process')&&($_POST['task']==$it)):
				
				switch ($it):
					case 'changeup':
						if ($_POST['pass1'] === $_POST['pass2']):

							$pass1 = cleanPassWord($_POST['pass1']);

							if (empty($pass1))
								qmd_notify(2,l('wrongpwdformat'),$aLinkLabel,$aLinkList);
								
							else
							{
								if (set_user_pwd($pass1,$qmdC->get_uid())>0)
									qmd_notify(0,l('operation_completed'),$aLinkLabel,$aLinkList);
								else
								{
									qmd_notify(0,l('operation_NOT_completed'),$aLinkLabel,$aLinkList);
									send_sys_msg('Error on setting user PWD','Setting user passwd resulted in error',1);
								}
								
							}
						else:
							qmd_notify(2,l('pass_mismatch_2'),$aLinkLabel,$aLinkList);
							
						endif;
					
						break;
						
					case 'change_usr_priv':
						
						$bday=$_POST['fposting_year'].'-'.$_POST['fposting_month'].'-'.$_POST['fposting_day'];

						if ($qSQL->prepareupdate(array('name','lastname','gender','eMail','bday'),
														array($_POST['name1'],$_POST['name2'],$_POST['cmbSex'],$_POST['eMail'],$bday),
														array('id='),array($uid),null)>0)
						{
							$iRows=0;
							$res=$qSQL->updateSQL(_PRE.'qmd_users',$iRows);//			iRows will return the number of rows affected
							if ($res>0)
								qmd_notify(0,l('operation_completed'),$aLinkLabel,$aLinkList);
							else
								qmd_notify(2,'error occured on updating user',$aLinkLabel,$aLinkList,'',0,1);
						}
						else
							qmd_notify(2,'some error occured on updating user prepare',$aLinkLabel,$aLinkList,'',0,1);
						break;
					case 'change_usr_general':
						break;
					default:
						qmd_notify(2,'some error occured',$aLinkLabel,$aLinkList);
				endswitch;
					
			else:
				if (isset($_POST['submit_msgs'])):
					show_messages();
				else:
					$sql='SELECT * from '._PRE.'qmd_users WHERE (id=?)';

					$userrows=$qSQL->qSQLquick($sql,array($uid));
					
					if (is_array($userrows)&&(count($userrows)>0)):
						$user=$userrows[0];
						echo '<p><a onclick="toggle(\'sub_changeup\')" style="cursor: pointer;" title="'.l('a_openclose').''.l('change_up').'">'
									.l('change_up').'</a></p>';
						echo '<div id="sub_changeup" style="display: none;">';
						echo html_input('form','','','','','','','','','','post','/'.$qmdC->language.'/'.$qmd_const_URL_Params[6].'/?action=process%26task=changeup');
							
							
							echo '<p>'.l('login_limit').'</p>';
											
							echo html_input('password','pass1','pass1','',l('a_password'));
							echo html_input('password','pass2','pass2','',l('a_password2'));
							echo '<p>'; # Save Password Change button
							echo html_input('hidden','task','task','changeup');
							echo html_input('submit','submit_pass','submit_pass',l('save'),'','button');
							echo '</p>';//
						echo '</form>';
						echo '</div>';
						//$l['usr_private_settings']='private Einstellungen';
						//$l['usr_general_settings']='allgemeine Einstellungen';
						echo '<p><a onclick="toggle(\'sub_usr_priv\')" style="cursor: pointer;" title="'.l('a_openclose').''.l('usr_private_settings').'">'
									.l('usr_private_settings').'</a></p>';
						echo '<div id="sub_usr_priv" style="display: none;">';
						echo html_input('form','','','','','','','','','','post','/'.$qmdC->language.'/'.$qmd_const_URL_Params[6].'/?action=process%26task=change_usr_priv');
							//echo '<div class="qmd_adminpanel">';
							echo html_input('text','name1','name1',$user['name'],l('usr_firstname'));
							echo html_input('text','name2','name2',$user['lastname'],l('usr_lastname'));
							$a=array(l('usr_no_statement'),l('usr_gender_m'),l('usr_gender_f'),l('usr_gender_x'));
							echo html_input('combobox','cmbSex','cmbSex',$user['gender'],l('usr_gender'),'cmbGender','','','','','','','','',$a);
							
							
							if (is_null($user['bday']))
							{	
							
								$sCheck=1;
								
								echo posting_time(date('d-M-Y','01-01-1970'),true);
							}
							else
							{
							
								echo posting_time($user['bday'],true);
							
								$sCheck=0;
							}
							echo html_input('checkbox', 'chkbday', 'chkbday', $sCheck, l('usr_no_statement'), '', 	'', 			$sCheck);
							echo '<p>'; # Save Password Change button
							echo html_input('hidden','task','task','change_usr_priv');
							echo html_input('submit','submit_usr_priv','submit_usr_priv',l('save'),'','button');
							echo '</p>';//
						echo '</form>';
						echo '</div>';
						
						$disabled='';
						
						echo html_input('form','','','','','','','','','','post','/'.$qmdC->language.'/'.$qmd_sefLink[15]);
						
						if ($qmdC->usrMSG>0)
							echo '<img src="/dev.img/mail_in.png" alt="mail" />'.$qmdC->usrMSG.'&nbsp;&nbsp;&nbsp;';//.'<br/>';
						else
						{
							$sql='select count(id) as msgs from qmd_user_msg where user_to=?';
							
							$r=$qSQL->qSQLquick($sql,array($qmdC->get_uid()));
							
							if ($r[0]['msgs']==0)
								$disabled= 'disabled="disabled"';
							
								
						}
						echo html_input('submit','submit_msgs','submit_msgs',l('messages'),'','button', $disabled);
						echo '</form>';
						//echo '</div>';
					else:
						qmd_die('INTERNAL ERROR on Userpanel!');
					endif;
				endif;
			endif;
		endif;
		echo '</div>';//userpanel !important here we close the div )-;
	endif;
	return $result;
}
function _listmsg($msg)
{
	echo '<td>'.$msg['uname'].'</td>';
	echo '<td>'.$msg['date'].'</td>';
	echo '<td>'.$msg['subject'].'</td>';
}
function show_messages()
{
	global $qmdC;
	global $qSQL;
	//NOTe we have div userpanel open and close it afterwards
	//ok what have we got to do
	//`1.) incoming messages - unread new messages and old messsages separated
	// 2.) sent messages
	// 3.) we need an option to delete messages - not really ... according to einstein space is cheaper than time
	$sql='Select m.*,u.uname from '._PRE.'qmd_user_msg m left join '._PRE.'qmd_users u on u.id=m.user_from where user_to=? ORDER by seen ASC, date DESC';
	$msgs=$qSQL->qSQLquick($sql,array($qmdC->uid));
	
	
	//echo 'there should be msgs';
	$iCount=0;
	$seen=-1;
	echo '<table border=1><colgroup>
				<col width="40"><!-- from -->
				<col width="150"><!-- date -->
				<col width="350"><!-- subject -->
			</colgroup>';
	while ($iCount<count($msgs))
	{
		echo '<tr>';
		$msg=$msgs[$iCount];
		if ($seen==$msg['seen'])//just display list
		{
			_listmsg($msg);
		}
		else//we are processing unread messages
		{
			if ($seen<0)
			{
				$seen++;
				if ($seen < $msg['seen'])
				{
					echo '<td colspan=3>'.l('usr_no_unread').'</td>';
					echo '</tr><tr><td colspan=3>&nbsp;</td>';
					$seen++;
					echo '</tr><tr><td colspan=3>'.l('usr_read_msgs').'</td><tr>';
					_listmsg($msg);
				}
				else
				{
					echo '<td colspan=3>'.l('usr_unread_msgs').'</td></tr><tr>';
					_listmsg($msg);
				}
			}
			else
			{	$seen++;
				echo '<td colspan=3>'.l('usr_read_msgs').'</td></tr><tr>';	//
				_listmsg($msg);
			}
		}
	
		//$l['usr_read_msgs']='mensajes leidos/viejos:';
		//$l['usr_no_read_msgs']='no hay mensajes viejos';
		echo '</tr>';
		$iCount++;
	}//while
	echo '</table>';
}
function user()
{
	$result=TRUE;
	global $qmdC;
	
	$x=$qmdC->get_UParamByName('uid');
	if ($x==-1)
	{
		return userpanel($qmdC->get_uid());
	}
	else
	{	
		if ($qmdC->get_userPermission(__USER_isUser)>0)
		{
			
			return userpanel($x);
		}
		else
		{
			$aLinkLabel=array(l('backhome'),l('backlastpage'));
			
			$aLinkList=array('/',$_SERVER['HTTP_REFERER']);
			qmd_notify(1,l('invalid_access'),$aLinkLabel,$aLinkList);
			return FALSE;
		}
	}	
	return $result;
}

function checkregistration($Mode=0)//this is also the place where login takes place...
{
	global $qmdC;
	$result=FALSE;
	$userTmp = checkUserName($_POST['uname'],false);
	
	$passTmp = cleanPassWord($_POST['pass']);

	if ($userTmp!==TRUE):
		if ($_POST['Loginform']==True)
			$sMsg=l('invaliduname');
		else
			$sMsg=l('wrongunameformat');
		
		qmd_notify(4,$sMsg,	
						array(l('backhome'),l('login'),l('register'),l('backlastpage')),
						array('/','/login','/register',$_SERVER['HTTP_REFERER']),l('error'));
	else:
		
		if (empty($passTmp)):
			qmd_notify(4,l('wrongpwdformat'),array(l('backhome'),l('login'),l('backlastpage')),array('/','/login',$_SERVER['HTTP_REFERER']),l('error'));

		else:

			if (checkMathCaptcha()):

				$urec=null;
				$user=$_POST['uname'];
				if ($Mode==0):
					
					$uid=checkUserPass2($user,$_POST['pass'],$urec);
					
					if ($uid>0):
						
						$_SESSION[_SITE.'/Logged_In'] = token();

						$_SESSION[_SITE.'/LoggedUser'] = $uid;//token();
						
						setcookie('user',md5($user).'%'.$uid,time()+__y_CookieUserLoginLifetime,'/',puresitename(1),0,0);

						$cookieVal=gencookie($urec);
						setcookie('userdata',$cookieVal,time()+__y_CookieUserLoginLifetime,'/',puresitename(1),0,0);
						
						
						$qmdC->set_uid($uid,$urec['uname'],$urec['OPMode']);
						$result=TRUE;
					else:
						qmd_notify(4,l('Error_wrong_credentials_submitted'),	
								array(l('backhome'),l('login'),l('backlastpage')),
								array('/','/login',$_SERVER['HTTP_REFERER']),l('error'));
						
					endif;
				else:
					if (isset($_POST['chkAGB']))
					{
						$resMsg='';
						if (check_if_unique('username', $user, -1, $resMsg)):
							
							if ($_POST['pass2']!=$_POST['pass']):
								
								qmd_notify(4,l('pass_mismatch_2'),	
												array(l('backhome'),l('login'),l('register'),l('backlastpage')),
												array('/','/login','/register',$_SERVER['HTTP_REFERER']),l('error'));
							else:
								// the next bit of code is from 
								// http://www.sitepoint.com/users-email-address-php/
								// take a given email address and split it into the username and domain. 
								$MailOK=check_eMail($_POST['uMail']);
								if ($MailOK==true):
									if (createUser($user,$_POST['pass'],$_POST['uMail'],0)>0):
										
										qmd_notify(4,l('checkyourmail4accountactivation'),	
												array(l('backhome'),l('login'),l('backlastpage')),
												array('/','/login',$_SERVER['HTTP_REFERER']),l('operation_completed'));
										
									else:
										
										qmd_notify(4,l('Error_creating_User'),	
													array(l('backhome'),l('login'),l('register'),l('backlastpage')),
													array('/','/login','/register',$_SERVER['HTTP_REFERER']),l('error'),'',0,1);//send systemmessage
									endif;
										
								else:
									
									qmd_notify(4,l('Invalid_eMail_submitted'),	
													array(l('backhome'),l('register'),l('backlastpage')),
													array('/','/register',$_SERVER['HTTP_REFERER']),l('error'));
								endif;
									
							endif;
						else:
							qmd_notify(4,l('UserNameExists').' ' .$resMsg,	
													array(l('backhome'),l('register'),l('backlastpage')),
													array('/','/register',$_SERVER['HTTP_REFERER']),l('caution'));
							
						endif;
					}
					else
						qmd_notify(4,l('err_AGBnotAccepted'),	
												array(l('backhome'),l('register'),l('backlastpage')),
												array('/','/register',$_SERVER['HTTP_REFERER']),l('error'));
				endif;
			else:
				if ($Mode==0)
				{
					
					qmd_notify(4,l('err_LoginCaptcha'),	
										array(l('backhome'),l('login'),l('backlastpage')),
										array('/','/login',$_SERVER['HTTP_REFERER']),l('error'));
				}
				else
				{
					
					qmd_notify(4,l('err_LoginCaptcha'),	
												array(l('backhome'),l('register'),l('backlastpage')),
												array('/','/register',$_SERVER['HTTP_REFERER']),l('error'));
				}
				
				
			endif;//checkMathCaptcha
		endif;//pass ok
	endif;		
	
	unset($_POST);
	return $result;
}

?>