<?php

/*------------------------------
	Program: qmd-cms [qimanfaya-Menu-Driven-CMS]
	Module: qmd List class extension for excursions
	
	..............................................
	qmd-cms 0.8.6
	last update: 04/24/2014
	
	..............................................
	
	exc_list.php
	============
	excursions-list

	This file is part of the qmd-php-library
	
	Author: ***hy
	For further reference regarding this code see qmdcms.php and the readme-files.
	
	This code was developed by ****hy
	Copyright: qimanfaya/hy-soft 2012,2014
	
	Licence:		GPL V.3

	A copy of the GNU General Public License is available:
	in the root of this folder
	and on the World Wide Web
	at <http://www.gnu.org/licenses/gpl-3.0.txt>. You can also obtain it by writing
	to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
	MA 02111-1307, USA.
	
*/
//This is a demo object that shows lists in a functional mode
include_once('exc_globals.php');
	class excursions_list extends qmd_LIST{
		var $Mode;
		var $ATypesReal;

		function __construct($controller,$BaseRec){
			if (__y_UseExternalDB>0)
				$DB='excursions';
			else
				$DB='';
		
			parent::__construct($controller,$BaseRec,'excursiones',$DB);
			
			$this->Mode=$BaseRec['optXtra'];
			
			$sWhere=' AND Typ="'.$this->Mode.'"';
			$sWhere.=' AND ML.lang="'.$controller->language.'"';
			$this->sql_list='SELECT x.*,a.id as artid,a.seftitle,ML.title FROM `excursiones` x 
										left join ('._PRE.'qmd_articles a)on(a.id=x.parent_article)
										left join ('._PRE.'qmd_articles_ML ML)on(ML.parent=a.id)
										WHERE (1=1) '.$sWhere;
			debuglog($this->sql_list,'LIST');
			$this->URLfieldName='seftitle';//this is the field containing the ID that links to the parent article
			$this->LinkFieldName='title';//this is the field that gets the anchor
			$this->IDField='artid';

			switch ($this->_CONTROLLER->language):
				case 'de':
					include_once('de.php');
					$this->listHeader=
						"Hier finden Sie eine &Uuml;bersicht der angebotenen Touren. Durch einen Klick auf den Namen werden Details und Bilder angezeigt.";
					
					$this->ListColLabels=array('Name','Zeit','km','Diff','Technik','Ausdauer','Terrain','Preis','Ort');
					break;
				case 'en':
					include_once('en.php');
					$this->listHeader=
						"Here you find an overview of our excursions. By clicking on the names details and images are displayed.";
					$this->ListColLabels=array('Name','Time','km','Diff','Technique','Endurance','Terrain','Preis','Area');
					break;
				case 'es':
					include_once('es.php');
					$this->listHeader=
						"Aqui encuentras un resumen de nuestros ofertas. Haga cliq para ver m&aacute;s informaci&oacute;n y imagenes.";
					$this->ListColLabels=array('Nombre','Tiempo','km','Diff','Tecnico','resistencia','Terreno','precio','Lugar');
					break;
			endswitch;
			
			//Now we define the fields
			$this->ListCOLs=array('title','Zeit','km','Diff','Technik','Ausdauer','Terrain','Preis','Region');
			
			$this->arSortFields=array('title','Zeit','km');
		
			$this->_cssFile='/schemes/excursions/css/exc_list.css';
			$this->_jsFile='schemes/excursions/js/excursions.js';
			
			$this->_ArticleType=2;//this is a list
			
			$this->ItemTitlefield='title';//i2s2bt-btwostp
		}
		
		function __destruct(){
			parent::__destruct();
			
		}
		
		function getListItemCellValue($row,$key,$value)
		{	//this is in order you want to diplay only part of the data in list overview
			$result=$value;
			if ($key=='Preis')
				$result.='&euro;';
			//if (strlen($result)>40){
			//$result=substr($result,0,40).'...';
			//}
			return $result;
		}
		
		function getArticleTeaser($Mode)
		{

			$teaser=$this->listHeader;
			return $teaser;
		}
		function ArticleShow($Mode=1)//Mode=0 show teaser Mode=1 show all
		{
			
			$result=parent::ArticleShow($Mode);
			
			return $result;
		}
		
		function objectEdit(){
			global $qmdC;
			global $qSQL;
			global $qmd_const_URL_Params;
			
			
			$curLang=$qmdC->get_UParamByName('editLang');
			if ($curLang==-1):
				$curLang=$qmdC->language;
			endif;
			//$this->connect('excursions');
			$sql='select a.id,a.seftitle,ML.lang from '._PRE.'qmd_articles a 
							left join (qmd_articles_ML ML)on(ML.parent=a.id) where art_parent ='.$this->getArticleID();
			$rows=$qSQL->qSQLsimple($sql);
			
			
			
			if (is_array($rows)):
				//echo 'hello world<br/>';
				echo '<table class="exc_edit_table" width=100%>';
				echo '			<tr>';
				echo '				<td class="exc_edit_head" colspan=2>';
				echo ' <div class="exc_button">'
							.qmd_createLink('/'.$qmd_const_URL_Params[2].'?action=admin_article
												%26editLang='.$curLang
												.'%26option=create
												%26parent='.$this->ArticleRow['artid'],
												'Create NEW')
												.'</div>';
				echo '				</td>';
				echo '			</tr>';
				echo '			<tr>';
				echo '				<td class="exc_edit">';
				if (count($rows)>0)
				{
					echo ' select an item to the right in order to edit<br/>';
				}
				else
				{
					echo ' no items available yet<br/>';
				}
				
												
				echo '				</td>';
				
				echo '				<td>';
				
				echo '             <div class="exc_list_itemselect">';
				if (count($rows>0)):
					for ($i=0;$i<count($rows);$i++):
						$r=$rows[$i];
						$sTitle=$r['seftitle'];
						if (empty($sTitle))
							$sTitle='--no title-- #'.$r['id'];
						
						
						//echo '<a href="/'.$qmd_const_URL_Params[2].'?action=admin_article%26id='.$r['id'].'%26editLang='.$curLang.'%26parent='.$this->getArticleID().'">'.$r['seftitle'].'</a>'.'<br/>';
						echo '<a href="/'.$qmd_const_URL_Params[2].'?action=admin_article%26id='.$r['id'].'%26parent='.$this->getArticleID().'%26editLang='.$r['lang'].'">'.$sTitle.' - ['.$r['lang'].']</a>'.'<br/>';
					endfor;
				else:
					echo 'no data found - yet';
				endif;

				echo '             </div>';
				echo '				</td>';
				echo '			</tr>';
							
				echo '</table>';
			else:
				
				qmd_die('internal error retrieving DATA (excursion list)');
			endif;
			
		}
		function objectSave($parentID){
			$result=TRUE;
			echo 'saving!<br/>';
			return $result;
		}
		//YOU MUST OVERRIDE THIS ONE IN YOUR LIST
		public function getChildLoader()
		{	
			$result='exc_list_item.php';
			return $result;
		}
		
		function fetch_list ($getItem='')
		{
			//this will only fill $_list_rows
		global $qSQL;
			
			
			$result=parent::fetch_list($getItem);
			/*
			//yecho($this->_list_rows);
														//this is only used to import articles
			if (count($this->_list_rows)<1):
				$sWhere=' Typ="'.$this->Mode.'"';
				for ($i=0;$i<count($this->_list_rows);$i++):
					if ($i==0)
						$sWhere.=' AND ID NOT in(';
					$sWhere.=$this->_list_rows[$i]['ID'];
					if ($i<count($this->_list_rows)-1)
						$sWhere.=',';
					else
						$sWhere.=')';
				endfor;
				
				$sql='SELECT x.* from `excursiones` x 
										WHERE  '.$sWhere;
				$newData=$qSQL->qSQLsimple($sql);
				switch ($this->Mode):
					case 'MTB':
						$CAT=42;
						$default_text='MTB-Excursion';
						break;
					case 'HIKE':
						$CAT=41;
						$default_text='Hiking on Lanzarote';
						break;
					default:
						$CAT=5;
						$default_text='Excursion on Lanzarote';
				endswitch;
				if ((is_array($newData))&&(count($newData)>0)):
					for ($i=0;$i<count($newData);$i++):
						$R=$newData[$i];
						$xID=$R['ID'];
						//yecho($R);
						$seftitle=$R['sef'];
						//if ($i<2):
							$id=$this->DoCreateArticle($seftitle, 
														$this->ArticleRow['artid'],
														-1, 
												$CAT,
												'',
												-1,
												3,
												0,
												1,
												0,
												0,
												'excursions',
												'exc_list_item.php',
												'Text',
												0,
												'',
									//ML
												$default_text,
												$seftitle);
						
							$sql='Update excursiones set parent_article='.$id;
							$sql.=' WHERE ID='.$xID;
							$qSQL->qSQLsimple($sql);
						//endif;
						
						echo '<br/>'.$id.' created '.$seftitle.' '.$xID;
					endfor;
				endif;
			endif;
			*/
			return $result;
		}
		
	}//end of object
	
?>